(function() {
  var Backbone, CoreModel, invert,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __slice = [].slice;

  Backbone = require('backbone');

  invert = function(x) {
    return !x;
  };

  module.exports = CoreModel = (function(_super) {
    __extends(CoreModel, _super);

    function CoreModel() {
      return CoreModel.__super__.constructor.apply(this, arguments);
    }

    CoreModel.prototype.destroyed = false;

    CoreModel.prototype.toggle = function(key) {
      return this.swap(key, invert);
    };

    CoreModel.prototype.swap = function(key, f) {
      return this.set(key, f(this.get(key)));
    };

    CoreModel.prototype.toJSON = function() {
      if (this.destroyed) {
        return 'DESTROYED';
      } else {
        return CoreModel.__super__.toJSON.apply(this, arguments);
      }
    };

    CoreModel.prototype.destroy = function() {
      if (!this.destroyed) {
        this.stopListening();
        this.destroyed = true;
        this.trigger('destroy', this, this.collection);
        this._frozen = [];
        this.clear();
        return this.off();
      }
    };

    CoreModel.prototype._frozen = [];

    CoreModel.prototype._validate = function(attrs, opts) {
      var msg, p, _i, _len, _ref;
      _ref = this._frozen;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        p = _ref[_i];
        if (!((p in attrs) && (attrs[p] !== this.get(p)))) {
          continue;
        }
        msg = "" + p + " is frozen (trying to set it to " + attrs[p] + " - is " + (this.get(p)) + ")";
        if (opts.merge) {
          attrs[p] = this.get(p);
        } else {
          throw new Error(msg);
        }
      }
      return CoreModel.__super__._validate.apply(this, arguments);
    };

    CoreModel.prototype.freeze = function() {
      var properties;
      properties = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      this._frozen = this._frozen.concat(properties);
      return this;
    };

    return CoreModel;

  })(Backbone.Model);

}).call(this);
