(function() {
  var $, Backbone, CoreModel, CoreView, Event, Icons, IndeterminateProgressBar, Messages, Templates, getKid, helpers, kid, listenToCollection, listenToModel, listenToState, listenToThing, onChange, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __slice = [].slice;

  require('./shim');

  Backbone = require('backbone');

  _ = require('underscore');

  $ = require('jquery');

  CoreModel = require('./core-model');

  Messages = require('./messages');

  Templates = require('./templates');

  Icons = require('./icons');

  Event = require('./event');

  helpers = require('./templates/helpers');

  onChange = require('./utils/on-change');

  IndeterminateProgressBar = (Templates.template('progress-bar'))({
    doneness: 1
  });

  kid = 0;

  getKid = function() {
    return kid++;
  };

  listenToModel = function() {
    return listenToThing.call(this, 'model');
  };

  listenToState = function() {
    return listenToThing.call(this, 'state');
  };

  listenToCollection = function() {
    return listenToThing.call(this, 'collection');
  };

  listenToThing = function(thing) {
    var definitions, event, handler, _results;
    definitions = _.result(this, "" + thing + "Events");
    if (!_.size(definitions)) {
      return;
    }
    if (this[thing] == null) {
      throw new Error("Cannot listen to " + thing + " - it is null.");
    }
    _results = [];
    for (event in definitions) {
      handler = definitions[event];
      handler = _.isFunction(handler) ? handler : this[handler];
      if (handler == null) {
        throw new Error("No handler for " + thing + ":" + event);
      }
      _results.push(this.listenTo(this[thing], event, handler));
    }
    return _results;
  };

  module.exports = CoreView = (function(_super) {
    var hasAll;

    __extends(CoreView, _super);

    function CoreView() {
      return CoreView.__super__.constructor.apply(this, arguments);
    }

    CoreView.include = function(mixin) {
      return _.extend(this.prototype, mixin);
    };

    CoreView.prototype.hasOwnModel = true;

    CoreView.prototype.parameters = [];

    CoreView.prototype.optionalParameters = [];

    CoreView.prototype.parameterTypes = {};

    CoreView.prototype.initState = function() {};

    CoreView.prototype.initialize = function(opts) {
      var Model, optParams, p, params, _i, _len, _ref, _ref1, _ref2;
      if (opts == null) {
        opts = {};
      }
      this.state = opts.state;
      params = (_ref = _.result(this, 'parameters')) != null ? _ref : [];
      optParams = (_ref1 = _.result(this, 'optionalParameters')) != null ? _ref1 : [];
      _.extend(this, _.pick.apply(_, [opts].concat(__slice.call(params))));
      for (_i = 0, _len = optParams.length; _i < _len; _i++) {
        p = optParams[_i];
        if (opts[p] != null) {
          this[p] = opts[p];
        }
      }
      this.children = {};
      Model = this.Model || CoreModel;
      if ((((_ref2 = this.model) != null ? _ref2.toJSON : void 0) != null)) {
        this.hasOwnModel = false;
      }
      if (this.model == null) {
        this.model = new Model;
      }
      if (this.model.toJSON == null) {
        this.model = new Model(this.model);
      }
      if (this.state == null) {
        this.state = new CoreModel;
      }
      if (this.state.toJSON == null) {
        this.state = new CoreModel(this.state);
      }
      if (this.RERENDER_EVENT != null) {
        this.listenTo(this.model, this.RERENDER_EVENT, this.reRender);
      }
      this.on('rendering', this.preRender);
      this.on('rendered', this.postRender);
      this.assertInvariants();
      this.initState();
      listenToModel.call(this);
      listenToState.call(this);
      listenToCollection.call(this);
      this.listenTo(Icons, this.ICONS, function() {
        if (this.template) {
          return this.reRender();
        }
      });
      return this.listenTo(this.model, 'destroy', function() {
        return this.remove();
      });
    };

    CoreView.prototype.ICONS = 'change';

    CoreView.prototype.stopListeningTo = function(obj) {
      return this.stopListening(obj);
    };

    CoreView.prototype.renderRequires = [];

    CoreView.prototype.modelEvents = {};

    CoreView.prototype.stateEvents = {};

    CoreView.prototype.collectionEvents = {};

    CoreView.prototype.listenForChange = function() {
      var emitter, handler, props;
      emitter = arguments[0], handler = arguments[1], props = 3 <= arguments.length ? __slice.call(arguments, 2) : [];
      if (!(props != null ? props.length : void 0)) {
        throw new Error('No properties listed');
      }
      return this.listenTo(emitter, onChange(props), handler);
    };

    CoreView.prototype.renderError = function(resp) {
      return renderError(this.el)(resp);
    };

    CoreView.prototype.helpers = function() {
      return _.extend({
        IndeterminateProgressBar: IndeterminateProgressBar
      }, helpers);
    };

    CoreView.prototype.getBaseData = function() {
      var labels;
      helpers = _.result(this, 'helpers');
      labels = _.result(this, 'labels');
      return _.extend({
        state: this.state.toJSON(),
        Messages: Messages,
        Icons: Icons,
        labels: labels
      }, helpers);
    };

    CoreView.prototype.getData = function() {
      var _ref, _ref1;
      return _.extend(this.getBaseData(), this.model.toJSON(), {
        collection: (_ref = (_ref1 = this.collection) != null ? _ref1.toJSON() : void 0) != null ? _ref : []
      });
    };

    CoreView.prototype.reRender = function() {
      if (this.rendered && !this.removed) {
        this.render();
      }
      return this;
    };

    CoreView.prototype.postRender = function() {};

    CoreView.prototype.preRender = function() {};

    hasAll = function(model, props) {
      return _.all(props, function(p) {
        return model.has(p);
      });
    };

    CoreView.prototype.onRenderError = function(e) {
      console.error('RENDER FAILED', this, e);
      return this.state.set({
        error: e
      });
    };

    CoreView.prototype.render = function() {
      var e, evt, prerenderEvent, requiredProps;
      if (this.removed) {
        return;
      }
      requiredProps = _.result(this, 'renderRequires');
      if ((requiredProps != null ? requiredProps.length : void 0) && (!hasAll(this.model, requiredProps))) {
        evt = onChange(requiredProps);
        this.listenToOnce(this.model, evt, this.render);
        return this;
      }
      prerenderEvent = new Event(this.rendered);
      this.trigger('rendering', prerenderEvent);
      if (prerenderEvent.cancelled) {
        return this;
      }
      this.removeAllChildren();
      if (this.template != null) {
        try {
          this.$el.html(this.template(this.getData()));
        } catch (_error) {
          e = _error;
          this.onRenderError(e);
        }
      }
      this.renderChildren();
      this.trigger('rendered', this.rendered = true);
      return this;
    };

    CoreView.prototype.renderChildren = function() {};

    CoreView.prototype.renderChild = function(name, view, container, placement) {
      if (container == null) {
        container = this.el;
      }
      if (placement == null) {
        placement = 'append';
      }
      if (name == null) {
        name = getKid();
      }
      this.removeChild(name);
      this.children[name] = view;
      if (view == null) {
        return this;
      }
      switch (placement) {
        case 'append':
          view.$el.appendTo(container);
          break;
        case 'prepend':
          view.$el.prependTo(container);
          break;
        case 'at':
          view.setElement(container[0] || container);
          break;
        default:
          throw new Error("Unknown position: " + placement);
      }
      view.render();
      return this;
    };

    CoreView.prototype.renderChildAt = function(name, view, element) {
      if (element == null) {
        element = this.$(name);
      }
      return this.renderChild(name, view, element, 'at');
    };

    CoreView.prototype.removeChild = function(name) {
      var _ref;
      if ((_ref = this.children[name]) != null) {
        _ref.remove();
      }
      return delete this.children[name];
    };

    CoreView.prototype.removeAllChildren = function() {
      var child, _i, _len, _ref, _results;
      if (this.children != null) {
        _ref = _.keys(this.children);
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          child = _ref[_i];
          _results.push(this.removeChild(child));
        }
        return _results;
      }
    };

    CoreView.prototype.removed = false;

    CoreView.prototype.remove = function() {
      if (!this.removed) {
        this.stopListening();
        this.removed = true;
        this.$el.parent().trigger('childremoved', this);
        this.trigger('remove', this);
        if (this.hasOwnModel) {
          this.model.destroy();
        }
        this.removeAllChildren();
        this.off();
        CoreView.__super__.remove.apply(this, arguments);
        return this;
      }
    };

    CoreView.prototype.make = function(elemName, attrs, content) {
      var $el, el, name, value, x, _i, _len;
      el = document.createElement(elemName);
      $el = $(el);
      if (attrs != null) {
        for (name in attrs) {
          value = attrs[name];
          if (name === 'class' || name === 'className') {
            $el.addClass(value);
          } else {
            $el.attr(name, value);
          }
        }
      }
      if (content != null) {
        if (_.isArray(content)) {
          for (_i = 0, _len = content.length; _i < _len; _i++) {
            x = content[_i];
            $el.append(x);
          }
        } else {
          $el.append(content);
        }
      }
      return el;
    };

    CoreView.prototype.invariants = function() {
      return {};
    };

    CoreView.prototype.assertInvariant = function(condition, message) {
      if (!condition) {
        throw new Error(message);
      }
    };

    CoreView.prototype.assertInvariants = function() {
      var assertion, condition, message, optionalParams, p, paramTypes, params, typeAssertion, v, _i, _j, _len, _len1, _ref, _ref1, _ref2, _ref3, _ref4, _results;
      params = (_ref = _.result(this, 'parameters')) != null ? _ref : [];
      optionalParams = (_ref1 = _.result(this, 'optionalParameters')) != null ? _ref1 : [];
      paramTypes = (_ref2 = _.result(this, 'parameterTypes')) != null ? _ref2 : {};
      for (_i = 0, _len = params.length; _i < _len; _i++) {
        p = params[_i];
        v = this[p];
        this.assertInvariant(v != null, "Missing required option: " + p);
      }
      _ref3 = params.concat(optionalParams);
      for (_j = 0, _len1 = _ref3.length; _j < _len1; _j++) {
        p = _ref3[_j];
        typeAssertion = paramTypes[p];
        if (typeAssertion != null) {
          v = this[p];
          assertion = typeAssertion.test(v);
          message = typeAssertion.message(p);
          this.assertInvariant(assertion, message);
        }
      }
      _ref4 = this.invariants();
      _results = [];
      for (condition in _ref4) {
        message = _ref4[condition];
        _results.push(this.assertInvariant(_.result(this, condition), message));
      }
      return _results;
    };

    return CoreView;

  })(Backbone.View);

}).call(this);
