(function() {
  var Checkbox, CoreView, Messages, Templates,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  CoreView = require('../core-view');

  Templates = require('../templates');

  Messages = require('../messages');

  module.exports = Checkbox = (function(_super) {
    __extends(Checkbox, _super);

    function Checkbox() {
      return Checkbox.__super__.constructor.apply(this, arguments);
    }

    Checkbox.prototype["class"] = 'checkbox';

    Checkbox.prototype.template = Templates.template('checkbox');

    Checkbox.prototype.getData = function() {
      return {
        checked: this.checked(),
        label: (this.label ? Messages.getText(this.label) : null)
      };
    };

    Checkbox.prototype.initialize = function(_arg) {
      this.attr = _arg.attr, this.label = _arg.label;
      return Checkbox.__super__.initialize.apply(this, arguments);
    };

    Checkbox.prototype.checked = function() {
      return this.model.get(this.attr);
    };

    Checkbox.prototype.toggle = function(e) {
      if (e != null) {
        e.stopPropagation();
      }
      return this.model.toggle(this.attr);
    };

    Checkbox.prototype.events = function() {
      return {
        'click': 'toggle'
      };
    };

    Checkbox.prototype.modelEvents = function() {
      var evts;
      evts = {};
      evts["change:" + this.attr] = this.setCheckboxState;
      return evts;
    };

    Checkbox.prototype.setCheckboxState = function() {
      if (this.cb == null) {
        this.cb = this.$('input')[0];
      }
      return this.cb.checked = this.model.get(this.attr);
    };

    return Checkbox;

  })(CoreView);

}).call(this);
