(function() {
  var CoreView, InputWithButton, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../core-view');

  Templates = require('../templates');

  module.exports = InputWithButton = (function(_super) {
    __extends(InputWithButton, _super);

    function InputWithButton() {
      return InputWithButton.__super__.constructor.apply(this, arguments);
    }

    InputWithButton.prototype.className = 'input-group';

    InputWithButton.prototype.template = Templates.template('input-with-button');

    InputWithButton.prototype.getData = function() {
      return _.extend(this.getBaseData(), {
        value: this.model.get(this.sets),
        placeholder: this.placeholder,
        button: this.button
      });
    };

    InputWithButton.prototype.initialize = function(_arg) {
      this.placeholder = _arg.placeholder, this.button = _arg.button, this.sets = _arg.sets;
      InputWithButton.__super__.initialize.apply(this, arguments);
      return this.sets != null ? this.sets : this.sets = 'value';
    };

    InputWithButton.prototype.postRender = function() {
      return this.$el.addClass(this.className);
    };

    InputWithButton.prototype.modelEvents = function() {
      var e;
      e = {};
      e["change:" + this.sets] = this.setDomValue;
      return e;
    };

    InputWithButton.prototype.events = function() {
      return {
        'keyup input': 'setModelValue',
        'click button': 'act'
      };
    };

    InputWithButton.prototype.setModelValue = function(e) {
      return this.model.set(this.sets, e.target.value);
    };

    InputWithButton.prototype.setDomValue = function() {
      var $input, domValue, value;
      value = this.model.get(this.sets);
      $input = this.$('input');
      domValue = $input.val();
      if (domValue !== value) {
        return $input.val(value);
      }
    };

    InputWithButton.prototype.act = function() {
      return this.trigger('act', this.model.get(this.sets));
    };

    return InputWithButton;

  })(CoreView);

}).call(this);
