(function() {
  var CoreView, InputWithLabel, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../core-view');

  Templates = require('../templates');

  module.exports = InputWithLabel = (function(_super) {
    __extends(InputWithLabel, _super);

    function InputWithLabel() {
      return InputWithLabel.__super__.constructor.apply(this, arguments);
    }

    InputWithLabel.prototype.className = 'form-group';

    InputWithLabel.prototype.template = Templates.template('input-with-label');

    InputWithLabel.prototype.parameters = function() {
      return ['attr', 'placeholder', 'label'];
    };

    InputWithLabel.prototype.optionalParameters = function() {
      return ['getProblem', 'helpMessage'];
    };

    InputWithLabel.prototype.getProblem = function(value) {
      return null;
    };

    InputWithLabel.prototype.helpMessage = null;

    InputWithLabel.prototype.initialize = function() {
      InputWithLabel.__super__.initialize.apply(this, arguments);
      return this.setValidity();
    };

    InputWithLabel.prototype.setValidity = function() {
      return this.state.set({
        problem: this.getProblem(this.model.get(this.attr))
      });
    };

    InputWithLabel.prototype.getData = function() {
      return _.extend(this.getBaseData(), {
        value: this.model.get(this.attr),
        label: this.label,
        placeholder: this.placeholder,
        helpMessage: this.helpMessage,
        hasProblem: this.state.get('problem')
      });
    };

    InputWithLabel.prototype.postRender = function() {
      this.$el.addClass(this.className);
      return this.onChangeValidity();
    };

    InputWithLabel.prototype.events = function() {
      return {
        'keyup input': 'setModelValue'
      };
    };

    InputWithLabel.prototype.stateEvents = function() {
      return {
        'change:problem': this.onChangeValidity
      };
    };

    InputWithLabel.prototype.modelEvents = function() {
      var e;
      e = {};
      e["change:" + this.attr] = this.onChangeValue;
      return e;
    };

    InputWithLabel.prototype.onChangeValue = function() {
      this.setValidity();
      return this.setDOMValue();
    };

    InputWithLabel.prototype.onChangeValidity = function() {
      var help, problem;
      problem = this.state.get('problem');
      help = this.$('.help-block');
      if (problem) {
        this.$el.toggleClass('has-warning', problem.level === 'warning');
        this.$el.toggleClass('has-error', problem.level !== 'warning');
        if (problem.message != null) {
          help.text(Messages.getText(problem.message));
        }
        return help.slideDown();
      } else {
        this.$el.removeClass('has-warning has-error');
        return help.slideUp();
      }
    };

    InputWithLabel.prototype.setModelValue = function(e) {
      return this.model.set(this.attr, this.$(e.target).val());
    };

    InputWithLabel.prototype.setDOMValue = function() {
      var $input, domValue, modelValue;
      $input = this.$('input');
      domValue = $input.val();
      modelValue = this.model.get(this.attr);
      if (modelValue !== domValue) {
        return $input.val(modelValue);
      }
    };

    return InputWithLabel;

  })(CoreView);

}).call(this);
