(function() {
  var InputWithLabel, SelectWithLabel, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  Templates = require('../templates');

  InputWithLabel = require('./input-with-label');

  module.exports = SelectWithLabel = (function(_super) {
    __extends(SelectWithLabel, _super);

    function SelectWithLabel() {
      return SelectWithLabel.__super__.constructor.apply(this, arguments);
    }

    SelectWithLabel.prototype.parameters = function() {
      return ['model', 'collection', 'attr', 'label', 'optionLabel'];
    };

    SelectWithLabel.prototype.optionalParameters = function() {
      return ['noOptionsMessage'].concat(SelectWithLabel.__super__.optionalParameters.apply(this, arguments));
    };

    SelectWithLabel.prototype.template = Templates.template('select-with-label');

    SelectWithLabel.prototype.noOptionsMessage = 'core.NoOptions';

    SelectWithLabel.prototype.events = function() {
      return {
        'change select': 'setModelValue'
      };
    };

    SelectWithLabel.prototype.collectionEvents = function() {
      return {
        'add remove reset change': this.reRender
      };
    };

    SelectWithLabel.prototype.getData = function() {
      var currentlySelected;
      currentlySelected = this.model.get(this.attr);
      return _.extend(this.getBaseData(), {
        label: this.label,
        model: this.model.toJSON(),
        selected: function(list) {
          return list.name === currentlySelected;
        },
        options: this.collection.toJSON(),
        optionLabel: this.optionLabel,
        helpMessage: this.helpMessage,
        noOptionsMessage: this.noOptionsMessage,
        hasProblem: this.state.get('problem')
      });
    };

    return SelectWithLabel;

  })(InputWithLabel);

}).call(this);
