(function() {
  define('formatters/bio/core/chromosome-location', function() {
    var ChrLocFormatter, fetch;
    fetch = function(service, id) {
      return service.rows({
        from: 'Location',
        select: ChrLocFormatter.replaces,
        where: {
          id: id
        }
      });
    };
    return ChrLocFormatter = (function() {
      ChrLocFormatter.replaces = ['locatedOn.primaryIdentifier', 'start', 'end'];

      ChrLocFormatter.merge = function(location, chromosome) {
        if (chromosome.has('primaryIdentifier')) {
          return location.set({
            chr: chromosome.get('primaryIdentifier')
          });
        }
      };

      function ChrLocFormatter(imobject) {
        var chr, end, id, needs, start, _ref;
        id = imobject.get('id');
        this.$el.addClass('chromosome-location');
        needs = ['start', 'end', 'chr'];
        if (!((imobject.__fetching != null) || _.all(needs, function(n) {
          return imobject.has(n);
        }))) {
          imobject.__fetching = fetch(this.model.get('query').service, id);
          imobject.__fetching.then(function(_arg) {
            var chr, end, start, _ref;
            _ref = _arg[0], chr = _ref[0], start = _ref[1], end = _ref[2];
            return imobject.set({
              chr: chr,
              start: start,
              end: end
            });
          });
        }
        _ref = imobject.toJSON(), start = _ref.start, end = _ref.end, chr = _ref.chr;
        return "" + chr + ":" + start + "-" + end;
      }

      return ChrLocFormatter;

    })();
  });

}).call(this);
