(function() {
  define('formatters/bio/core/organism', function() {
    var Organism, ensureData, getData, templ;
    getData = function(model, prop, backupProp) {
      var ret, val;
      ret = {};
      val = ret[prop] = model.get(prop);
      if (val == null) {
        ret[prop] = model.get(backupProp);
      }
      return ret;
    };
    ensureData = function(model, service) {
      var p;
      if ((model._fetching != null) || model.has('shortName')) {
        return;
      }
      model._fetching = p = service.findById('Organism', model.get('id'));
      return p.done(function(org) {
        return model.set({
          shortName: org.shortName
        });
      });
    };
    templ = _.template("<span class=\"name\"><%- shortName %></span>");
    return Organism = function(model) {
      var data;
      this.$el.addClass('organism');
      ensureData(model, this.model.get('query').service);
      if (model.get('id')) {
        data = getData(model, 'shortName', 'name');
        return templ(data);
      } else {
        return "<span class=\"null-value\">&nbsp;</span>";
      }
    };
  });

}).call(this);
