(function() {
  (function() {
    var SVG, supportsSVG;
    SVG = "http://www.w3.org/TR/SVG11/feature#Shape";
    supportsSVG = function() {
      var _ref;
      return (typeof SVGAngle !== "undefined" && SVGAngle !== null) || (window.SVGAngle != null) || ((_ref = document.implementation) != null ? typeof _ref.hasFeature === "function" ? _ref.hasFeature(SVG, "1.0") : void 0 : void 0);
    };

    /*
     * Add a 'destroyed' event on element removal.
     */
    jQuery.event.special.destroyed = {
      remove: function(o) {
        if (o.type !== 'destroyed') {
          return typeof o.handler === "function" ? o.handler() : void 0;
        }
      }
    };

    /*
    *
    * A bridge between iPad and iPhone touch events and jquery draggable, 
    * sortable etc. mouse interactions.
    * @author Oleg Slobodskoi  
    * 
    * modified by John Hardy to use with any touch device
    * fixed breakage caused by jquery.ui so that mouseHandled internal flag is reset 
    * before each touchStart event
    *
     */
    (function($) {
      var proto, _mouseInit;
      $.support.touch = typeof Touch === 'object';
      if (!$.support.touch) {
        return false;
      }
      proto = $.ui.mouse.prototype;
      _mouseInit = proto._mouseInit;
      return $.extend(proto, {
        _mouseInit: function() {
          this.element.bind("touchstart." + this.widgetName, $.proxy(this, "_touchStart"));
          return _mouseInit.apply(this, arguments);
        },
        _touchStart: function(event) {
          if (event.originalEvent.targetTouches.length !== 1) {
            return false;
          }
          this.element.bind("touchmove." + this.widgetName, $.proxy(this, "_touchMove")).bind("touchend." + this.widgetName, $.proxy(this, "_touchEnd"));
          this._modifyEvent(event);
          $(document).trigger($.Event("mouseup"));
          this._mouseDown(event);
          return false;
        },
        _touchMove: function(event) {
          this._modifyEvent(event);
          return this._mouseMove(event);
        },
        _touchEnd: function(event) {
          this.element.unbind("touchmove." + this.widgetName).unbind("touchend." + this.widgetName);
          return this._mouseUp(event);
        },
        _modifyEvent: function(event) {
          var target;
          event.which = 1;
          target = event.originalEvent.targetTouches[0];
          event.pageX = target.clientX;
          return event.pageY = target.clientY;
        }
      });
    })(jQuery);
    return jQuery.fn.imWidget = function(arg0, arg1) {
      var cls, error, events, options, properties, query, service, token, type, url, view;
      if (typeof arg0 === 'string') {
        view = this.data('widget');
        if (arg0 === 'option') {
          switch (arg1) {
            case 'query':
              return view.query;
            case 'service':
              return view.service;
            case 'events':
              return view.queryEvents;
            case 'type':
              return this.data('widget-type');
            case 'properties':
              return this.data('widget-options');
            default:
              throw new Error("Unknown option " + arg1);
          }
        } else if (arg0 === 'table') {
          return view;
        } else {
          throw new Error("Unknown method " + arg0);
        }
      } else {
        type = arg0.type, service = arg0.service, url = arg0.url, token = arg0.token, query = arg0.query, events = arg0.events, properties = arg0.properties, error = arg0.error, options = arg0.options;
        if (supportsSVG() && (typeof d3 === "undefined" || d3 === null)) {
          intermine.cdn.load('d3');
        }
        intermine.setOptions({
          Style: intermine.options.Style
        });
        if (service == null) {
          service = new intermine.Service({
            root: url,
            token: token
          });
        }
        if (error != null) {
          service.errorHandler = error;
        }
        cls = type === 'table' ? intermine.query.results.CompactView : type === 'dashboard' ? intermine.query.results.DashBoard : type === 'minimal' ? intermine.query.results.Toolless : void 0;
        if (!cls) {
          console.error("" + type + " widgets are not supported");
          return false;
        }
        if (this.width() < jQuery('body').width() * 0.6) {
          this.addClass('im-half');
        }
        if (options != null) {
          intermine.setOptions(options);
        }
        view = new cls(service, query, events, properties);
        this.empty().append(view.el);
        view.render();
        this.data('widget-options', properties);
        this.data('widget-type', type);
        this.data('widget', view);
        return this.data('widget');
      }
    };
  })();

}).call(this);
