(function() {
  var Backbone, DEFAULTS, HELPERS, Messages, actionMessages, common, numToString, pluralise, _, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Backbone = require('backbone');

  _ = require('underscore');

  actionMessages = require('./messages/actions');

  common = require('./messages/common');

  _ref = require('./templates/helpers'), numToString = _ref.numToString, pluralise = _ref.pluralise;

  DEFAULTS = [common, actionMessages];

  HELPERS = {
    formatNumber: numToString,
    pluralise: pluralise
  };

  Messages = (function(_super) {
    __extends(Messages, _super);

    function Messages() {
      this.getText = __bind(this.getText, this);
      return Messages.__super__.constructor.apply(this, arguments);
    }

    Messages.prototype.initialize = function() {
      this.cache = {};
      return this.on('change', (function(_this) {
        return function() {
          return _this.cache = {};
        };
      })(this));
    };

    Messages.prototype.destroy = function() {
      var prop, _results;
      this.off();
      _results = [];
      for (prop in this) {
        _results.push(delete this[prop]);
      }
      return _results;
    };

    Messages.prototype.getTemplate = function(key) {
      var templ, _ref1;
      templ = (_ref1 = this.cache[key]) != null ? _ref1 : this.get(key);
      if ((templ != null) && (templ.call == null)) {
        templ = _.template(templ);
      }
      return this.cache[key] = templ;
    };

    Messages.prototype.getText = function(key, args) {
      var templ, _ref1;
      if (args == null) {
        args = {};
      }
      templ = this.getTemplate(key);
      return (_ref1 = typeof templ === "function" ? templ(_.extend({
        Messages: this
      }, HELPERS, args)) : void 0) != null ? _ref1 : "!!!No message for " + key + "!!!";
    };

    Messages.prototype.setWithPrefix = function(prefix, messages) {
      var key, val, _results;
      _results = [];
      for (key in messages) {
        val = messages[key];
        _results.push(this.set("" + prefix + "." + key, val));
      }
      return _results;
    };

    Messages.prototype.defaults = function() {
      return _.extend.apply(null, [{}].concat(DEFAULTS));
    };

    return Messages;

  })(Backbone.Model);

  module.exports = new Messages;

  module.exports.Messages = Messages;

}).call(this);
