(function() {
  var Messages;

  Messages = require('../messages');

  Messages.setWithPrefix('codegen', {
    AsHTML: "As HTML page",
    DialogueTitle: "Generated <%= Messages.getText(\"codegen.Lang\", {lang: lang}) %>\nCode for <%= query.name || \"Query\" %>",
    CannotExportXML: "You cannot save the XML as a file directly. Please use your browser's cut\nand paste functionality.",
    PrimaryAction: 'Save',
    ChooseLang: 'Choose Language',
    ShowBoilerPlate: 'Show comments',
    HighlightSyntax: 'Highlight Syntax',
    GenerateCodeIn: function(_arg) {
      var lang;
      lang = _arg.lang;
      return "Generate " + (Messages.getText('codegen.Lang', {
        lang: lang
      })) + "\n" + (lang !== 'xml' ? 'code' : '');
    },
    Lang: function(_arg) {
      var lang;
      lang = _arg.lang;
      switch (lang) {
        case 'py':
          return 'Python';
        case 'pl':
          return 'Perl';
        case 'java':
          return 'Java';
        case 'rb':
          return 'Ruby';
        case 'js':
          return 'JavaScript';
        case 'xml':
          return 'XML';
        default:
          throw new Error("Unknown language " + lang);
      }
    }
  });

}).call(this);
