(function() {
  var Messages;

  Messages = require('../messages');

  Messages.setWithPrefix('lists', {
    DefaultName: '<%= typeName %> List (<%= new Date() %>)',
    Create: 'Create List',
    Append: 'Add to List',
    SaveAsList: 'Save as List',
    CreateListTitle: "Create a new List\n<% if (state.count) { %>\n  of <%= formatNumber(state.count) %>\n  <%= pluralise(state.typeName, (state.count || 0)) %>\n<% } %>",
    AppendToListTitle: "Add\n<% if (state.count) { %>\n  <%= formatNumber(state.count) %>\n  <%= pluralise(state.typeName, (state.count || 0)) %>\n<% } %>\nto\n<%= target || 'a List' %>",
    NoTags: 'No tags',
    AddTag: 'Add a new tag',
    AddTagBtn: 'add',
    RemoveTag: 'Remove this tag',
    ShowExtraOptions: "<% if (minimised) { %>Show <% } %>Optional attributes",
    TargetDoesNotExist: "Your target list does not exist.",
    NoTargetSelected: 'Please select a target list.',
    PossibleAppendTarget: "<%= name %> (<%= formatNumber(size) %> <%= pluralise((typeName || 'item'), size) %>)",
    NoObjectsSelected: "No objects selected. Choose objects from the table beneath. You can\ndrag this dialog around if it is in the way.",
    StartPicking: 'Pick items from the table',
    NoCommonType: 'There is no common type for these objects.'
  });

  Messages.setWithPrefix('lists.error', {
    MustBeLoggedIn: "You are not logged in. Anonymous users cannot create lists."
  });

  Messages.setWithPrefix('lists.params', {
    Name: 'List Name',
    NamePlaceholder: 'List name is required',
    Desc: 'List Description',
    DescPlaceholder: 'Enter a description',
    Target: 'Choose list to append items to'
  });

  Messages.setWithPrefix('lists.params.help', {
    Name: 'You must provide a unique list name',
    Target: 'You must select a target list'
  });

  Messages.setWithPrefix('lists.picker', {
    Expand: 'show more options',
    Collapse: 'show fewer options'
  });

  Messages.setWithPrefix('lists.append', {
    NoSuitableLists: "No suitable lists were found\n<% if (model.type) { %>\n  for <%- model.type %>.\n<% } else { %>\n  because no items are selected, or they have no common type.\n<% } %>"
  });

}).call(this);
