(function() {
  var Messages;

  Messages = require('../messages');

  Messages.setWithPrefix('summary', {
    Got: '<% if (available > got) { %>Showing <%= formatNumber(got) %> of<% } %>',
    Max: 'Maximum',
    Min: 'Minimum',
    Bucket: "<%= range.min %> to <%= range.max %>: <%= count %> values",
    Count: 'Count',
    Item: 'Item',
    Average: 'Average',
    StdDev: 'Standard Deviation',
    OnlyOne: "There is only one <%- names.typeName %> <%- names.endName %>:\n<strong><%- item.item %></strong>, which occurs\n<strong>\n  <% if (item.count === 1) { %>\n    once\n  <% } else if (item.count === 2) { %>\n    twice\n  <% } else { %>\n    <%- formatNumber(item.count) %> times\n  <% } %>\n</strong>",
    NumericDistribution: 'Showing distribution of <%= formatNumber(n) %>',
    FilterValuesPlaceholder: 'Filter values',
    DownloadData: 'Download data',
    DownloadFormat: 'As',
    MoreItems: 'Load more items',
    Include: 'Restrict table to matching rows',
    Exclude: 'Exclude matching rows from table',
    Reset: 'Reset selection',
    Toggle: 'Toggle selection',
    SelectFilter: 'Select filter type',
    FacetBar: 'rgba(206, 210, 222, <%= opacity %>)',
    NoResults: 'No results for <%= path %>',
    SelectedCount: "<%= isApprox ? \"ca. \" : void 0 %><%= formatNumber(selectedCount) %>\n<%= pluralise('Item', selectedCount) %> Selected",
    Total: "<% if (filtered) { %>(filtered from <%= formatNumber(total) %>)<% } %>"
  });

}).call(this);
