(function() {
  var Messages;

  Messages = require('../messages');

  Messages.setWithPrefix('table', {
    Building: 'Loading Table ...',
    OverlayText: 'Requesting data...',
    Empty: 'No Results',
    EmptyWhy: 'This query returns no results. You may wish to change its filters'
  });

  Messages.setWithPrefix('table.lg', {
    ShowingAll: 'Showing all <%= formatNumber(count) %> rows',
    ShowingRange: "Showing <%= formatNumber(first) %> to <%= formatNumber(last) %>\nof <%= formatNumber(count) %> <%= pluralise(\"row\", count) %>"
  });

  Messages.setWithPrefix('table.md', {
    ShowingAll: 'All <%= formatNumber(count) %> rows',
    ShowingRange: "Showing rows <%= formatNumber(first) %> to <%= formatNumber(last) %>\nof <%= formatNumber(count) %>"
  });

  Messages.setWithPrefix('table.sm', {
    ShowingAll: 'All rows',
    ShowingRange: "Rows <%= formatNumber(first) %> to <%= formatNumber(last) %>\nof <%= formatNumber(count) %>"
  });

  Messages.setWithPrefix('table.xs', {
    ShowingAll: 'All rows',
    ShowingRange: "<%= formatNumber(first) %> to <%= formatNumber(last) %>\nof <%= formatNumber(count) %>"
  });

  Messages.setWithPrefix('table.header', {
    FailedToInitSortMenu: 'Could not initialise the sorting menu.',
    FailedToInitFilter: 'Could not initialise the filter menu.',
    FailedToInitSummary: 'Could not intitialise the column summary.',
    ViewSummary: 'View column summary',
    ToggleColumn: 'Toggle column visibility',
    RemoveColumn: 'Remove this column',
    SortColumn: "<% if (dir === 'ASC') { %>\n  Sorted in ascending order.\n<% } else if (dir === 'DESC') { %>\n  Sorted in descending order.\n<% } else { %>\n  Sort this column.\n<% } %>",
    ToggleTables: 'Expand/collapse all sub-tables',
    Composed: "This column replaces <%= replaces.length %> others. Click here\nto show the individual columns separately.",
    FilterTitle: "<% if (count > 0) { %>\n  <%= count %> active filters.\n<% } else { %>\n  Filter by values in this column.\n<% } %>"
  });

}).call(this);
