(function() {
  var Messages;

  Messages = require('../messages');

  Messages.setWithPrefix('undo', {
    StepTitle: "<% if (label === 'Initial') { %>\n  Initial State\n<% } else if (verb === 'Added') { %>\n  <% if (label === 'sort order element') { %>\n    Added <%= formatNumber(number) %> <%= pluralise('column', number) %> to the sort order\n  <% } else if (label === 'column') { %>\n    Selected <%= formatNumber(number) %> <%= pluralise('column', number) %>\n  <% } else { %>\n    Added <%= formatNumber(number) %> <%= pluralise(label, number) %>\n  <% } %>\n<% } else if (verb === 'Removed') { %>\n  <% if (label === 'sort order element') { %>\n    Removed <%= formatNumber(number) %> <%= pluralise('column', number) %> from the sort order\n  <% } else if (label === 'column') { %>\n    Unselected <%= formatNumber(number) %> <%= pluralise('column', number) %>\n  <% } else { %>\n    Removed <%= formatNumber(number) %> <%= pluralise(label, number) %>\n  <% } %>\n<% } else if (verb === 'Changed') { %>\n  <% if (label === 'sort order element') { %>\n    Changed sort order\n  <% } else { %>\n    Changed <%= pluralise(label, 2) %>\n  <% } %>\n<% } else if (verb === 'Rearranged') { %>\n  Rearranged <%= pluralise(label, 2) %>\n<% } else { %>\n  !!!Cannot handle <%= verb %> <%= label %>!!!\n<% } %>",
    StepCount: "<%= formatNumber(count) %> <%= pluralise(\"row\", count) %>",
    RevertToState: 'Revert to this state',
    IsCurrentState: 'This is the current state',
    ViewCount: '<%= n %> <%= pluralise("column", n) %> selected',
    ConstraintCount: "<% if (n) { %>\n  <%= n %> <%= pluralise('filter', n) %>\n<% } else { %>\n  No filters\n<% } %>",
    OrderElemCount: "<% if (n) { %>\n  Sorted on <%= n %> <%= pluralise('column', n) %>\n<% } else { %>\n  Not sorted\n<% } %>",
    ShowAllStates: "Show <%= n %> hidden <%= pluralise('state', n) %>",
    ToggleTrivial: '<%= hideTrivial ? "Hiding" : "Hide" %> minor steps',
    ToggleTrivialTitle: '<%= hideTrivial ? "Hiding" : "Hide" %> steps that did not change the row count',
    Revision: 'no. <%= v %>',
    RevisionTitle: 'revision <%= v %>',
    MoreSteps: '<%= more %> more <%= pluralise("step", more) %>'
  });

}).call(this);
