(function() {
  var _;

  _ = require('underscore');

  exports.initTypeaheads = function() {
    return this._typeaheads != null ? this._typeaheads : this._typeaheads = [];
  };

  exports.removeTypeAheads = function() {
    var ta, _results;
    if (this._typeaheads == null) {
      return;
    }
    _results = [];
    while ((ta = this._typeaheads.shift())) {
      ta.off('typeahead:select');
      ta.off('typeahead:selected');
      ta.off('typeahead:autocompleted');
      ta.off('typeahead:close');
      _results.push(ta.typeahead('destroy'));
    }
    return _results;
  };

  exports.lastTypeahead = function() {
    var _ref;
    return _.last((_ref = this._typeaheads) != null ? _ref : []);
  };

  exports.activateTypeahead = function(input, opts, data, placeholder, cb, onChange) {
    input.attr({
      placeholder: placeholder
    }).typeahead(opts, data);
    input.on('typeahead:selected', cb);
    input.on('typeahead:select', cb);
    input.on('typeahead:autocompleted', cb);
    if (onChange != null) {
      input.on('typeahead:close', onChange);
    }
    this.initTypeaheads().push(input);
    input.focus();
    return this;
  };

}).call(this);
