(function() {
  var AvailableColumns, Collection, PathModel, cmp, displayName, partsLen,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Collection = require('../core/collection');

  PathModel = require('./path');

  cmp = function(f, a, b) {
    var fa, fb, x, _ref;
    _ref = (function() {
      var _i, _len, _ref, _results;
      _ref = [a, b];
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        x = _ref[_i];
        _results.push(f(x));
      }
      return _results;
    })(), fa = _ref[0], fb = _ref[1];
    if (fa < fb) {
      return -1;
    } else if (fa > fb) {
      return 1;
    } else {
      return 0;
    }
  };

  partsLen = function(m) {
    return m.get('parts').length;
  };

  displayName = function(m) {
    return m.get('displayName');
  };

  module.exports = AvailableColumns = (function(_super) {
    __extends(AvailableColumns, _super);

    function AvailableColumns() {
      return AvailableColumns.__super__.constructor.apply(this, arguments);
    }

    AvailableColumns.prototype.model = PathModel;

    AvailableColumns.prototype.initialize = function() {
      AvailableColumns.__super__.initialize.apply(this, arguments);
      return this.on('change:parts change:displayName', (function(_this) {
        return function() {
          return _this.sort();
        };
      })(this));
    };

    AvailableColumns.prototype.comparator = function(a, b) {
      return (cmp(partsLen, a, b)) || (cmp(displayName, a, b));
    };

    return AvailableColumns;

  })(Collection);

}).call(this);
