(function() {
  var CellModel, CoreModel, DELIM, Options, Promise, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  Promise = require('es6-promise').Promise;

  Options = require('../options');

  CoreModel = require('../core-model');

  DELIM = 'DynamicObjects.NameDelimiter';

  module.exports = CellModel = (function(_super) {
    __extends(CellModel, _super);

    function CellModel() {
      return CellModel.__super__.constructor.apply(this, arguments);
    }

    CellModel.prototype.defaults = function() {
      return {
        columnName: null,
        typeName: null,
        typeNames: [],
        entity: null,
        column: null,
        node: null,
        field: null,
        value: null
      };
    };

    CellModel.prototype.initialize = function() {
      var column, model, nameRequests, t, types, _ref;
      CellModel.__super__.initialize.apply(this, arguments);
      types = (_ref = this.get('entity').get('classes')) != null ? _ref : [this.get('node')];
      model = (column = this.get('column')).model;
      column.getDisplayName().then((function(_this) {
        return function(columnName) {
          return _this.set({
            columnName: columnName
          });
        };
      })(this));
      nameRequests = (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = types.length; _i < _len; _i++) {
          t = types[_i];
          _results.push(model.makePath(t).getDisplayName());
        }
        return _results;
      })();
      return Promise.all(nameRequests).then((function(_this) {
        return function(names) {
          return _this.set({
            typeNames: names,
            typeName: names.join(Options.get(DELIM))
          });
        };
      })(this));
    };

    CellModel.prototype.getPath = function() {
      return this.get('column');
    };

    CellModel.prototype.toJSON = function() {
      return _.extend(CellModel.__super__.toJSON.apply(this, arguments), {
        column: this.get('column').toString(),
        node: this.get('node').toString(),
        entity: this.get('entity').toJSON()
      });
    };

    return CellModel;

  })(CoreModel);

}).call(this);
