(function() {
  var ConstraintModel, LIST_OPS, LOOP_OPS, PathModel, RANGE_OPS, TERNARY_OPS, constraintType, _, _ref,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  _ref = require('imjs').Query, LIST_OPS = _ref.LIST_OPS, LOOP_OPS = _ref.LOOP_OPS, TERNARY_OPS = _ref.TERNARY_OPS, RANGE_OPS = _ref.RANGE_OPS;

  PathModel = require('./path');

  constraintType = function(opts) {
    var _ref1, _ref2, _ref3, _ref4;
    if (opts.path.isAttribute()) {
      if (opts.values) {
        return 'MULTI_VALUE';
      }
      return 'ATTR_VALUE';
    } else {
      if (opts.type) {
        return 'TYPE';
      }
      if (opts.ids) {
        return 'IDS';
      }
      if (opts.values && (_ref1 = opts.op, __indexOf.call(RANGE_OPS, _ref1) >= 0)) {
        return 'RANGE';
      }
      if ((_ref2 = opts.op, __indexOf.call(TERNARY_OPS, _ref2) >= 0)) {
        return 'LOOKUP';
      }
      if ((_ref3 = opts.op, __indexOf.call(LIST_OPS, _ref3) >= 0)) {
        return 'LIST';
      }
      if ((_ref4 = opts.op, __indexOf.call(LOOP_OPS, _ref4) >= 0)) {
        return 'LOOP';
      }
    }
    throw new Error("Cannot determine constraint type: " + opts.path + " " + opts.op);
  };

  module.exports = ConstraintModel = (function(_super) {
    __extends(ConstraintModel, _super);

    ConstraintModel.prototype.defaults = function() {
      return _.extend(ConstraintModel.__super__.defaults.apply(this, arguments), {
        value: null,
        values: [],
        ids: [],
        extraValue: null,
        code: null,
        CONSTRAINT_TYPE: 'ATTR_VALUE'
      });
    };

    function ConstraintModel(opts) {
      var type;
      ConstraintModel.__super__.constructor.call(this, opts.path);
      type = opts.type;
      this.unset('id');
      this.unset('type');
      this.set(_.omit(opts, 'path', 'type'));
      if (type != null) {
        this.set({
          type: type.toString()
        });
        type.getDisplayName().then((function(_this) {
          return function(name) {
            return _this.set({
              typeName: name
            });
          };
        })(this));
      }
      this.set({
        CONSTRAINT_TYPE: constraintType(opts)
      });
    }

    return ConstraintModel;

  })(PathModel);

}).call(this);
