(function() {
  var CoreCollection, CoreModel, CreateListModel, ON_COMMA, trim, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreModel = require('../core-model');

  CoreCollection = require('../core/collection');

  ON_COMMA = /,\s*/;

  trim = function(s) {
    return s.replace(/(^\s+|\s+$)/g, '');
  };

  module.exports = CreateListModel = (function(_super) {
    __extends(CreateListModel, _super);

    function CreateListModel() {
      return CreateListModel.__super__.constructor.apply(this, arguments);
    }

    CreateListModel.prototype.defaults = function() {
      return {
        name: null,
        description: null
      };
    };

    CreateListModel.prototype.initialize = function() {
      var tag;
      this.tags = new CoreCollection;
      if (this.has('tags')) {
        this.tags.reset((function() {
          var _i, _len, _ref, _results;
          _ref = this.get('tags');
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            tag = _ref[_i];
            _results.push({
              id: tag
            });
          }
          return _results;
        }).call(this));
      }
      this.listenTo(this.tags, 'remove', (function(_this) {
        return function(t) {
          _this.trigger('remove:tag', t);
          return _this.trigger('change');
        };
      })(this));
      return this.listenTo(this.tags, 'add', (function(_this) {
        return function(t) {
          _this.trigger('add:tag', t);
          return _this.trigger('change');
        };
      })(this));
    };

    CreateListModel.prototype.toJSON = function() {
      return _.extend(CreateListModel.__super__.toJSON.apply(this, arguments), {
        tags: this.tags.map(function(t) {
          return t.get('id');
        })
      });
    };

    CreateListModel.prototype.addTag = function() {
      var tag, tags, _i, _len, _ref, _results;
      tags = this.get('nextTag');
      if (tags == null) {
        throw new Error('No tag to add');
      }
      this.unset('nextTag');
      _ref = trim(tags).split(ON_COMMA);
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        tag = _ref[_i];
        _results.push(this.tags.add({
          id: tag
        }));
      }
      return _results;
    };

    CreateListModel.prototype.destroy = function() {
      var _ref;
      if ((_ref = this.tags) != null) {
        _ref.close();
      }
      return CreateListModel.__super__.destroy.apply(this, arguments);
    };

    return CreateListModel;

  })(CoreModel);

}).call(this);
