(function() {
  var Collection, Join, Joins, PathModel, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  Collection = require('../core/collection');

  PathModel = require('./path');

  Join = (function(_super) {
    __extends(Join, _super);

    Join.prototype.defaults = function() {
      return _.extend(Join.__super__.defaults.apply(this, arguments), {
        style: 'INNER'
      });
    };

    function Join(_arg) {
      var path, style;
      path = _arg.path, style = _arg.style;
      Join.__super__.constructor.call(this, path);
      if (style != null) {
        this.set({
          style: style
        });
      }
    }

    return Join;

  })(PathModel);

  module.exports = Joins = (function(_super) {
    __extends(Joins, _super);

    function Joins() {
      return Joins.__super__.constructor.apply(this, arguments);
    }

    Joins.prototype.model = Join;

    Joins.prototype.comparator = 'displayName';

    Joins.prototype.initialize = function() {
      Joins.__super__.initialize.apply(this, arguments);
      return this.listenTo(this, 'change:displayName', this.sort);
    };

    Joins.prototype.getJoins = function() {
      return _.object(this.where({
        style: 'OUTER'
      }).map(function(m) {
        return [m.get('path'), m.get('style')];
      }));
    };

    return Joins;

  })(Collection);

  Joins.fromQuery = function(query) {
    var joins, n, p, path, style, _i, _len, _ref, _ref1;
    joins = new Joins;
    _ref = query.joins;
    for (p in _ref) {
      style = _ref[p];
      path = query.makePath(p);
      joins.add(new Join({
        style: style,
        path: path
      }));
    }
    _ref1 = query.getQueryNodes();
    for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
      n = _ref1[_i];
      while (!n.isRoot()) {
        joins.add(new Join({
          path: n
        }));
        n = n.getParent();
      }
    }
    return joins;
  };

}).call(this);
