(function() {
  var CoreModel, NestedTableModel, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreModel = require('../core-model');

  module.exports = NestedTableModel = (function(_super) {
    __extends(NestedTableModel, _super);

    function NestedTableModel() {
      return NestedTableModel.__super__.constructor.apply(this, arguments);
    }

    NestedTableModel.prototype.defaults = function() {
      return {
        columnName: null,
        columnTypeName: null,
        columnName: null,
        typeName: null,
        column: null,
        node: null,
        fieldName: null,
        contentName: null,
        view: [],
        rows: []
      };
    };

    NestedTableModel.prototype.initialize = function() {
      this.onChangeColumn();
      return this.listenTo(this, 'change:column', this.onChangeColumn);
    };

    NestedTableModel.prototype.onChangeColumn = function() {
      var column, node, views;
      column = this.get('column');
      node = this.get('node');
      views = this.get('view');
      if (views.length === 1) {
        column = column.model.makePath(views[0], column.subclasses);
        node = column.isAttribute() ? column.getParent() : column;
      }
      node.getType().getDisplayName().then((function(_this) {
        return function(name) {
          return _this.set({
            columnTypeName: name
          });
        };
      })(this));
      return column.getDisplayName().then((function(_this) {
        return function(name) {
          _this.set({
            columnName: name
          });
          if (column.isAttribute()) {
            _this.set({
              fieldName: _.last(name.split(' > '))
            });
          }
          return _this.set({
            contentName: _.compact([_this.get('columnTypeName'), _this.get('fieldName')]).join(' ')
          });
        };
      })(this));
    };

    NestedTableModel.prototype.getPath = function() {
      return this.get('column');
    };

    NestedTableModel.prototype.toJSON = function() {
      return _.extend(NestedTableModel.__super__.toJSON.apply(this, arguments), {
        column: this.get('column').toString(),
        node: this.get('node').toString(),
        rows: this.get('rows').map(function(r) {
          return r.map(function(c) {
            return c.toJSON();
          });
        })
      });
    };

    return NestedTableModel;

  })(CoreModel);

}).call(this);
