(function() {
  var Backbone, NumericRange, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  Backbone = require('backbone');

  module.exports = NumericRange = (function(_super) {
    __extends(NumericRange, _super);

    function NumericRange() {
      return NumericRange.__super__.constructor.apply(this, arguments);
    }

    NumericRange.prototype._defaults = {};

    NumericRange.prototype.setLimits = function(limits) {
      return _.extend(this._defaults, limits);
    };

    NumericRange.prototype.get = function(prop) {
      var ret;
      ret = NumericRange.__super__.get.call(this, prop);
      if (ret != null) {
        return ret;
      } else if (prop in this._defaults) {
        return this._defaults[prop];
      } else {
        return null;
      }
    };

    NumericRange.prototype.toJSON = function() {
      return _.extend({}, this._defaults, this.attributes);
    };

    NumericRange.prototype.nullify = function() {
      var evt, _i, _len, _ref, _results;
      this.unset('min');
      this.unset('max');
      this.nulled = true;
      _ref = ['change:min', 'change:max', 'change'];
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        evt = _ref[_i];
        _results.push(this.trigger(evt, this));
      }
      return _results;
    };

    NumericRange.prototype.reset = function() {
      this.clear();
      return this.trigger('reset', this);
    };

    NumericRange.prototype.set = function(name, value) {
      var meth;
      this.nulled = false;
      if (_.isString(name) && (name in this._defaults)) {
        meth = name === 'min' ? 'max' : 'min';
        return NumericRange.__super__.set.call(this, name, Math[meth](this._defaults[name], value));
      } else {
        return NumericRange.__super__.set.apply(this, arguments);
      }
    };

    NumericRange.prototype.isAll = function() {
      return !this.isNotAll();
    };

    NumericRange.prototype.isNotAll = function() {
      var max, min, _ref;
      if (this.nulled) {
        return false;
      }
      _ref = this.toJSON(), min = _ref.min, max = _ref.max;
      return ((min != null) && min !== this._defaults.min) || ((max != null) && max !== this._defaults.max);
    };

    return NumericRange;

  })(Backbone.Model);

}).call(this);
