(function() {
  var IMObject, ObjectStore, _;

  _ = require('underscore');

  IMObject = require('./intermine-object');

  module.exports = ObjectStore = (function() {
    function ObjectStore(root, schema) {
      this.schema = schema;
      if (root == null) {
        throw new Error('No root');
      }
      if (this.schema == null) {
        throw new Error('no schema');
      }
      this.base = root.replace(/\/service\/?$/, "");
      this._objects = {};
    }

    ObjectStore.prototype.get = function(obj, field) {
      var model, _base, _name;
      model = ((_base = this._objects)[_name = obj.id] != null ? _base[_name] : _base[_name] = this._newObject(obj));
      model.merge(obj, field);
      return model;
    };

    ObjectStore.prototype._newObject = function(obj) {
      var c, classes;
      classes = (function() {
        var _i, _len, _ref, _ref1, _ref2, _results;
        _ref2 = (_ref = (_ref1 = obj['class']) != null ? _ref1.split(',') : void 0) != null ? _ref : [];
        _results = [];
        for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
          c = _ref2[_i];
          _results.push(this.schema.makePath(c));
        }
        return _results;
      }).call(this);
      return new IMObject(this.base, classes, obj.id);
    };

    ObjectStore.prototype.destroy = function() {
      var id, model, _ref;
      _ref = this._objects;
      for (id in _ref) {
        model = _ref[id];
        model.destroy();
      }
      delete this.selectedObjects;
      return delete this._objects;
    };

    return ObjectStore;

  })();

}).call(this);
