(function() {
  var Backbone, OpenNodes, UniqItems, descendsFrom,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Backbone = require('backbone');

  UniqItems = require('./uniq-items');

  descendsFrom = function(a, b) {
    if ((!(a != null ? a.equals : void 0)) || (!(b != null ? b.isRoot : void 0))) {
      return false;
    }
    while (!a.equals(b)) {
      if (b.isRoot()) {
        return false;
      }
      b = b.getParent();
    }
    return true;
  };

  module.exports = OpenNodes = (function(_super) {
    __extends(OpenNodes, _super);

    function OpenNodes() {
      return OpenNodes.__super__.constructor.apply(this, arguments);
    }

    OpenNodes.prototype.contains = function(path) {
      if (path instanceof Backbone.Model) {
        return OpenNodes.__super__.contains.call(this, path);
      } else {
        return this.any(function(node) {
          return descendsFrom(path, node.get('item'));
        });
      }
    };

    OpenNodes.prototype.remove = function(path) {
      var delenda, delendum, _i, _len, _results;
      if (path instanceof Backbone.Model) {
        OpenNodes.__super__.remove.call(this, path);
      }
      delenda = this.filter(function(node) {
        return descendsFrom(path, node.get('item'));
      });
      _results = [];
      for (_i = 0, _len = delenda.length; _i < _len; _i++) {
        delendum = delenda[_i];
        _results.push(OpenNodes.__super__.remove.call(this, delendum));
      }
      return _results;
    };

    return OpenNodes;

  })(UniqItems);

}).call(this);
