(function() {
  var Page;

  module.exports = Page = (function() {
    function Page(start, size) {
      this.start = start;
      this.size = size != null ? size : null;
      if (!((this.start != null) && this.start >= 0)) {
        throw new Error('Start must be >= 0');
      }
      if ((this.size != null) && this.size < 0) {
        throw new Error('Size must be null or Natural');
      }
    }

    Page.prototype.end = function() {
      if (this.all()) {
        return null;
      } else {
        return this.start + this.size;
      }
    };

    Page.prototype.all = function() {
      return !this.size;
    };

    Page.prototype.isBefore = function(index) {
      return (this.size != null) && this.end() < index;
    };

    Page.prototype.isAfter = function(index) {
      return index < this.start;
    };

    Page.prototype.leftGap = function(index) {
      if (this.isAfter(index)) {
        return this.start - index;
      } else {
        return null;
      }
    };

    Page.prototype.rightGap = function(index) {
      if (this.isBefore(index)) {
        return index - this.end();
      } else {
        return null;
      }
    };

    Page.prototype.next = function() {
      return new Page(this.end(), this.size);
    };

    Page.prototype.prev = function() {
      return new Page(Math.max(0, this.start - this.size), this.size);
    };

    Page.prototype.toString = function() {
      return "Page(" + this.start + " .. " + (this.end()) + ")";
    };

    return Page;

  })();

}).call(this);
