(function() {
  var Backbone, PathSet, UniqItems,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  UniqItems = require('./uniq-items');

  Backbone = require('backbone');

  module.exports = PathSet = (function(_super) {
    __extends(PathSet, _super);

    function PathSet() {
      return PathSet.__super__.constructor.apply(this, arguments);
    }

    PathSet.prototype.paths = function() {
      return this.map(function(model) {
        return model.get('item');
      });
    };

    PathSet.prototype.contains = function(path) {
      return this.any(function(model) {
        return path.equals(model.get('item'));
      });
    };

    PathSet.prototype.toggle = function(path) {
      if (this.contains(path)) {
        return this.remove(path);
      } else {
        return this.add(path);
      }
    };

    PathSet.prototype.remove = function(path) {
      var delendum;
      if (path instanceof Backbone.Model) {
        return PathSet.__super__.remove.apply(this, arguments);
      }
      delendum = this.find(function(model) {
        return path.equals(model.get('item'));
      });
      if (delendum != null) {
        return PathSet.__super__.remove.call(this, delendum);
      }
    };

    return PathSet;

  })(UniqItems);

}).call(this);
