(function() {
  var BOOLEAN_TYPES, CoreModel, NUMERIC_TYPES, PathModel, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  CoreModel = require('../core-model');

  _ref = require('imjs').Model, NUMERIC_TYPES = _ref.NUMERIC_TYPES, BOOLEAN_TYPES = _ref.BOOLEAN_TYPES;

  module.exports = PathModel = (function(_super) {
    __extends(PathModel, _super);

    PathModel.prototype.defaults = function() {
      return {
        path: null,
        type: null,
        displayName: null,
        typeName: null,
        parts: [],
        isNumeric: false,
        isBoolean: false,
        isReference: false,
        isAttribute: true
      };
    };

    function PathModel(path) {
      PathModel.__super__.constructor.call(this);
      this.set(this.pathAttributes(path));
      this.setDisplayName(path);
      this.setTypeName(path);
      this.pathInfo = function() {
        return path;
      };
      this.freeze('path', 'isNumeric', 'isBoolean', 'isReference', 'isAttribute');
    }

    PathModel.prototype.setDisplayName = function(path) {
      return path.getDisplayName().then((function(_this) {
        return function(name) {
          _this.set({
            displayName: name,
            parts: name.split(' > ')
          });
          return _this.freeze('displayName', 'parts');
        };
      })(this));
    };

    PathModel.prototype.setTypeName = function(path) {
      var type;
      type = (path.isAttribute() ? path.getParent() : path).getType();
      return type.getDisplayName().then((function(_this) {
        return function(name) {
          return _this.set({
            typeName: name
          });
        };
      })(this));
    };

    PathModel.prototype.pathAttributes = function(path) {
      var attrs, isAttr, str, type, _ref1;
      str = String(path);
      isAttr = path.isAttribute();
      type = path.getType();
      attrs = {
        id: (isAttr ? str : "" + str + ".id"),
        path: str,
        type: (_ref1 = type.name) != null ? _ref1 : type
      };
      if (isAttr) {
        attrs.isNumeric = (__indexOf.call(NUMERIC_TYPES, type) >= 0);
        attrs.isBoolean = (__indexOf.call(BOOLEAN_TYPES, type) >= 0);
      } else {
        attrs.isReference = true;
        attrs.isAttribute = false;
      }
      return attrs;
    };

    return PathModel;

  })(CoreModel);

}).call(this);
