(function() {
  var Collection, CoreModel, SelectedObjects, SelectionModel, types,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  CoreModel = require('../core-model');

  Collection = require('../core/collection');

  types = require('../core/type-assertions');

  SelectionModel = (function(_super) {
    __extends(SelectionModel, _super);

    function SelectionModel() {
      return SelectionModel.__super__.constructor.apply(this, arguments);
    }

    SelectionModel.prototype.defaults = function() {
      return {
        'class': null,
        'id': null
      };
    };

    SelectionModel.prototype.validate = function(attrs, opts) {
      if ('class' in attrs) {
        if (attrs['class'] == null) {
          return '"class" must not be null';
        }
      }
      if ('id' in attrs) {
        if (attrs.id == null) {
          return '"id" must not be null';
        }
      }
      return false;
    };

    return SelectionModel;

  })(CoreModel);

  module.exports = SelectedObjects = (function(_super) {
    __extends(SelectedObjects, _super);

    SelectedObjects.prototype.model = SelectionModel;

    function SelectedObjects(service) {
      SelectedObjects.__super__.constructor.call(this);
      types.assertMatch(types.Service, service, 'service');
      this.state = new CoreModel({
        node: null,
        commonType: null,
        typeName: null
      });
      this.listenTo(this.state, 'change:commonType', this.onChangeType);
      this.listenTo(this.state, 'change:node', this.onChangeNode);
      this.listenTo(this, 'add remove reset', this.setType);
      service.fetchModel().then((function(_this) {
        return function(schema) {
          _this.schema = schema;
          return _this.setType();
        };
      })(this));
    }

    SelectedObjects.prototype.onChangeNode = function() {
      return this.trigger('change:node change', this.state.get('node'));
    };

    SelectedObjects.prototype.onChangeType = function() {
      var path, type;
      if (this.schema == null) {
        return;
      }
      type = this.state.get('commonType');
      if (type == null) {
        return this.state.set({
          typeName: null
        });
      }
      path = this.schema.makePath(type);
      path.getDisplayName().then((function(_this) {
        return function(name) {
          _this.state.set({
            typeName: name
          });
          return _this.trigger('change:typeName change');
        };
      })(this));
      return this.trigger('change:commonType change');
    };

    SelectedObjects.prototype.setType = function() {
      var commonType;
      if (this.schema == null) {
        return;
      }
      commonType = this.size() ? commonType = this.schema.findCommonType(this.map(function(o) {
        return o.get('class');
      })) : null;
      if (commonType != null) {
        return this.state.set({
          commonType: commonType
        });
      } else {
        return this.state.set({
          commonType: null,
          typeName: null
        });
      }
    };

    return SelectedObjects;

  })(Collection);

}).call(this);
