(function() {
  var CoreModel, Executor, StepModel, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreModel = require('../core-model');

  Executor = require('../utils/count-executor');

  module.exports = StepModel = (function(_super) {
    __extends(StepModel, _super);

    function StepModel() {
      return StepModel.__super__.constructor.apply(this, arguments);
    }

    StepModel.prototype.defaults = function() {
      return {
        count: 0
      };
    };

    StepModel.prototype.initialize = function() {
      StepModel.__super__.initialize.apply(this, arguments);
      this.set({
        createdAt: new Date()
      });
      this.listenTo(this, 'change:query', this._setCount);
      return this._setCount();
    };

    StepModel.prototype._setCount = function() {
      var q;
      q = this.get('query');
      if (q != null) {
        return Executor.count(q).then((function(_this) {
          return function(c) {
            return _this.set({
              count: c
            });
          };
        })(this));
      } else {
        return this.set({
          count: 0
        });
      }
    };

    StepModel.prototype.toJSON = function() {
      return _.extend(StepModel.__super__.toJSON.apply(this, arguments), {
        query: this.get('query').toJSON()
      });
    };

    return StepModel;

  })(CoreModel);

}).call(this);
