(function() {
  var CoreModel, Options, PathSet, TableModel,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Options = require('../options');

  CoreModel = require('../core-model');

  PathSet = require('./path-set');

  module.exports = TableModel = (function(_super) {
    __extends(TableModel, _super);

    function TableModel() {
      this.filled = __bind(this.filled, this);
      return TableModel.__super__.constructor.apply(this, arguments);
    }

    TableModel.prototype.defaults = function() {
      return {
        phase: 'FETCHING',
        start: 0,
        size: Options.get('DefaultPageSize'),
        count: null,
        fill: 0,
        error: null,
        selecting: false,
        previewOwner: null,
        highlitNode: null,
        minimisedColumns: new PathSet
      };
    };

    TableModel.prototype.initialize = function() {
      var minimisedColumns;
      minimisedColumns = this.get('minimisedColumns');
      this.listenTo(minimisedColumns, 'add remove reset', function() {
        return this.trigger('change:minimisedColumns change');
      });
      return this.freeze('minimisedColumns');
    };

    TableModel.prototype.filled = function() {
      return this.swap('fill', function(n) {
        return n + 1;
      });
    };

    TableModel.prototype.toJSON = function() {
      var data;
      data = TableModel.__super__.toJSON.apply(this, arguments);
      data.minimisedColumns = this.get('minimisedColumns').toJSON().map(String);
      return data;
    };

    TableModel.prototype.destroy = function() {
      this.get('minimisedColumns').close();
      return TableModel.__super__.destroy.apply(this, arguments);
    };

    return TableModel;

  })(CoreModel);

}).call(this);
