(function() {
  var Backbone, Collection, CoreModel, Item, UniqItems, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Backbone = require('backbone');

  _ = require('underscore');

  CoreModel = require('../core-model');

  Collection = require('../core/collection');

  Item = (function(_super) {
    __extends(Item, _super);

    function Item() {
      return Item.__super__.constructor.apply(this, arguments);
    }

    Item.prototype.initialize = function(item, props) {
      if (props != null) {
        this.set(props);
      }
      return this.set({
        item: item,
        id: String(item)
      });
    };

    return Item;

  })(CoreModel);

  module.exports = UniqItems = (function(_super) {
    __extends(UniqItems, _super);

    function UniqItems() {
      return UniqItems.__super__.constructor.apply(this, arguments);
    }

    UniqItems.prototype.model = Item;

    UniqItems.prototype.toJSON = function() {
      var m, _i, _len, _ref, _results;
      _ref = this.models;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        m = _ref[_i];
        _results.push(m.get('item'));
      }
      return _results;
    };

    UniqItems.prototype.togglePresence = function(item) {
      if (this.contains(item)) {
        return this.remove(item);
      } else {
        return this.add(item);
      }
    };

    UniqItems.prototype.get = function(key) {
      return UniqItems.__super__.get.call(this, key instanceof Backbone.Model ? key : String(key));
    };

    UniqItems.prototype.contains = function(item) {
      if (item instanceof Item) {
        return UniqItems.__super__.contains.call(this, item);
      } else {
        return this.findWhere({
          item: item
        }) != null;
      }
    };

    UniqItems.prototype.add = function(items, props) {
      var item, _i, _len, _results;
      items = _(items).isArray() ? items : [items];
      _results = [];
      for (_i = 0, _len = items.length; _i < _len; _i++) {
        item = items[_i];
        if ((item != null) && "" !== item) {
          if (!this.contains(item)) {
            _results.push(UniqItems.__super__.add.call(this, new Item(item, props)));
          } else {
            _results.push(void 0);
          }
        }
      }
      return _results;
    };

    UniqItems.prototype.remove = function(items, opts) {
      var item, _i, _len, _results;
      items = _(items).isArray() ? items : [items];
      _results = [];
      for (_i = 0, _len = items.length; _i < _len; _i++) {
        item = items[_i];
        if (item instanceof Item) {
          _results.push(UniqItems.__super__.remove.call(this, item, opts));
        } else {
          _results.push(UniqItems.__super__.remove.call(this, this.findWhere({
            item: item
          }), opts));
        }
      }
      return _results;
    };

    return UniqItems;

  })(Collection);

}).call(this);
