(function() {
  var NestedModel, Options,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  NestedModel = require('./core/nested-model');

  Options = (function(_super) {
    __extends(Options, _super);

    function Options() {
      return Options.__super__.constructor.apply(this, arguments);
    }

    Options.prototype.defaults = function() {
      return {
        INITIAL_SUMMARY_ROWS: 1000,
        NUM_SEPARATOR: ',',
        NUM_CHUNK_SIZE: 3,
        MAX_PIE_SLICES: 15,
        DropdownMax: 20,
        DefaultPageSize: 25,
        DynamicObjects: {
          NameDelimiter: ' / '
        },
        CodeGen: {
          Default: 'py',
          Langs: ['py', 'pl', 'java', 'rb', 'js', 'xml'],
          Extra: {
            js: 'codegen.AsHTML'
          }
        },
        ListFreshness: 250,
        MaxSuggestions: 1000,
        ListCategorisers: ['organism.name', 'department.company.name'],
        PieColors: 'category10',
        TableResults: {
          CacheFactor: 10,
          RequestLimit: 5000
        },
        TableHeader: {
          FullPathPopoverEnabled: true
        },
        TableCell: {
          AddDataClasses: true,
          PreviewTrigger: 'hover',
          HoverDelay: 200,
          IndicateOffHostLinks: true,
          ExternalLinkIcons: {
            "http://some.host.somewhere": "http://some.host.somewhere/logo.png"
          }
        },
        ItemDetails: {
          Fields: {},
          Count: {}
        },
        StylePrefix: 'imtables',
        SuggestionDepth: 2,
        Events: {
          ActivateTab: 'mouseenter'
        },
        Subtables: {
          Initially: {
            expanded: false
          }
        },
        Facets: {
          DrawAverageLine: true,
          Initially: {
            Open: true
          }
        },
        Destinations: ['download', 'Galaxy', 'GenomeSpace', 'Drive', 'Dropbox'],
        Destination: {
          download: {
            Enabled: true
          },
          Galaxy: {
            Main: "http://main.g2.bx.psu.edu",
            Current: null,
            Tool: 'flymine',
            Save: false,
            Enabled: true
          },
          GenomeSpace: {
            Upload: "https://gsui.genomespace.org/jsui/upload/loadUrlToGenomespace.html",
            Enabled: true
          },
          Drive: {
            Library: 'https://apis.google.com/js/client.js',
            Enabled: false
          },
          Dropbox: {
            Library: 'https://www.dropbox.com/static/api/2/dropins.js',
            Enabled: false
          }
        },
        ShowId: false,
        TableWidgets: {
          Pagination: {
            enabled: true,
            index: 0
          },
          PageSizer: {
            enabled: true,
            index: 1
          },
          TableSummary: {
            enabled: true,
            index: 2
          }
        },
        CellCutoff: 100,
        ShowHistory: true,
        icons: 'fontawesome',
        D3: {
          Transition: {
            Easing: 'exp',
            Duration: 500,
            DurationShort: 200
          }
        },
        brand: {
          "http://www_flymine_org/query/service/": {
            name: "FlyMine"
          },
          "http://preview_flymine_org/preview/service/": {
            name: "FlyMine-Preview"
          },
          "http://www_mousemine_org/mousemine/service/": {
            name: "MouseMine (MGI)"
          }
        },
        Formatters: {
          testmodel: {},
          genomic: {}
        },
        ColumnManager: {
          SelectColumn: {
            Multi: true
          }
        },
        UndoHistory: {
          ShowAllStatesCutOff: 6
        }
      };
    };

    return Options;

  })(NestedModel);

  module.exports = new Options;

  module.exports.Options = Options;

}).call(this);
