(function() {
  var __slice = [].slice;

  define('perma-query', function() {
    var Deferred, any, defer, get, getPermaQuery, replaceIdConstraint, whenAll, zip;
    get = intermine.funcutils.get;
    any = _.any, zip = _.zip;
    Deferred = jQuery.Deferred;
    defer = function(x) {
      return Deferred(function() {
        return this.resolve(x);
      });
    };
    whenAll = function(promises) {
      return $.when.apply($, promises).then(function() {
        var results;
        results = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
        return results.slice();
      });
    };
    replaceIdConstraint = function(classkeys, query) {
      return function(c) {
        var def, finding, keys, path, type, _ref;
        path = query.makePath(c.path);
        def = new Deferred;
        if (!(((_ref = c.op) === '=' || _ref === '==') && path.end.name === 'id')) {
          def.resolve(c);
        } else {
          type = path.getParent().getType().name;
          keys = classkeys[type];
          if (keys == null) {
            def.reject("No class keys configured for " + type);
          } else {
            finding = query.service.rows({
              select: keys,
              where: {
                id: c.value
              }
            }).then(get(0));
            finding.fail(def.reject);
            finding.then(function(values) {
              var value, _i, _len, _ref1, _ref2;
              if (!values) {
                return def.reject("" + type + "@" + c.value + " not found");
              }
              _ref1 = zip(keys, values);
              for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
                _ref2 = _ref1[_i], path = _ref2[0], value = _ref2[1];
                if (value != null) {
                  return def.resolve({
                    path: path,
                    value: value,
                    op: '=='
                  });
                }
              }
              return def.reject("" + type + "@" + c.value + " has no identifying fields");
            });
          }
        }
        return def.promise();
      };
    };
    return getPermaQuery = function(query) {
      var applyNewCons, c, containsIdConstraint, copy, def, nodes;
      nodes = (function() {
        var _i, _len, _ref, _results;
        _ref = query.constraints;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          c = _ref[_i];
          if (c.type == null) {
            _results.push(query.makePath(c.path));
          }
        }
        return _results;
      })();
      containsIdConstraint = nodes.length && any(nodes, function(n) {
        var _ref;
        return 'id' === ((_ref = n.end) != null ? _ref.name : void 0);
      });
      copy = query.clone();
      if (!containsIdConstraint) {
        return defer(copy);
      }
      def = new Deferred;
      applyNewCons = function(newCons) {
        copy.constraints = newCons;
        return def.resolve(copy);
      };
      query.service.get('classkeys').then(function(_arg) {
        var classes, replaceIdCon;
        classes = _arg.classes;
        replaceIdCon = replaceIdConstraint(classes, copy);
        return whenAll((function() {
          var _i, _len, _ref, _results;
          _ref = copy.constraints;
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            c = _ref[_i];
            _results.push(replaceIdCon(c));
          }
          return _results;
        })()).then(applyNewCons).fail(def.reject);
      });
      return def.promise();
    };
  });

}).call(this);
