(function() {
  var getOrganisms, modelIsBio, organisable, requiresAuthentication;

  modelIsBio = function(model) {
    return !!(model != null ? model.classes['Gene'] : void 0);
  };

  requiresAuthentication = function(q) {
    return _.any(q.constraints, function(c) {
      var _ref;
      return (_ref = c.op) === 'NOT IN' || _ref === 'IN';
    });
  };

  organisable = function(path) {
    return path.getEndClass().name === 'Organism' || (path.getType().fields['organism'] != null);
  };

  getOrganisms = function(q, cb) {
    return $.when(q).then(function(query) {
      var c, def, done, mustBe, n, newView, opath, toRun;
      def = $.Deferred();
      if (cb != null) {
        def.done(cb);
      }
      done = _.compose(def.resolve, uniquelyFlat);
      mustBe = (function() {
        var _i, _len, _ref, _ref1, _results;
        _ref = query.constraints;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          c = _ref[_i];
          if (((_ref1 = c.op) === '=' || _ref1 === 'ONE OF' || _ref1 === 'LOOKUP') && c.path.match(/(o|O)rganism(\.\w+)?$/)) {
            _results.push(c.value || c.values);
          }
        }
        return _results;
      })();
      if (mustBe.length) {
        done(mustBe);
      } else {
        toRun = query.clone();
        newView = (function() {
          var _i, _len, _ref, _results;
          _ref = toRun.getViewNodes();
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            n = _ref[_i];
            if (!(organisable(n))) {
              continue;
            }
            opath = n.getEndClass().name === 'Organism' ? n : n.append('organism');
            _results.push(opath.append('shortName'));
          }
          return _results;
        })();
        if (newView.length) {
          toRun.select(_.uniq(newView, String)).orderBy([]).rows().then(done, function() {
            return done([]);
          });
        } else {
          done([]);
        }
      }
      return def.promise();
    });
  };

}).call(this);
