(function() {
  var Branding, Options, Promise, getInstance, instances;

  Options = require('../options');

  Promise = require('es6-promise').Promise;

  instances = {};

  getInstance = function(service) {
    var _name;
    return instances[_name = service.root] != null ? instances[_name] : instances[_name] = new Branding(service);
  };

  module.exports = function(service) {
    return getInstance(service).getBranding();
  };

  Branding = (function() {
    function Branding(service) {
      this.key = service.root.replace(/\./g, '_');
      this.promise = service.get('branding').then((function(_this) {
        return function(info) {
          return Options.set(['brand', _this.key], info.properties);
        };
      })(this));
    }

    Branding.prototype.getBranding = function() {
      return new Promise((function(_this) {
        return function(resolve) {
          return _this.promise.then((function() {
            return resolve(Options.get(['brand', _this.key]));
          }), (function() {
            return resolve(null);
          }));
        };
      })(this));
    };

    return Branding;

  })();

}).call(this);
