(function() {
  var Formatting, createColumns, getReplacedTest, index, isKeyField, notBanned, returnIfOK,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  createColumns = require('./create-columns');

  isKeyField = require('./is-key-field');

  getReplacedTest = require('./get-replaced-test');

  Formatting = require('../formatting');

  notBanned = function(blacklist) {
    return function(formatter) {
      return !blacklist.findWhere({
        formatter: formatter
      });
    };
  };

  returnIfOK = function(f, test) {
    return function(x) {
      var r;
      r = f(x);
      if (test(r)) {
        return r;
      } else {
        return null;
      }
    };
  };

  index = function(xs) {
    var i, x, _i, _len, _results;
    _results = [];
    for (i = _i = 0, _len = xs.length; _i < _len; i = ++_i) {
      x = xs[i];
      _results.push(x.index = i);
    }
    return _results;
  };

  module.exports = function(query, banList) {
    return query.service.fetchClassKeys().then(function(classKeys) {
      var col, cols, explicitReplacements, fmtr, getFormatter, isReplaced, keyField, newHeaders, parent, replaced, replacedBy, subPath, _i, _j, _k, _l, _len, _len1, _len2, _len3, _ref, _ref1, _ref2;
      keyField = isKeyField(classKeys);
      replacedBy = {};
      explicitReplacements = {};
      getFormatter = returnIfOK(Formatting.getFormatter, notBanned(banList));
      cols = createColumns(query);
      for (_i = 0, _len = cols.length; _i < _len; _i++) {
        col = cols[_i];
        if (!(col.path.isAttribute() && (fmtr = getFormatter(col.path)))) {
          continue;
        }
        col.isFormatted = true;
        col.formatter = fmtr;
        parent = col.path.getParent();
        _ref1 = (_ref = fmtr.replaces) != null ? _ref : [];
        for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
          replaced = _ref1[_j];
          subPath = "" + parent + "." + replaced;
          if (replacedBy[subPath] == null) {
            replacedBy[subPath] = col;
          }
          if (__indexOf.call(query.views, subPath) >= 0) {
            col.replaces.push(query.makePath(subPath));
          }
        }
      }
      for (_k = 0, _len2 = cols.length; _k < _len2; _k++) {
        col = cols[_k];
        _ref2 = col.replaces;
        for (_l = 0, _len3 = _ref2.length; _l < _len3; _l++) {
          replaced = _ref2[_l];
          explicitReplacements[replaced] = col;
        }
      }
      isReplaced = getReplacedTest(replacedBy, explicitReplacements);
      newHeaders = (function() {
        var _len4, _m, _ref3, _results;
        _results = [];
        for (_m = 0, _len4 = cols.length; _m < _len4; _m++) {
          col = cols[_m];
          if (!(!isReplaced(col))) {
            continue;
          }
          if (col.isFormatted) {
            if (_ref3 = col.path, __indexOf.call(col.replaces, _ref3) < 0) {
              col.replaces.push(col.path);
            }
            if ((keyField(col.path)) || (col.replaces.length > 1)) {
              col.path = col.path.getParent();
            }
          }
          _results.push(col);
        }
        return _results;
      })();
      index(newHeaders);
      return newHeaders;
    });
  };

}).call(this);
