(function() {
  var calculateRowTemplate, getOJCBelow, getTopLevelOJC,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  getOJCBelow = function(query, p, below) {
    var highest, oj, path;
    oj = query.getOuterJoin(p);
    if ((!oj) || (oj === below)) {
      return null;
    }
    path = query.makePath(oj);
    highest = path.isCollection() ? oj : null;
    path = path.getParent();
    while (path && (!path.isRoot())) {
      (function(next) {
        var nextPath;
        if (next != null) {
          nextPath = query.makePath(next);
        }
        if ((nextPath != null ? nextPath.isCollection() : void 0) && (next !== below)) {
          highest = next;
        }
        return path = nextPath != null ? nextPath.getParent() : void 0;
      })(query.getOuterJoin(path));
    }
    return highest;
  };

  getTopLevelOJC = function(query, p) {
    return getOJCBelow(query, p, null);
  };

  module.exports = calculateRowTemplate = function(query) {
    var coevals, cv, group, handled, lower, oj, row, v, _i, _j, _len, _len1, _ref;
    row = [];
    handled = {};
    _ref = query.views;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      v = _ref[_i];
      if (!(!handled[v])) {
        continue;
      }
      oj = getTopLevelOJC(query, v);
      if (oj) {
        coevals = query.views.filter(function(vv) {
          return oj === getTopLevelOJC(query, vv);
        });
        group = {
          column: oj,
          view: []
        };
        for (_j = 0, _len1 = coevals.length; _j < _len1; _j++) {
          cv = coevals[_j];
          lower = getOJCBelow(query, cv, oj);
          handled[cv] = group;
          if (lower) {
            if (!(__indexOf.call(group.view, lower) >= 0)) {
              group.view.push(lower);
            }
          } else {
            group.view.push(cv);
          }
        }
        row.push(handled[oj] = group);
      } else {
        row.push(handled[v] = {
          column: v
        });
      }
    }
    return row;
  };

}).call(this);
