(function() {
  var createColumns, longestCommonPrefix, structure;

  longestCommonPrefix = require('./longest-common-prefix');

  structure = require('./calculate-row-template');

  module.exports = createColumns = function(query) {
    return structure(query).map(function(cell) {
      var commonPrefix, path, replaces, subview, v;
      if (cell.view != null) {
        commonPrefix = longestCommonPrefix(cell.view);
        path = query.makePath(commonPrefix);
        subview = (function() {
          var _i, _len, _ref, _results;
          _ref = cell.view;
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            v = _ref[_i];
            _results.push(query.makePath(v));
          }
          return _results;
        })();
        replaces = (function() {
          var _i, _len, _ref, _results;
          _ref = query.views;
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            v = _ref[_i];
            if (0 === v.indexOf(commonPrefix)) {
              _results.push(query.makePath(v));
            }
          }
          return _results;
        })();
      } else {
        path = query.makePath(cell.column);
        subview = null;
        replaces = [];
      }
      return {
        path: path,
        subview: subview,
        replaces: replaces
      };
    });
  };

}).call(this);
