(function() {
  var buildProps, refs, refsIn, _;

  _ = require('underscore');

  buildProps = function(fs) {
    return function(vs) {
      if (vs) {
        return _.object(_.zip(fs, vs));
      } else {
        return {};
      }
    };
  };

  refs = function(fs) {
    var f;
    return _.flatten((function() {
      var _i, _len, _results;
      _results = [];
      for (_i = 0, _len = fs.length; _i < _len; _i++) {
        f = fs[_i];
        if (~f.indexOf('.')) {
          _results.push(refsIn(f));
        }
      }
      return _results;
    })());
  };

  refsIn = function(f) {
    var i, parts, _i, _ref, _results;
    parts = f.split('.');
    _results = [];
    for (i = _i = 1, _ref = parts.length; 1 <= _ref ? _i < _ref : _i > _ref; i = 1 <= _ref ? ++_i : --_i) {
      _results.push(parts.slice(0, i).join('.'));
    }
    return _results;
  };

  module.exports = function(type, fields, cache) {
    if (cache == null) {
      cache = {};
    }
    return function(service, id) {
      var key;
      key = service.root + '#' + id;
      return cache[key] != null ? cache[key] : cache[key] = (function() {
        return service.rows({
          select: fields,
          from: type,
          where: {
            id: id
          },
          joins: refs(fields)
        }).then(_.compose(buildProps(fields), _.head));
      })();
    };
  };

}).call(this);
