(function() {
  var EQL, Promise, getOrganisms, hasAnOrganism, nameOrShortName, organisable, uniquelyFlat, wild, _,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  _ = require('underscore');

  Promise = require('es6-promise').Promise;

  uniquelyFlat = _.compose(_.uniq, _.flatten);

  hasAnOrganism = function(path) {
    var _ref;
    return ((_ref = path.getType().fields) != null ? _ref.organism : void 0) != null;
  };

  organisable = function(path) {
    return (path.getEndClass().name === 'Organism') || (hasAnOrganism(path));
  };

  nameOrShortName = function(path) {
    var _ref;
    return (path.getEndClass().name === 'Organism') && ((_ref = path.end.name) === 'name' || _ref === 'shortName');
  };

  wild = function(value) {
    return (value != null) && /\*/.test(value);
  };

  EQL = ['=', '==', 'ONE OF'];

  module.exports = getOrganisms = function(query) {
    return new Promise(function(resolve, reject) {
      var c, directly, done, mustBe, n, newView, nothing, onLookups, opath;
      done = _.compose(resolve, uniquelyFlat);
      nothing = function() {
        return resolve([]);
      };
      directly = (function() {
        var _i, _len, _ref, _ref1, _results;
        _ref = query.constraints;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          c = _ref[_i];
          if ((_ref1 = c.op, __indexOf.call(EQL, _ref1) >= 0) && (!wild(c.value)) && (nameOrShortName(query.makePath(c.path)))) {
            _results.push(c.value || c.values);
          }
        }
        return _results;
      })();
      onLookups = (function() {
        var _i, _len, _ref, _results;
        _ref = query.constraints;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          c = _ref[_i];
          if ((c.op === 'LOOKUP') && (c.extraValue != null) && (hasAnOrganism(query.makePath(c.path)))) {
            _results.push(c.extraValue);
          }
        }
        return _results;
      })();
      mustBe = _.union(directly, onLookups);
      if (mustBe.length) {
        return done(mustBe);
      } else {
        newView = (function() {
          var _i, _len, _ref, _results;
          _ref = query.getViewNodes();
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            n = _ref[_i];
            if (!(organisable(n))) {
              continue;
            }
            opath = n.getType().name === 'Organism' ? n : n.append('organism');
            _results.push(opath.append('shortName'));
          }
          return _results;
        })();
        if (newView.length) {
          return query.clone().select(_.uniq(newView, String)).orderBy([]).rows().then(done, nothing);
        } else {
          return nothing();
        }
      }
    });
  };

}).call(this);
