(function() {
  var getReplacedTest, isIDPath, shouldFormat;

  shouldFormat = require('../formatting').shouldFormat;

  isIDPath = function(p) {
    return p.isAttribute() && p.end.name === 'id';
  };

  module.exports = getReplacedTest = function(formatReplacements, allReplacements) {
    return function(col) {
      var p, replacer;
      if (col == null) {
        throw new Error('no column');
      }
      p = col.path;
      if (!((shouldFormat(p)) || (p in allReplacements))) {
        return false;
      }
      replacer = formatReplacements[p];
      if (isIDPath(p)) {
        if (replacer == null) {
          replacer = formatReplacements[p.getParent()];
        }
      }
      return replacer && (replacer.formatter != null) && (col !== replacer);
    };
  };

}).call(this);
