(function() {
  var indent;

  module.exports = indent = function(xml) {
    var buffer, indentLevel, isClosing, isOneLiner, isOpening, line, lines, _i, _len;
    lines = xml.split(/></);
    indentLevel = 1;
    buffer = [];
    for (_i = 0, _len = lines.length; _i < _len; _i++) {
      line = lines[_i];
      if (!/>$/.test(line)) {
        line = line + '>';
      }
      if (!/^</.test(line)) {
        line = '<' + line;
      }
      isClosing = /^<\/\w+\s*>/.test(line);
      isOneLiner = /\/>$/.test(line) || (!isClosing && /<\/\w+>$/.test(line));
      isOpening = !(isOneLiner || isClosing);
      if (isClosing) {
        indentLevel--;
      }
      buffer.push(new Array(indentLevel).join('  ') + line);
      if (isOpening) {
        indentLevel++;
      }
    }
    return buffer.join("\n");
  };

}).call(this);
