(function() {
  var CACHE, Promise, getPathSuggestions, matchPathsToNames, _;

  _ = require('underscore');

  Promise = require('es6-promise').Promise;

  CACHE = {};

  matchPathsToNames = function(paths) {
    return function(names) {
      var name, path, _i, _len, _ref, _ref1, _results;
      _ref = _.zip(paths, names);
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        _ref1 = _ref[_i], path = _ref1[0], name = _ref1[1];
        _results.push({
          path: path,
          name: name
        });
      }
      return _results;
    };
  };

  module.exports = getPathSuggestions = function(query, depth) {
    var key, namings, p, paths;
    key = "" + query.service.root + ":" + query.root + ":" + depth;
    if (key in CACHE) {
      return CACHE[key];
    }
    paths = (function() {
      var _i, _len, _ref, _results;
      _ref = query.getPossiblePaths(depth);
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        p = _ref[_i];
        _results.push(query.makePath(p));
      }
      return _results;
    })();
    paths = paths.filter(function(p) {
      var _ref;
      return !(((_ref = p.end) != null ? _ref.name : void 0) === 'id');
    });
    namings = (function() {
      var _i, _len, _results;
      _results = [];
      for (_i = 0, _len = paths.length; _i < _len; _i++) {
        p = paths[_i];
        _results.push(p.getDisplayName());
      }
      return _results;
    })();
    return CACHE[key] != null ? CACHE[key] : CACHE[key] = Promise.all(namings).then(matchPathsToNames(paths));
  };

}).call(this);
