(function() {
  var PopoverFactory, PreviewCachingService;

  PreviewCachingService = (function() {
    function PreviewCachingService(wrapped) {
      this.wrapped = wrapped;
      this.root = this.wrapped.root;
      this._foundById = {};
      this._counts = {};
    }

    PreviewCachingService.prototype.fetchModel = function() {
      return this.wrapped.fetchModel();
    };

    PreviewCachingService.prototype.findById = function(type, id, flds) {
      var _base, _name;
      return (_base = this._foundById)[_name = "" + type + ":" + id + ":" + flds] != null ? _base[_name] : _base[_name] = this.wrapped.findById(type, id, flds);
    };

    PreviewCachingService.prototype.count = function(query) {
      var _base, _name;
      return (_base = this._counts)[_name = JSON.stringify(query)] != null ? _base[_name] : _base[_name] = this.wrapped.count(query);
    };

    PreviewCachingService.prototype.destroy = function() {
      this._foundById = {};
      this._counts = {};
      return delete this.wrapped;
    };

    return PreviewCachingService;

  })();

  module.exports = PopoverFactory = (function() {
    function PopoverFactory(service, Preview) {
      this.Preview = Preview;
      this.service = new PreviewCachingService(service);
    }

    PopoverFactory.prototype.get = function(obj) {
      var Preview, id, service, types;
      Preview = this.Preview, service = this.service;
      types = obj.get('classes');
      id = obj.get('id');
      return new Preview({
        service: service,
        model: {
          types: types,
          id: id
        }
      });
    };

    PopoverFactory.prototype.destroy = function() {
      this.service.destroy();
      return delete this.service;
    };

    return PopoverFactory;

  })();

}).call(this);
