(function() {
  var $, Options, Promise, loadDropbox, loadResource;

  $ = require('jquery');

  Promise = require('es6-promise').Promise;

  Options = require('../options');

  loadResource = require('./load-resource');

  loadDropbox = function() {
    return loadResource('Destination.Dropbox.Library', 'Dropbox');
  };

  module.exports = function(url, filename, onProgress) {
    return loadDropbox().then(function(Dropbox) {
      return new Promise(function(resolve, reject) {
        Dropbox.appKey = Options.get('auth.dropbox');
        return Dropbox.save({
          files: [
            {
              url: url,
              filename: filename
            }
          ],
          success: resolve,
          progress: onProgress,
          cancel: reject,
          error: reject
        });
      });
    });
  };

}).call(this);
