(function() {
  var Options, Promise, fromPairs, getGenomeSpaceUrl, save, _;

  _ = require('underscore');

  Promise = require('es6-promise').Promise;

  Options = require('../options');

  fromPairs = require('./query-string').fromPairs;

  getGenomeSpaceUrl = function(uri, fileName) {
    var GenomeSpace, pairs, qs;
    GenomeSpace = Options.get('Destination.GenomeSpace');
    pairs = [['uploadUrl', uri], ['fileName', fileName]];
    qs = fromPairs(pairs);
    return "" + GenomeSpace.Upload + "?" + qs;
  };

  save = function(uri, fileName) {
    return new Promise(function(resolve, reject) {
      var win;
      win = window.open(getGenomeSpaceUrl(uri, fileName));
      win.setCallbackOnGSUploadComplete = function(savePath) {
        return resolve(savePath);
      };
      win.setCallbackOnGSUploadError = function(savePath) {
        console.log('GSERR', arguments);
        return reject(new Error("Could not save to " + savePath));
      };
      win.addEventListener('unload', function() {
        return reject(new Error('Upload cancelled'));
      });
      return win.focus();
    });
  };

  module.exports = save;

}).call(this);
