(function() {
  var Icons, Messages, Options, SuggestionSource, fs, html, mustacheSettings, template, _,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  

  _ = require('underscore');

  Options = require('../options');

  Messages = require('../messages');

  Icons = require('../icons');

  mustacheSettings = require('../templates/mustache-settings');

  html = "<span class=\"alert alert-info\">\n  {{{ icons.icon('Info') }}}\n  {{ messages.getText('conbuilder.TooManySuggestions') }}\n  There are {{ extra }} values we could not include.\n</span>\n";

  template = _.template(html, mustacheSettings);

  module.exports = SuggestionSource = (function() {
    SuggestionSource.prototype.tooMany = '<span></span>';

    function SuggestionSource(suggestions, total) {
      var maxSuggestions;
      this.suggestions = suggestions;
      this.total = total;
      this.suggest = __bind(this.suggest, this);
      maxSuggestions = Options.get('MaxSuggestions');
      if (this.total > maxSuggestions) {
        this.tooMany = template({
          icons: Icons,
          messages: Messages,
          extra: total - maxSuggestions
        });
      }
    }

    SuggestionSource.prototype.suggest = function(term, cb) {
      var matches, parts, s, _ref, _ref1;
      if ((term == null) || term === '') {
        return cb((function() {
          var _i, _len, _ref, _results;
          _ref = this.suggestions.slice(0, 10);
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            s = _ref[_i];
            _results.push(s);
          }
          return _results;
        }).call(this));
      }
      parts = (_ref = term != null ? (_ref1 = term.toLowerCase()) != null ? _ref1.split(' ') : void 0 : void 0) != null ? _ref : [];
      matches = function(_arg) {
        var item;
        item = _arg.item;
        if (item == null) {
          item = '';
        }
        return _.all(parts, function(p) {
          return item.toLowerCase().indexOf(p) >= 0;
        });
      };
      return cb((function() {
        var _i, _len, _ref2, _results;
        _ref2 = this.suggestions;
        _results = [];
        for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
          s = _ref2[_i];
          if (matches(s)) {
            _results.push(s);
          }
        }
        return _results;
      }).call(this));
    };

    return SuggestionSource;

  })();

}).call(this);
