(function() {
  var CodeGenButton, CodeGenModel, CoreView, Dialogue, MainButton, Messages, Options, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../core-view');

  Messages = require('../messages');

  Options = require('../options');

  Templates = require('../templates');

  CodeGenModel = require('../models/code-gen');

  Dialogue = require('./code-gen-dialogue');

  require('../messages/code-gen');

  MainButton = (function(_super) {
    __extends(MainButton, _super);

    function MainButton() {
      return MainButton.__super__.constructor.apply(this, arguments);
    }

    MainButton.prototype.modelEvents = function() {
      return {
        'change:lang': this.reRender
      };
    };

    MainButton.prototype.template = Templates.template('code-gen-button-main');

    return MainButton;

  })(CoreView);

  module.exports = CodeGenButton = (function(_super) {
    __extends(CodeGenButton, _super);

    function CodeGenButton() {
      return CodeGenButton.__super__.constructor.apply(this, arguments);
    }

    CodeGenButton.prototype.parameters = ['query', 'tableState'];

    CodeGenButton.prototype.Model = CodeGenModel;

    CodeGenButton.prototype.template = Templates.template('code-gen-button');

    CodeGenButton.prototype.getData = function() {
      return _.extend(CodeGenButton.__super__.getData.apply(this, arguments), {
        options: Options.get('CodeGen')
      });
    };

    CodeGenButton.prototype.renderChildren = function() {
      return this.renderChildAt('.im-show-code-gen-dialogue', new MainButton({
        model: this.model
      }));
    };

    CodeGenButton.prototype.events = function() {
      return {
        'click .dropdown-menu.im-code-gen-langs li': 'chooseLang',
        'click .im-show-code-gen-dialogue': 'showDialogue'
      };
    };

    CodeGenButton.prototype.chooseLang = function(e) {
      var lang;
      lang = this.$(e.target).closest('li').data('lang');
      this.model.set({
        lang: lang
      });
      return this.showDialogue();
    };

    CodeGenButton.prototype.showDialogue = function() {
      var dialogue, page;
      page = this.tableState.pick('start', 'size');
      dialogue = new Dialogue({
        query: this.query,
        model: this.model,
        page: page
      });
      this.renderChild('dialogue', dialogue);
      return dialogue.show();
    };

    return CodeGenButton;

  })(CoreView);

}).call(this);
