(function() {
  var AvailablePath, CUTOFF, UnselectedColumn, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  UnselectedColumn = require('./unselected-column');

  CUTOFF = 900;

  module.exports = AvailablePath = (function(_super) {
    __extends(AvailablePath, _super);

    function AvailablePath() {
      return AvailablePath.__super__.constructor.apply(this, arguments);
    }

    AvailablePath.prototype.parameters = ['findActives'];

    AvailablePath.prototype.restoreTitle = 'columns.AddColumnToSortOrder';

    AvailablePath.prototype.events = function() {
      return _.extend(AvailablePath.__super__.events.apply(this, arguments), {
        mousedown: 'onMouseDown',
        dragstart: 'onDragStart',
        dragstop: 'onDragStop'
      });
    };

    AvailablePath.prototype.onMouseDown = function() {
      return this.fixAppendTo();
    };

    AvailablePath.prototype.fixAppendTo = function() {
      var modalWidth, wide;
      this.$el.draggable('option', 'appendTo', this.$el.closest('.well'));
      modalWidth = this.$el.closest('.modal').width();
      wide = modalWidth >= CUTOFF;
      return this.$el.draggable('option', 'axis', (wide ? null : 'y'));
    };

    AvailablePath.prototype.onDragStart = function() {
      this.state.set({
        dragged: this.model.get('path')
      });
      return this.$el.addClass('ui-dragging');
    };

    AvailablePath.prototype.onDragStop = function() {
      this.state.unset('dragged');
      return this.$el.removeClass('ui-dragging');
    };

    AvailablePath.prototype.postRender = function() {
      var index, modalWidth, wide;
      modalWidth = this.$el.closest('.modal').width();
      wide = modalWidth >= CUTOFF;
      index = this.model.collection.indexOf(this.model);
      this.$el.draggable({
        axis: (wide ? null : 'y'),
        connectToSortable: this.findActives(),
        helper: 'clone',
        revert: 'invalid',
        opacity: 0.8,
        cancel: 'i,a,button',
        zIndex: 1000
      });
      return this.$('[title]').tooltip({
        placement: (index === 0 ? 'bottom' : 'top')
      });
    };

    return AvailablePath;

  })(UnselectedColumn);

}).call(this);
