(function() {
  var Collection, CoreView, PathModel, SelectedColumn, TEMPLATE_PARTS, Templates, decr, ignore, incr, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  Collection = require('../../core/collection');

  Templates = require('../../templates');

  PathModel = require('../../models/path');

  ignore = require('../../utils/events').ignore;

  decr = function(i) {
    return i - 1;
  };

  incr = function(i) {
    return i + 1;
  };

  TEMPLATE_PARTS = ['column-manager-path-remover', 'column-manager-position-controls', 'column-manager-path-name'];

  module.exports = SelectedColumn = (function(_super) {
    __extends(SelectedColumn, _super);

    function SelectedColumn() {
      return SelectedColumn.__super__.constructor.apply(this, arguments);
    }

    SelectedColumn.prototype.Model = PathModel;

    SelectedColumn.prototype.tagName = 'li';

    SelectedColumn.prototype.className = 'list-group-item im-selected-column';

    SelectedColumn.prototype.template = Templates.templateFromParts(TEMPLATE_PARTS);

    SelectedColumn.prototype.removeTitle = 'columns.RemoveColumn';

    SelectedColumn.prototype.getData = function() {
      var isLast;
      isLast = this.model === this.model.collection.last();
      return _.extend(SelectedColumn.__super__.getData.apply(this, arguments), {
        removeTitle: this.removeTitle,
        isLast: isLast,
        parts: this.parts.pluck('part')
      });
    };

    SelectedColumn.prototype.initialize = function() {
      SelectedColumn.__super__.initialize.apply(this, arguments);
      this.parts = new Collection;
      this.listenTo(this.parts, 'add remove reset', this.reRender);
      this.resetParts();
      return this.listenTo(this.model.collection, 'sort', this.onCollectionSorted);
    };

    SelectedColumn.prototype.modelEvents = function() {
      return {
        destroy: this.stopListeningTo,
        'change:parts': this.resetParts
      };
    };

    SelectedColumn.prototype.stateEvents = function() {
      return {
        'change:fullPath': this.setFullPathClass
      };
    };

    SelectedColumn.prototype.onCollectionSorted = function() {
      return this.reRender();
    };

    SelectedColumn.prototype.resetParts = function() {
      var id, part;
      return this.parts.reset((function() {
        var _i, _len, _ref, _results;
        _ref = this.model.get('parts');
        _results = [];
        for (id = _i = 0, _len = _ref.length; _i < _len; id = ++_i) {
          part = _ref[id];
          _results.push({
            part: part,
            id: id
          });
        }
        return _results;
      }).call(this));
    };

    SelectedColumn.prototype.postRender = function() {
      return this.$('[title]').tooltip({
        container: this.$el
      });
    };

    SelectedColumn.prototype.events = function() {
      return {
        'click .im-remove-view': 'removeView',
        'click .im-move-up': 'moveUp',
        'click .im-move-down': 'moveDown',
        'click': 'toggleFullPath',
        'binned': 'removeView'
      };
    };

    SelectedColumn.prototype.toggleFullPath = function() {
      return this.state.toggle('fullPath');
    };

    SelectedColumn.prototype.moveDown = function(e) {
      var next;
      ignore(e);
      next = this.model.collection.at(incr(this.model.get('index')));
      next.swap('index', decr);
      this.model.swap('index', incr);
      return this.$el.insertAfter(this.$el.next());
    };

    SelectedColumn.prototype.moveUp = function(e) {
      var prev;
      ignore(e);
      prev = this.model.collection.at(decr(this.model.get('index')));
      prev.swap('index', incr);
      this.model.swap('index', decr);
      return this.$el.insertBefore(this.$el.prev());
    };

    SelectedColumn.prototype.setFullPathClass = function() {
      return this.$el.toggleClass('im-full-path', this.state.get('fullPath'));
    };

    SelectedColumn.prototype.removeView = function(e) {
      ignore(e);
      this.model.collection.remove(this.model);
      return this.model.destroy();
    };

    return SelectedColumn;

  })(CoreView);

}).call(this);
