(function() {
  var ClassSet, ColumnManagerTabs, CoreView, Templates, tabClassSet, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  Templates = require('../../templates');

  ClassSet = require('../../utils/css-class-set');

  tabClassSet = function(tab, state) {
    var defs;
    defs = {
      active: function() {
        return state.get('currentTab') === tab;
      }
    };
    defs["im-" + tab + "-tab"] = true;
    return new ClassSet(defs);
  };

  module.exports = ColumnManagerTabs = (function(_super) {
    __extends(ColumnManagerTabs, _super);

    function ColumnManagerTabs() {
      return ColumnManagerTabs.__super__.constructor.apply(this, arguments);
    }

    ColumnManagerTabs.TABS = ['view', 'sortorder'];

    ColumnManagerTabs.prototype.template = Templates.template('column-manager-tabs');

    ColumnManagerTabs.prototype.className = 'im-column-manager-tabs';

    ColumnManagerTabs.prototype.getData = function() {
      return _.extend(ColumnManagerTabs.__super__.getData.apply(this, arguments), {
        classes: this.classSets
      });
    };

    ColumnManagerTabs.prototype.initState = function() {
      return this.state.set({
        currentTab: ColumnManagerTabs.TABS[0]
      });
    };

    ColumnManagerTabs.prototype.initialize = function() {
      ColumnManagerTabs.__super__.initialize.apply(this, arguments);
      return this.initClassSets();
    };

    ColumnManagerTabs.prototype.stateEvents = function() {
      return {
        'change:currentTab': this.reRender
      };
    };

    ColumnManagerTabs.prototype.events = function() {
      return {
        'click .im-view-tab': 'selectViewTab',
        'click .im-sortorder-tab': 'selectSortOrderTab'
      };
    };

    ColumnManagerTabs.prototype.selectViewTab = function() {
      return this.state.set({
        currentTab: 'view'
      });
    };

    ColumnManagerTabs.prototype.selectSortOrderTab = function() {
      return this.state.set({
        currentTab: 'sortorder'
      });
    };

    ColumnManagerTabs.prototype.initClassSets = function() {
      var tab, _i, _len, _ref, _results;
      this.classSets = {};
      _ref = ['view', 'sortorder'];
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        tab = _ref[_i];
        _results.push((function(_this) {
          return function(tab) {
            return _this.classSets[tab] = tabClassSet(tab, _this.state);
          };
        })(this)(tab));
      }
      return _results;
    };

    return ColumnManagerTabs;

  })(CoreView);

}).call(this);
