(function() {
  var ConstraintSummary, CoreView, IS_BLANK, Messages, Model, Query, Templates, _, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
    __slice = [].slice;

  _ = require('underscore');

  Messages = require('../messages');

  Templates = require('../templates');

  CoreView = require('../core-view');

  IS_BLANK = require('../patterns').IS_BLANK;

  _ref = require('imjs'), Query = _ref.Query, Model = _ref.Model;

  Messages.set({
    'consummary.IsA': 'is a',
    'consummary.NoValue': 'no value'
  });

  module.exports = ConstraintSummary = (function(_super) {
    __extends(ConstraintSummary, _super);

    function ConstraintSummary() {
      return ConstraintSummary.__super__.constructor.apply(this, arguments);
    }

    ConstraintSummary.prototype.tagName = 'ol';

    ConstraintSummary.prototype.className = 'constraint-summary breadcrumb';

    ConstraintSummary.prototype.initialize = function() {
      ConstraintSummary.__super__.initialize.apply(this, arguments);
      return this.listenTo(Messages, 'change', this.reRender);
    };

    ConstraintSummary.prototype.getData = function() {
      return _.extend(ConstraintSummary.__super__.getData.apply(this, arguments), {
        labels: this.getSummary()
      });
    };

    ConstraintSummary.prototype.template = Templates.template('constraint-summary');

    ConstraintSummary.prototype.getTitleOp = function() {
      return this.model.get('op') || Messages.getText('consummary.IsA');
    };

    ConstraintSummary.prototype.modelEvents = function() {
      return {
        change: this.reRender
      };
    };

    ConstraintSummary.prototype.events = function() {
      return {
        'click .label-path': function() {
          return this.state.toggle('showFullPath');
        }
      };
    };

    ConstraintSummary.prototype.stateEvents = function() {
      return {
        'change:showFullPath': this.toggleFullPath
      };
    };

    ConstraintSummary.prototype.toggleFullPath = function() {
      return this.$('.label-path').toggleClass('im-show-full-path', !!this.state.get('showFullPath'));
    };

    ConstraintSummary.prototype.postRender = function() {
      return this.toggleFullPath();
    };

    ConstraintSummary.prototype.getTitleVal = function() {
      var first, last, vals, _i, _ref1, _ref2;
      if (this.model.has('values') && (_ref1 = this.model.get('op'), __indexOf.call(Query.MULTIVALUE_OPS.concat(Query.RANGE_OPS), _ref1) >= 0)) {
        if (vals = this.model.get('values')) {
          if (vals.length === 1) {
            return vals[0];
          } else if (vals.length === 0) {
            return '[ ]';
          } else if (vals.length > 5) {
            return vals.length + " values";
          } else {
            first = 2 <= vals.length ? __slice.call(vals, 0, _i = vals.length - 1) : (_i = 0, []), last = vals[_i++];
            return "" + (first.join(', ')) + " and " + last;
          }
        }
      } else if (this.model.has('value')) {
        return this.model.get('value');
      } else {
        return (_ref2 = this.model.get('typeName')) != null ? _ref2 : this.model.get('type');
      }
    };

    ConstraintSummary.prototype.isLookup = function() {
      return this.model.get('op') === 'LOOKUP';
    };

    ConstraintSummary.prototype.getPathLabel = function() {
      var displayName, path, title, _ref1, _ref2;
      _ref1 = this.model.toJSON(), title = _ref1.title, displayName = _ref1.displayName, path = _ref1.path;
      return {
        content: String((_ref2 = title != null ? title : displayName) != null ? _ref2 : path),
        type: 'path'
      };
    };

    ConstraintSummary.prototype.getSummary = function() {
      var labels, level, op, val, _ref1;
      labels = [];
      labels.push(this.getPathLabel());
      if ((op = this.getTitleOp())) {
        labels.push({
          content: op,
          type: 'op'
        });
      }
      if (_ref1 = this.model.get('op'), __indexOf.call(Query.NULL_OPS, _ref1) < 0) {
        val = this.getTitleVal();
        if ((val == null) || IS_BLANK.test(val)) {
          level = this.model.get('new') ? 'warning' : 'error';
          labels.push({
            content: 'NoValue',
            type: level
          });
        } else {
          labels.push({
            content: val,
            type: 'value'
          });
        }
        if (this.isLookup() && this.model.has('extraValue')) {
          labels.push({
            content: this.model.get('extraValue'),
            type: 'extra',
            icon: 'ExtraValue'
          });
        }
      }
      return labels;
    };

    return ConstraintSummary;

  })(CoreView);

}).call(this);
