(function() {
  var ActiveConstraint, ConstraintAdder, Constraints, CoreView, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../core-view');

  Templates = require('../templates');

  ConstraintAdder = require('./constraint-adder');

  ActiveConstraint = require('./active-constraint');

  require('../messages/constraints');

  module.exports = Constraints = (function(_super) {
    __extends(Constraints, _super);

    function Constraints() {
      return Constraints.__super__.constructor.apply(this, arguments);
    }

    Constraints.prototype.className = "im-constraints";

    Constraints.prototype.initialize = function(_arg) {
      this.query = _arg.query;
      Constraints.__super__.initialize.apply(this, arguments);
      return this.listenTo(this.query, "change:constraints", this.reRender);
    };

    Constraints.prototype.getData = function() {
      return _.extend(Constraints.__super__.getData.apply(this, arguments), {
        constraints: this.getConstraints()
      });
    };

    Constraints.prototype.events = function() {
      return {
        click: function(e) {
          return e != null ? e.stopPropagation() : void 0;
        }
      };
    };

    Constraints.prototype.template = Templates.templateFromParts(['constraints-heading', 'active-constraints']);

    Constraints.prototype.postRender = function() {
      var constraint, container, i, _i, _len, _ref;
      container = this.$('.im-active-constraints');
      _ref = this.getConstraints();
      for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
        constraint = _ref[i];
        this.renderChild("con_" + i, new ActiveConstraint({
          query: this.query,
          constraint: constraint
        }), container);
      }
      return this.renderChild('conAdder', this.getConAdder());
    };

    Constraints.prototype.getConstraints = function() {
      return this.query.constraints.slice();
    };

    Constraints.prototype.getConAdder = function() {
      return new ConstraintAdder({
        query: this.query
      });
    };

    return Constraints;

  })(CoreView);

}).call(this);
