(function() {
  var AdderButton, CoreView, Messages, PathModel, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  Messages = require('../../messages');

  PathModel = require('../../models/path');

  require('../../messages/constraints');

  module.exports = AdderButton = (function(_super) {
    __extends(AdderButton, _super);

    function AdderButton() {
      return AdderButton.__super__.constructor.apply(this, arguments);
    }

    AdderButton.prototype.Model = PathModel;

    AdderButton.prototype.tagName = 'button';

    AdderButton.prototype.className = 'btn btn-primary im-add-constraint';

    AdderButton.prototype.optionalParameters = ['hideType'];

    AdderButton.prototype.hideType = false;

    AdderButton.prototype.template = function(data) {
      return _.escape(Messages.getText('constraints.AddConFor', data));
    };

    AdderButton.prototype.getData = function() {
      return _.extend(AdderButton.__super__.getData.apply(this, arguments), {
        hideType: this.hideType
      });
    };

    AdderButton.prototype.modelEvents = function() {
      return {
        change: this.reRender
      };
    };

    AdderButton.prototype.events = function() {
      return {
        click: function() {
          return this.trigger('chosen', this.model.get('path'));
        }
      };
    };

    return AdderButton;

  })(CoreView);

}).call(this);
