(function() {
  var AdderButton, ComposedColumnConstraintAdder, ConstraintAdder, CoreView, DropdownButtonGrp, Messages, OPTS_SEL, Option, PathModel, Templates, Toggle, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __slice = [].slice;

  _ = require('underscore');

  CoreView = require('../../core-view');

  PathModel = require('../../models/path');

  Templates = require('../../templates');

  Messages = require('../../messages');

  ConstraintAdder = require('../constraint-adder');

  AdderButton = require('./column-adder-button');

  require('../../messages/constraints');

  OPTS_SEL = '.im-constraint-adder-options';

  DropdownButtonGrp = (function(_super) {
    __extends(DropdownButtonGrp, _super);

    function DropdownButtonGrp() {
      return DropdownButtonGrp.__super__.constructor.apply(this, arguments);
    }

    DropdownButtonGrp.prototype.className = 'btn-group';

    DropdownButtonGrp.prototype.parameters = ['main', 'options'];

    DropdownButtonGrp.prototype.initState = function() {
      return this.state.set({
        open: false
      });
    };

    DropdownButtonGrp.prototype.stateEvents = function() {
      return {
        'change:open': this.toggleOpen
      };
    };

    DropdownButtonGrp.prototype.toggleOpen = function() {
      return this.$el.toggleClass('open', this.state.get('open'));
    };

    DropdownButtonGrp.prototype.ICONS = 'NONE';

    DropdownButtonGrp.prototype.postRender = function() {
      var i, kid, ul, _i, _len, _ref;
      this.toggleOpen();
      this.renderChild('main', this.main);
      this.renderChild('toggle', new Toggle({
        state: this.state
      }));
      ul = document.createElement('ul');
      ul.className = 'dropdown-menu';
      _ref = this.options;
      for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
        kid = _ref[i];
        this.renderChild(i, kid, ul);
      }
      return this.$el.append(ul);
    };

    return DropdownButtonGrp;

  })(CoreView);

  Toggle = (function(_super) {
    __extends(Toggle, _super);

    function Toggle() {
      return Toggle.__super__.constructor.apply(this, arguments);
    }

    Toggle.prototype.tagName = 'button';

    Toggle.prototype.className = 'btn btn-primary dropdown-toggle';

    Toggle.prototype.ICONS = 'NONE';

    Toggle.prototype.template = _.template("<span class=\"caret\"></span>\n<span class=\"sr-only\"><%- Messages.getText('constraints.OtherPaths') %></span>");

    Toggle.prototype.events = function() {
      return {
        click: function() {
          return this.state.toggle('open');
        }
      };
    };

    return Toggle;

  })(CoreView);

  Option = (function(_super) {
    __extends(Option, _super);

    function Option() {
      return Option.__super__.constructor.apply(this, arguments);
    }

    Option.prototype.tagName = 'li';

    Option.prototype.className = '';

    Option.prototype.template = function() {
      return "<a>" + Option.__super__.template.apply(this, arguments) + "</a>";
    };

    return Option;

  })(AdderButton);

  module.exports = ComposedColumnConstraintAdder = (function(_super) {
    __extends(ComposedColumnConstraintAdder, _super);

    function ComposedColumnConstraintAdder() {
      return ComposedColumnConstraintAdder.__super__.constructor.apply(this, arguments);
    }

    ComposedColumnConstraintAdder.prototype.parameters = ['query', 'paths'];

    ComposedColumnConstraintAdder.prototype.onChosen = function(path) {
      return this.model.set({
        constraint: {
          path: path
        }
      });
    };

    ComposedColumnConstraintAdder.prototype.renderOptions = function() {};

    ComposedColumnConstraintAdder.prototype.showTree = function() {
      var b, grp, mainButton, opts, p, p_, ps, _i, _len, _ref, _ref1;
      _ref = this.paths, p = _ref[0], ps = 2 <= _ref.length ? __slice.call(_ref, 1) : [];
      mainButton = new AdderButton({
        hideType: true,
        model: new PathModel(p)
      });
      opts = (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = ps.length; _i < _len; _i++) {
          p_ = ps[_i];
          _results.push(new Option({
            hideType: true,
            model: new PathModel(p_)
          }));
        }
        return _results;
      })();
      grp = new DropdownButtonGrp({
        main: mainButton,
        options: opts
      });
      _ref1 = [mainButton].concat(__slice.call(opts));
      for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
        b = _ref1[_i];
        this.listenTo(b, 'chosen', this.onChosen);
      }
      return this.renderChild('tree', grp, this.$(OPTS_SEL));
    };

    return ComposedColumnConstraintAdder;

  })(ConstraintAdder);

}).call(this);
