(function() {
  var AdderButton, ConstraintAdder, CoreView, Messages, OPTS_SEL, PathModel, SingleColumnConstraintAdder, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  PathModel = require('../../models/path');

  Templates = require('../../templates');

  Messages = require('../../messages');

  ConstraintAdder = require('../constraint-adder');

  AdderButton = require('./column-adder-button');

  require('../../messages/constraints');

  OPTS_SEL = '.im-constraint-adder-options';

  module.exports = SingleColumnConstraintAdder = (function(_super) {
    __extends(SingleColumnConstraintAdder, _super);

    function SingleColumnConstraintAdder() {
      return SingleColumnConstraintAdder.__super__.constructor.apply(this, arguments);
    }

    SingleColumnConstraintAdder.prototype.parameters = ['query', 'path'];

    SingleColumnConstraintAdder.prototype.initialize = function() {
      var constraint;
      SingleColumnConstraintAdder.__super__.initialize.apply(this, arguments);
      constraint = {
        path: this.path
      };
      return this.model.set({
        constraint: constraint
      });
    };

    SingleColumnConstraintAdder.prototype.events = function() {
      return {
        'click .im-add-constraint': this.act
      };
    };

    SingleColumnConstraintAdder.prototype.act = function() {
      this.hideTree();
      return this.renderConstraintEditor();
    };

    SingleColumnConstraintAdder.prototype.renderOptions = function() {};

    SingleColumnConstraintAdder.prototype.showTree = function() {
      var button, model;
      model = new PathModel(this.query.makePath(this.path));
      button = new AdderButton({
        model: model
      });
      return this.renderChild('tree', new AdderButton({
        model: model
      }), this.$(OPTS_SEL));
    };

    return SingleColumnConstraintAdder;

  })(ConstraintAdder);

}).call(this);
