(function() {
  var ComposedColumnConstraintAdder, Constraints, SingleColumnConstraintAdder, SingleColumnConstraints,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Constraints = require('../constraints');

  SingleColumnConstraintAdder = require('./single-column-adder');

  ComposedColumnConstraintAdder = require('./composed-column-adder');

  module.exports = SingleColumnConstraints = (function(_super) {
    __extends(SingleColumnConstraints, _super);

    function SingleColumnConstraints() {
      return SingleColumnConstraints.__super__.constructor.apply(this, arguments);
    }

    SingleColumnConstraints.prototype.getConAdder = function() {
      var isComposed, outerJoined, path, replaces, _ref;
      if (this.shouldShowAdder()) {
        _ref = this.model.attributes, replaces = _ref.replaces, isComposed = _ref.isComposed, outerJoined = _ref.outerJoined;
        path = this.model.pathInfo();
        if (isComposed && replaces.length > 1) {
          return new ComposedColumnConstraintAdder({
            query: this.query,
            paths: replaces
          });
        } else if (outerJoined) {
          return new ComposedColumnConstraintAdder({
            query: this.query,
            paths: [path].concat(replaces)
          });
        } else {
          return new SingleColumnConstraintAdder({
            query: this.query,
            path: path
          });
        }
      }
    };

    SingleColumnConstraints.prototype.shouldShowAdder = function() {
      var isComposed, numeric, outerJoined, _ref;
      _ref = this.model.attributes, numeric = _ref.numeric, isComposed = _ref.isComposed, outerJoined = _ref.outerJoined;
      return numeric || isComposed || outerJoined || (!this.getConstraints().length);
    };

    SingleColumnConstraints.prototype.getConstraints = function() {
      var c, view, _i, _len, _ref, _results;
      view = this.model.get('path');
      _ref = this.query.constraints;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        c = _ref[_i];
        if (c.path.match(view)) {
          _results.push(c);
        }
      }
      return _results;
    };

    return SingleColumnConstraints;

  })(Constraints);

}).call(this);
