(function() {
  var Bus, CC_NOT_FOUND, Children, CoreView, Dashboard, ERR, History, QueryTools, SelectedObjects, Table, TableModel, Types, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../core-view');

  History = require('../models/history');

  TableModel = require('../models/table');

  SelectedObjects = require('../models/selected-objects');

  Bus = require('../utils/events').Bus;

  Children = require('../utils/children');

  Types = require('../core/type-assertions');

  Table = require('./table');

  QueryTools = require('./query-tools');

  ERR = 'Bad arguments to Dashboard - {query :: imjs.Query} is required';

  CC_NOT_FOUND = 'consumerContainer provided as selector - but no matching element was found';

  module.exports = Dashboard = (function(_super) {
    __extends(Dashboard, _super);

    function Dashboard() {
      return Dashboard.__super__.constructor.apply(this, arguments);
    }

    Dashboard.prototype.tagName = 'div';

    Dashboard.prototype.className = 'imtables-dashboard container-fluid';

    Dashboard.prototype.Model = TableModel;

    Dashboard.prototype.optionalParameters = ['consumerContainer', 'consumerBtnClass'];

    Dashboard.prototype.initialize = function(_arg) {
      var query;
      query = _arg.query;
      if (!Types.Query.test(query)) {
        if (query == null) {
          throw new Error(ERR);
        }
      }
      Dashboard.__super__.initialize.apply(this, arguments);
      this.history = new History;
      this.bus = new Bus;
      this.history.setInitialState(query);
      this.selectedObjects = new SelectedObjects(query.service);
      if ((this.consumerContainer != null) && _.isString(this.consumerContainer)) {
        this.consumerContainer = document.querySelector(this.consumerContainer);
        if (!this.consumerContainer) {
          return console.log(CC_NOT_FOUND);
        }
      }
    };

    Dashboard.prototype.renderChildren = function() {
      this.renderQueryTools();
      return this.renderTable();
    };

    Dashboard.prototype.renderTable = function() {
      var table;
      table = Children.createChild(this, Table);
      return this.renderChild('table', table);
    };

    Dashboard.prototype.renderQueryTools = function() {
      var tools;
      tools = Children.createChild(this, QueryTools, {
        tableState: this.model
      });
      return this.renderChild('tools', tools);
    };

    Dashboard.prototype.remove = function() {
      this.bus.destroy();
      this.history.close();
      return Dashboard.__super__.remove.apply(this, arguments);
    };

    return Dashboard;

  })(CoreView);

}).call(this);
