(function() {
  var Counter, ExportDialogue, ExportDialogueButton, QueryDialogueButton, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  QueryDialogueButton = require('../query-dialogue-button');

  ExportDialogue = require('../export-dialogue');

  Counter = require('../../utils/count-executor');

  module.exports = ExportDialogueButton = (function(_super) {
    __extends(ExportDialogueButton, _super);

    function ExportDialogueButton() {
      return ExportDialogueButton.__super__.constructor.apply(this, arguments);
    }

    ExportDialogueButton.prototype.className = 'im-export-dialogue-button';

    ExportDialogueButton.prototype.longLabel = 'export.ExportQuery';

    ExportDialogueButton.prototype.shortLabel = 'export.Export';

    ExportDialogueButton.prototype.icon = 'Download';

    ExportDialogueButton.prototype.optionalParameters = ['tableState'];

    ExportDialogueButton.prototype.initialize = function() {
      ExportDialogueButton.__super__.initialize.apply(this, arguments);
      return Counter.count(this.query).then((function(_this) {
        return function(count) {
          return _this.state.set({
            disabled: count === 0
          });
        };
      })(this)).then(null, (function(_this) {
        return function(err) {
          return _this.state.set({
            disabled: true,
            error: err
          });
        };
      })(this));
    };

    ExportDialogueButton.prototype.initState = function() {
      return this.state.set({
        name: this.query.name
      });
    };

    ExportDialogueButton.prototype.dialogueOptions = function() {
      var page, _ref;
      page = (_ref = this.tableState) != null ? _ref.pick('start', 'size') : void 0;
      return {
        query: this.query,
        model: {
          tablePage: page
        }
      };
    };

    ExportDialogueButton.prototype.Dialogue = ExportDialogue;

    return ExportDialogueButton;

  })(QueryDialogueButton);

}).call(this);
