(function() {
  var AddColumnControl, ColumnControls, ColumnView, HasTypeaheads, HeadingLabel, LabelView, Messages, PathSet, ResetButton, Templates, View, pathSuggester, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  _ = require('underscore');

  View = require('../../core-view');

  PathSet = require('../../models/path-set');

  LabelView = require('../label-view');

  Messages = require('../../messages');

  Templates = require('../../templates');

  HasTypeaheads = require('../../mixins/has-typeaheads');

  pathSuggester = require('../../utils/path-suggester');

  HeadingLabel = (function(_super) {
    __extends(HeadingLabel, _super);

    function HeadingLabel() {
      return HeadingLabel.__super__.constructor.apply(this, arguments);
    }

    HeadingLabel.prototype.template = _.partial(Messages.getText, 'export.category.Columns');

    return HeadingLabel;

  })(LabelView);

  AddColumnControl = (function(_super) {
    __extends(AddColumnControl, _super);

    function AddColumnControl() {
      return AddColumnControl.__super__.constructor.apply(this, arguments);
    }

    AddColumnControl.include(HasTypeaheads);

    AddColumnControl.prototype.initialize = function(_arg) {
      this.columns = _arg.columns, this.query = _arg.query;
      AddColumnControl.__super__.initialize.apply(this, arguments);
      return this.initSuggestions();
    };

    AddColumnControl.prototype.addSuggestion = function(path) {
      var m;
      if (!this.columns.contains(path)) {
        this.suggestions.add(path);
        m = this.suggestions.get(path);
        return path.getDisplayName(function(error, name) {
          return m.set({
            error: error,
            name: name
          });
        });
      }
    };

    AddColumnControl.prototype.initSuggestions = function() {
      var cn, node, nodes, _i, _len, _results;
      this.suggestions = new PathSet;
      nodes = this.query.getQueryNodes();
      _results = [];
      for (_i = 0, _len = nodes.length; _i < _len; _i++) {
        node = nodes[_i];
        _results.push((function() {
          var _j, _len1, _ref, _results1;
          _ref = node.getChildNodes();
          _results1 = [];
          for (_j = 0, _len1 = _ref.length; _j < _len1; _j++) {
            cn = _ref[_j];
            if (cn.isAttribute()) {
              if (!this.columns.contains(cn)) {
                _results1.push(this.addSuggestion(cn));
              } else {
                _results1.push(void 0);
              }
            }
          }
          return _results1;
        }).call(this));
      }
      return _results;
    };

    AddColumnControl.prototype.postRender = function() {
      var dataset, input, opts;
      input = this.$('input');
      opts = {
        minLength: 1,
        highlight: true
      };
      dataset = {
        name: 'view_suggestions',
        source: pathSuggester(this.suggestions),
        displayKey: 'name'
      };
      this.activateTypeahead(input, opts, dataset, 'Additional paths', (function(_this) {
        return function(e, suggestion) {
          var path;
          path = suggestion.item;
          return _this.columns.add(path, {
            active: true
          });
        };
      })(this));
      return this.$('.im-help').tooltip();
    };

    AddColumnControl.prototype.className = 'col-sm-8';

    AddColumnControl.prototype.template = Templates.template('export_add_column_control');

    return AddColumnControl;

  })(View);

  ResetButton = (function(_super) {
    __extends(ResetButton, _super);

    function ResetButton() {
      return ResetButton.__super__.constructor.apply(this, arguments);
    }

    ResetButton.prototype.className = 'col-sm-4';

    ResetButton.prototype.RERENDER_EVENT = 'change:isAll';

    ResetButton.prototype.initialize = function(_arg) {
      this.query = _arg.query, this.columns = _arg.columns;
      ResetButton.__super__.initialize.apply(this, arguments);
      this.setIsAll();
      return this.listenTo(this.columns, 'change:active', this.setIsAll);
    };

    ResetButton.prototype.setIsAll = function() {
      var c, cols, view;
      view = this.query.views;
      cols = (function() {
        var _i, _len, _ref, _results;
        _ref = this.columns.where({
          active: true
        });
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          c = _ref[_i];
          _results.push(c.get('item').toString());
        }
        return _results;
      }).call(this);
      return this.model.set({
        isAll: _.isEqual(view, cols)
      });
    };

    ResetButton.prototype.template = Templates.template('reset_button');

    ResetButton.prototype.events = function() {
      return {
        'click button': 'reset'
      };
    };

    ResetButton.prototype.reset = function() {
      var view;
      view = this.query.views;
      return this.columns.each(function(c) {
        var path;
        path = c.get('item').toString();
        return c.set({
          active: _.any(view, function(v) {
            return v === path;
          })
        });
      });
    };

    return ResetButton;

  })(View);

  ColumnView = (function(_super) {
    __extends(ColumnView, _super);

    function ColumnView() {
      return ColumnView.__super__.constructor.apply(this, arguments);
    }

    ColumnView.prototype.RERENDER_EVENT = 'change';

    ColumnView.prototype.initialize = function() {
      var path, _ref;
      ColumnView.__super__.initialize.apply(this, arguments);
      if (!this.model.has('active')) {
        this.model.set({
          active: true
        });
      }
      if (!this.model.has('name')) {
        this.model.set({
          name: null
        });
        path = this.model.get('item');
        if (((_ref = this.model.get('item').end) != null ? _ref.name : void 0) === 'id') {
          path = path.getParent();
        }
        return path.getDisplayName((function(_this) {
          return function(error, name) {
            return _this.model.set({
              error: error,
              name: name
            });
          };
        })(this));
      }
    };

    ColumnView.prototype.className = 'list-group-item';

    ColumnView.prototype.events = function() {
      return {
        'click .im-active-state': (function(_this) {
          return function() {
            return _this.model.toggle('active');
          };
        })(this)
      };
    };

    ColumnView.prototype.tagName = 'li';

    ColumnView.prototype.template = Templates.template('export_column_control');

    return ColumnView;

  })(View);

  module.exports = ColumnControls = (function(_super) {
    __extends(ColumnControls, _super);

    function ColumnControls() {
      return ColumnControls.__super__.constructor.apply(this, arguments);
    }

    ColumnControls.prototype.className = 'container-fluid';

    ColumnControls.prototype.initialize = function(_arg) {
      var activeCols, c, format, n, ns, p, v, _i, _j, _k, _len, _len1, _len2, _ref, _ref1;
      this.query = _arg.query;
      ColumnControls.__super__.initialize.apply(this, arguments);
      this.columns = new PathSet;
      format = this.model.get('format');
      activeCols = this.model.get('columns');
      if (!((_ref = format.needs) != null ? _ref.length : void 0)) {
        _ref1 = this.query.views;
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          v = _ref1[_i];
          p = this.query.makePath(v);
          this.columns.add(p, {
            active: _.any(activeCols, function(ac) {
              return ac === v;
            })
          });
        }
      }
      for (_j = 0, _len1 = activeCols.length; _j < _len1; _j++) {
        c = activeCols[_j];
        this.columns.add(this.query.makePath(c), {
          active: true
        });
      }
      if ((ns = this.model.get('nodecolumns'))) {
        for (_k = 0, _len2 = ns.length; _k < _len2; _k++) {
          n = ns[_k];
          this.columns.add(this.query.makePath(n), {
            active: false
          });
        }
      }
      this.listenTo(this.columns, 'add remove reset change:active', this.setColumns);
      return this.listenTo(this.columns, 'add remove reset', this.reRender);
    };

    ColumnControls.prototype.setColumns = function(m) {
      var c, columns, max, newlySelected, others;
      columns = (function() {
        var _i, _len, _ref, _results;
        _ref = this.columns.where({
          active: true
        });
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          c = _ref[_i];
          _results.push(c.get('item').toString());
        }
        return _results;
      }).call(this);
      if ((max = this.model.get('format').maxColumns)) {
        if ((m != null) && columns.length > max) {
          newlySelected = m.get('item').toString();
          others = (function() {
            var _i, _len, _results;
            _results = [];
            for (_i = 0, _len = columns.length; _i < _len; _i++) {
              c = columns[_i];
              if (c !== newlySelected) {
                _results.push(c);
              }
            }
            return _results;
          })();
          columns = [newlySelected].concat(_.first(others, max - 1));
          _.defer((function(_this) {
            return function() {
              var _i, _len, _ref, _ref1, _results;
              _ref = _this.columns.where({
                active: true
              });
              _results = [];
              for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                c = _ref[_i];
                _results.push(c.set({
                  active: (_ref1 = c.get('item').toString(), __indexOf.call(columns, _ref1) >= 0)
                }));
              }
              return _results;
            };
          })(this));
        }
      }
      return this.model.set({
        columns: columns
      });
    };

    ColumnControls.prototype.tagName = 'form';

    ColumnControls.prototype.template = Templates.template('export_column_controls');

    ColumnControls.prototype.postRender = function() {
      var ctrls, ul;
      ul = this.$('ul');
      ctrls = this.$('.controls');
      this.columns.each((function(_this) {
        return function(c, i) {
          return _this.renderChild(i, new ColumnView({
            model: c
          }), ul);
        };
      })(this));
      this.renderChild('reset', new ResetButton({
        query: this.query,
        columns: this.columns
      }), ctrls);
      return this.renderChild('add', new AddColumnControl({
        query: this.query,
        columns: this.columns
      }), ctrls);
    };

    return ColumnControls;

  })(View);

}).call(this);
