(function() {
  var FormatControls, Formats, HeadingView, LabelView, Messages, Templates, View, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  View = require('../../core-view');

  Messages = require('../../messages');

  Templates = require('../../templates');

  LabelView = require('../label-view');

  Formats = require('../../models/export-formats');

  HeadingView = (function(_super) {
    __extends(HeadingView, _super);

    function HeadingView() {
      return HeadingView.__super__.constructor.apply(this, arguments);
    }

    HeadingView.prototype.template = _.partial(Messages.getText, 'export.category.Format');

    return HeadingView;

  })(LabelView);

  module.exports = FormatControls = (function(_super) {
    __extends(FormatControls, _super);

    function FormatControls() {
      return FormatControls.__super__.constructor.apply(this, arguments);
    }

    FormatControls.prototype.tagName = 'form';

    FormatControls.prototype.template = Templates.template('export_format_controls');

    FormatControls.prototype.getData = function() {
      var formats, types;
      types = this.model.get('has');
      formats = Formats.getFormats(types);
      return _.extend({
        formats: formats
      }, FormatControls.__super__.getData.apply(this, arguments));
    };

    FormatControls.prototype.events = function() {
      return {
        'change input:radio': 'onChangeFormat'
      };
    };

    FormatControls.prototype.onChangeFormat = function() {
      return this.model.set({
        format: this.$('input:radio:checked').val()
      });
    };

    FormatControls.prototype.postRender = function() {
      return this.renderChild('heading', new HeadingView({
        model: this.model
      }), this.$('.im-title'));
    };

    return FormatControls;

  })(View);

}).call(this);
