(function() {
  var CoreView, Formats, Messages, PROPS, Preview, RunsQuery, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  Messages = require('../../messages');

  Templates = require('../../templates');

  Formats = require('../../models/export-formats');

  RunsQuery = require('../../mixins/runs-query');

  PROPS = {
    compress: null,
    size: 3
  };

  module.exports = Preview = (function(_super) {
    __extends(Preview, _super);

    function Preview() {
      return Preview.__super__.constructor.apply(this, arguments);
    }

    Preview.include(RunsQuery);

    Preview.prototype.initialize = function(_arg) {
      this.query = _arg.query;
      Preview.__super__.initialize.apply(this, arguments);
      this.state.set({
        preview: ''
      });
      this.setPreview();
      this.listenTo(this.state, 'change:preview', this.reRender);
      return this.listenTo(this.model, 'change:format', this.setPreview);
    };

    Preview.prototype.setPreview = function() {
      var format;
      format = this.model.get('format');
      if (format.group === 'bio') {
        return this.state.set({
          preview: 'Previews are not supported for bio-informatics formats'
        });
      } else {
        return this.runQuery(PROPS).then((function(_this) {
          return function(resp) {
            if (_.isString(resp)) {
              return _this.state.set({
                preview: resp
              });
            } else {
              return _this.state.set({
                preview: JSON.stringify(resp, null, 2)
              });
            }
          };
        })(this));
      }
    };

    Preview.prototype.template = Templates.template('export_preview');

    Preview.prototype.getData = function() {
      var formats, types;
      types = this.model.get('has');
      formats = Formats.getFormats(types);
      return _.extend({
        formats: formats
      }, Preview.__super__.getData.apply(this, arguments));
    };

    Preview.prototype.events = function() {
      return {
        'change .im-export-formats select': 'setFormat'
      };
    };

    Preview.prototype.setFormat = function(e) {
      return this.model.set({
        format: Formats.getFormat(e.target.value)
      });
    };

    return Preview;

  })(CoreView);

}).call(this);
