(function() {
  var HeadingLabel, LabelView, Messages, OffsetLabel, ResetButton, RowControls, SizeLabel, Templates, View, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  View = require('../../core-view');

  LabelView = require('../label-view');

  Messages = require('../../messages');

  Templates = require('../../templates');

  SizeLabel = (function(_super) {
    __extends(SizeLabel, _super);

    function SizeLabel() {
      return SizeLabel.__super__.constructor.apply(this, arguments);
    }

    SizeLabel.prototype.getData = function() {
      return {
        size: this.model.get('size') || Messages.getText('rows.All')
      };
    };

    SizeLabel.prototype.template = _.partial(Messages.getText, 'export.param.Size');

    return SizeLabel;

  })(LabelView);

  OffsetLabel = (function(_super) {
    __extends(OffsetLabel, _super);

    function OffsetLabel() {
      return OffsetLabel.__super__.constructor.apply(this, arguments);
    }

    OffsetLabel.prototype.template = _.partial(Messages.getText, 'export.param.Start');

    return OffsetLabel;

  })(LabelView);

  HeadingLabel = (function(_super) {
    __extends(HeadingLabel, _super);

    function HeadingLabel() {
      return HeadingLabel.__super__.constructor.apply(this, arguments);
    }

    HeadingLabel.prototype.template = _.partial(Messages.getText, 'export.category.Rows');

    return HeadingLabel;

  })(LabelView);

  ResetButton = (function(_super) {
    __extends(ResetButton, _super);

    function ResetButton() {
      return ResetButton.__super__.constructor.apply(this, arguments);
    }

    ResetButton.prototype.RERENDER_EVENT = 'change';

    ResetButton.prototype.getData = function() {
      return _.extend(ResetButton.__super__.getData.apply(this, arguments), {
        isAll: !(this.model.get('start') || this.model.get('size'))
      });
    };

    ResetButton.prototype.template = Templates.template('export_rows_reset_button');

    ResetButton.prototype.events = function() {
      return {
        'click .btn-reset': 'reset',
        'click .im-set-table-page': 'setTablePage'
      };
    };

    ResetButton.prototype.reset = function() {
      return this.model.set({
        start: 0,
        size: null
      });
    };

    ResetButton.prototype.setTablePage = function() {
      return this.model.set(this.model.get('tablePage'));
    };

    return ResetButton;

  })(View);

  module.exports = RowControls = (function(_super) {
    __extends(RowControls, _super);

    function RowControls() {
      return RowControls.__super__.constructor.apply(this, arguments);
    }

    RowControls.prototype.RERENDER_EVENT = 'change:max';

    RowControls.prototype.initialize = function() {
      RowControls.__super__.initialize.apply(this, arguments);
      if (!this.model.has('max')) {
        this.model.set({
          max: null
        });
      }
      this.listenTo(this.model, 'change:size', this.updateLabels);
      return this.listenTo(this.model, 'change:size change:start', this.updateInputs);
    };

    RowControls.prototype.tagName = 'form';

    RowControls.prototype.template = Templates.template('export_row_controls');

    RowControls.prototype.events = function() {
      return {
        'input input[name=size]': 'onChangeSize',
        'input input[name=start]': 'onChangeStart'
      };
    };

    RowControls.prototype.updateInputs = function() {
      var max, size, start, _ref;
      _ref = this.model.toJSON(), start = _ref.start, size = _ref.size, max = _ref.max;
      this.$("input[name=size]").val(size || max);
      return this.$("input[name=start]").val(start);
    };

    RowControls.prototype.onChangeSize = function() {
      var size;
      size = parseInt(this.$('input[name=size]').val(), 10);
      if ((!size) || (size === this.model.get('max'))) {
        return this.model.set({
          size: null
        });
      } else {
        return this.model.set({
          size: size
        });
      }
    };

    RowControls.prototype.onChangeStart = function() {
      return this.model.set({
        start: parseInt(this.$('input[name=start]').val(), 10)
      });
    };

    RowControls.prototype.postRender = function() {
      this.renderChild('heading', new HeadingLabel({
        model: this.state
      }), this.$('.im-title'));
      this.renderChild('size', new SizeLabel({
        model: this.model
      }), this.$('.size-label'));
      this.renderChild('start', new OffsetLabel({
        model: this.model
      }), this.$('.start-label'));
      return this.renderChild('reset', new ResetButton({
        model: this.model
      }), this.$('.im-reset'));
    };

    return RowControls;

  })(View);

}).call(this);
