(function() {
  var CoreView, FacetItems, NoResults, OnlyOneItem, REQ_ATTRS, SummaryItems, SummaryStats, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  Templates = require('../../templates');

  SummaryStats = require('./summary-stats');

  SummaryItems = require('./summary-items');

  OnlyOneItem = require('./only-one-item');

  NoResults = require('./no-results');

  REQ_ATTRS = ['error', 'initialized'];

  module.exports = FacetItems = (function(_super) {
    __extends(FacetItems, _super);

    function FacetItems() {
      return FacetItems.__super__.constructor.apply(this, arguments);
    }

    FacetItems.prototype.className = 'im-facet-items';

    FacetItems.prototype.initialize = function(_arg) {
      this.range = _arg.range;
      return FacetItems.__super__.initialize.apply(this, arguments);
    };

    FacetItems.prototype.invariants = function() {
      return {
        modelHasRequiredAttrs: "Model only has the following attributes: " + (_.keys(this.model.attributes))
      };
    };

    FacetItems.prototype.modelHasRequiredAttrs = function() {
      return (_.intersection(REQ_ATTRS, _.keys(this.model.attributes))).length === 2;
    };

    FacetItems.prototype.modelEvents = function() {
      return {
        destroy: this.stopListening
      };
    };

    FacetItems.prototype.template = Templates.template('facet_frequency');

    FacetItems.prototype.RERENDER_EVENT = 'change:error change:numeric change:uniqueValues change:initialized';

    FacetItems.prototype.postRender = function() {
      if (this.model.get('initialized')) {
        return this.renderChild('items', this.getItems());
      }
    };

    FacetItems.prototype.getItems = function() {
      switch (false) {
        case !this.model.get('numeric'):
          return new SummaryStats({
            model: this.model,
            range: this.range
          });
        case !(this.model.get('uniqueValues') > 1):
          return new SummaryItems({
            model: this.model
          });
        case this.model.get('uniqueValues') !== 1:
          return new OnlyOneItem({
            model: this.model,
            state: this.state
          });
        default:
          return new NoResults({
            model: this.state
          });
      }
    };

    return FacetItems;

  })(CoreView);

}).call(this);
