(function() {
  var CoreView, FacetVisualisation, Histogram, NumericDistribution, Options, PieChart, SummaryItems,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Options = require('../../options');

  CoreView = require('../../core-view');

  NumericDistribution = require('./numeric');

  PieChart = require('./pie');

  Histogram = require('./histogram');

  SummaryItems = require('./summary-items');

  module.exports = FacetVisualisation = (function(_super) {
    __extends(FacetVisualisation, _super);

    function FacetVisualisation() {
      return FacetVisualisation.__super__.constructor.apply(this, arguments);
    }

    FacetVisualisation.prototype.className = 'im-facet-vis';

    FacetVisualisation.prototype.initialize = function(_arg) {
      this.range = _arg.range;
      return FacetVisualisation.__super__.initialize.apply(this, arguments);
    };

    FacetVisualisation.prototype.RERENDER_EVENT = 'change:loading change:numeric change:canHaveMultipleValues';

    FacetVisualisation.prototype.postRender = function() {
      if (this.model.get('initialized')) {
        return this.renderChild('vis', this.getVisualization());
      }
    };

    FacetVisualisation.prototype.getVisualization = function(args) {
      var canHaveMultipleValues, got, numeric, type, uniqueValues, _ref;
      _ref = this.model.toJSON(), uniqueValues = _ref.uniqueValues, numeric = _ref.numeric, canHaveMultipleValues = _ref.canHaveMultipleValues, type = _ref.type, got = _ref.got;
      switch (false) {
        case !numeric:
          return new NumericDistribution({
            model: this.model,
            range: this.range
          });
        case uniqueValues !== 1:
          return null;
        case !canHaveMultipleValues:
          return new Histogram({
            model: this.model
          });
        case !((0 < uniqueValues && uniqueValues <= (Options.get('MAX_PIE_SLICES')))):
          return new PieChart({
            model: this.model
          });
        case !got:
          return new Histogram({
            model: this.model
          });
        default:
          return null;
      }
    };

    return FacetVisualisation;

  })(CoreView);

}).call(this);
