(function() {
  var CoreView, FormattedSorting, SortedPath, Templates, sortQueryByPath,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  CoreView = require('../core-view');

  Templates = require('../templates');

  SortedPath = require('./formatted/sorting-path');

  sortQueryByPath = require('../utils/sort-query-by-path');

  module.exports = FormattedSorting = (function(_super) {
    __extends(FormattedSorting, _super);

    function FormattedSorting() {
      return FormattedSorting.__super__.constructor.apply(this, arguments);
    }

    FormattedSorting.prototype.className = 'im-col-sort-menu no-margins';

    FormattedSorting.prototype.tagName = 'ul';

    FormattedSorting.prototype.initialize = function(_arg) {
      this.query = _arg.query;
      FormattedSorting.__super__.initialize.apply(this, arguments);
      return this.setPathNames();
    };

    FormattedSorting.prototype.modelEvents = function() {
      return {
        'change:displayName': this.initState,
        'change:replaces': this.setPathNames
      };
    };

    FormattedSorting.prototype.initState = function() {
      return this.state.set({
        group: this.model.get('displayName')
      });
    };

    FormattedSorting.prototype.setPathNames = function() {
      var p, _i, _len, _ref, _results;
      _ref = this.getPaths();
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        p = _ref[_i];
        _results.push((function(_this) {
          return function(p) {
            var key;
            key = p.toString();
            if (!_this.state.has(key)) {
              _this.state.set(key, '');
            }
            return p.getDisplayName().then(function(name) {
              return _this.state.set(key, name);
            });
          };
        })(this)(p));
      }
      return _results;
    };

    FormattedSorting.prototype.getPaths = function() {
      var replaces;
      replaces = this.model.get('replaces');
      if (replaces.length) {
        return replaces.slice();
      } else {
        return [this.query.makePath(this.model.get('path'))];
      }
    };

    FormattedSorting.prototype.preRender = function(e) {
      var path, paths;
      path = (paths = this.getPaths())[0];
      if (paths.length === 1) {
        e.cancel();
        return sortQueryByPath(this.query, path);
      }
    };

    FormattedSorting.prototype.postRender = function() {
      var i, p, _i, _len, _ref, _results;
      _ref = this.getPaths();
      _results = [];
      for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
        p = _ref[i];
        _results.push(this.renderChild(i, new SortedPath({
          model: this.model,
          state: this.state,
          query: this.query,
          path: p
        })));
      }
      return _results;
    };

    return FormattedSorting;

  })(CoreView);

}).call(this);
