(function() {
  var CoreView, INITIAL_CARETS, Icons, SortedPath, Templates, sortQueryByPath,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  CoreView = require('../../core-view');

  Templates = require('../../templates');

  Icons = require('../../icons');

  sortQueryByPath = require('../../utils/sort-query-by-path');

  INITIAL_CARETS = /^\s*>\s*/;

  module.exports = SortedPath = (function(_super) {
    __extends(SortedPath, _super);

    function SortedPath() {
      return SortedPath.__super__.constructor.apply(this, arguments);
    }

    SortedPath.prototype.tagName = 'li';

    SortedPath.prototype.className = 'im-formatted-path im-subpath';

    SortedPath.prototype.parameters = ['query', 'path'];

    SortedPath.prototype.stateEvents = function() {
      return {
        change: this.reRender
      };
    };

    SortedPath.prototype.getData = function() {
      var direction, name, names, _ref;
      names = this.state.toJSON();
      name = (_ref = names[this.path]) != null ? _ref.replace(names.group, '').replace(INITIAL_CARETS, '') : void 0;
      direction = this.query.getSortDirection(this.path);
      return {
        Icons: Icons,
        name: name,
        direction: direction
      };
    };

    SortedPath.prototype.template = Templates.template('formatted_sorting');

    SortedPath.prototype.events = function() {
      return {
        click: 'sortByPath'
      };
    };

    SortedPath.prototype.sortByPath = function() {
      return sortQueryByPath(this.query, this.path);
    };

    return SortedPath;

  })(CoreView);

}).call(this);
