(function() {
  var AttrDetailsModel, Collection, CoreModel, CoreView, CountsTitle, DetailsModel, ERROR, HIDDEN_FIELDS, ItemDetails, Options, PathModel, Preview, PreviewModel, Promise, RefDetailsModel, ReferenceCounts, ServiceType, SortedByName, Templates, acceptAttr, acceptRef, cantFindField, concat, getLeaves, types, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  _ = require('underscore');

  Promise = require('es6-promise').Promise;

  Templates = require('../templates');

  CoreView = require('../core-view');

  CoreModel = require('../core-model');

  Options = require('../options');

  Collection = require('../core/collection');

  PathModel = require('../models/path');

  types = require('../core/type-assertions');

  getLeaves = require('../utils/get-leaves');

  ItemDetails = require('./item-preview/details');

  ReferenceCounts = require('./item-preview/reference-counts');

  CountsTitle = require('./item-preview/counts-title');

  cantFindField = function(fld, types) {
    return "Could not determine origin of " + fld + " from [" + (types.join(', ')) + "]";
  };

  DetailsModel = (function(_super) {
    __extends(DetailsModel, _super);

    function DetailsModel(opts) {
      DetailsModel.__super__.constructor.call(this, opts.path);
      this.set(_.omit(opts, 'path'));
    }

    return DetailsModel;

  })(PathModel);

  AttrDetailsModel = (function(_super) {
    __extends(AttrDetailsModel, _super);

    function AttrDetailsModel() {
      return AttrDetailsModel.__super__.constructor.apply(this, arguments);
    }

    AttrDetailsModel.prototype.defaults = function() {
      return _.extend(AttrDetailsModel.__super__.defaults.apply(this, arguments), {
        fieldType: 'ATTR',
        valueOverspill: null,
        tooLong: false,
        value: null
      });
    };

    return AttrDetailsModel;

  })(DetailsModel);

  RefDetailsModel = (function(_super) {
    __extends(RefDetailsModel, _super);

    function RefDetailsModel() {
      return RefDetailsModel.__super__.constructor.apply(this, arguments);
    }

    RefDetailsModel.prototype.defaults = function() {
      return _.extend(RefDetailsModel.__super__.defaults.apply(this, arguments), {
        fieldType: 'REF',
        values: []
      });
    };

    return RefDetailsModel;

  })(DetailsModel);

  SortedByName = (function(_super) {
    __extends(SortedByName, _super);

    function SortedByName() {
      return SortedByName.__super__.constructor.apply(this, arguments);
    }

    SortedByName.prototype.comparator = 'displayName';

    SortedByName.prototype.initialize = function() {
      return this.listenTo(this, 'change:displayName', this.sort);
    };

    return SortedByName;

  })(Collection);

  PreviewModel = (function(_super) {
    __extends(PreviewModel, _super);

    function PreviewModel() {
      return PreviewModel.__super__.constructor.apply(this, arguments);
    }

    PreviewModel.prototype.defaults = function() {
      return {
        types: [],
        id: null,
        error: null,
        phase: 'FETCHING'
      };
    };

    return PreviewModel;

  })(CoreModel);

  ERROR = Templates.template('cell-preview-error');

  HIDDEN_FIELDS = ['class', 'objectId'];

  concat = function(xs, ys) {
    return xs.concat(ys);
  };

  acceptAttr = function() {
    return function(f, v) {
      return (v != null) && (!v.objectId) && (__indexOf.call(HIDDEN_FIELDS, f) < 0);
    };
  };

  acceptRef = function() {
    return function(f, v) {
      return v != null ? v.objectId : void 0;
    };
  };

  ServiceType = new types.Structure('ServiceType', {
    root: types.String,
    count: types.Function,
    findById: types.Function,
    fetchModel: types.Function
  });

  module.exports = Preview = (function(_super) {
    __extends(Preview, _super);

    function Preview() {
      this.handleItem = __bind(this.handleItem, this);
      return Preview.__super__.constructor.apply(this, arguments);
    }

    Preview.prototype.Model = PreviewModel;

    Preview.prototype.className = 'im-cell-preview-inner';

    Preview.prototype.parameters = ['service'];

    Preview.prototype.parameterTypes = {
      service: ServiceType
    };

    Preview.prototype.initialize = function() {
      Preview.__super__.initialize.apply(this, arguments);
      this.fieldDetails = new SortedByName;
      return this.referenceFields = new SortedByName;
    };

    Preview.prototype.modelEvents = function() {
      return {
        'change:phase': this.reRender,
        'change:error': this.reRender
      };
    };

    Preview.prototype.remove = function() {
      this.removeAllChildren();
      this.fieldDetails.close();
      this.referenceFields.close();
      delete this.fieldDetails;
      delete this.referenceFields;
      return Preview.__super__.remove.apply(this, arguments);
    };

    Preview.prototype.fetching = null;

    Preview.prototype.template = function(_arg) {
      var error, phase;
      phase = _arg.phase, error = _arg.error;
      switch (phase) {
        case 'FETCHING':
          return this.helpers().IndeterminateProgressBar;
        case 'ERROR':
          return ERROR(error);
        default:
          return null;
      }
    };

    Preview.prototype.preRender = function() {
      var m;
      m = this.model;
      if (this.fetching == null) {
        this.fetching = this.fetchData();
      }
      return this.fetching.then((function() {
        return m.set({
          phase: 'SUCCESS'
        });
      }), function(e) {
        console.error(e);
        return m.set({
          phase: 'ERROR',
          error: e
        });
      });
    };

    Preview.prototype.postRender = function() {
      var t, _i, _len, _ref, _results;
      if ('SUCCESS' === this.model.get('phase')) {
        _ref = this.model.get('types');
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          t = _ref[_i];
          _results.push(this.$el.addClass(t));
        }
        return _results;
      }
    };

    Preview.prototype.renderChildren = function() {
      var countsTitle, itemDetailsTable, referenceCounts;
      itemDetailsTable = new ItemDetails({
        collection: this.fieldDetails
      });
      this.renderChild('details', itemDetailsTable);
      countsTitle = new CountsTitle({
        collection: this.referenceFields
      });
      this.renderChild('counttitle', countsTitle);
      referenceCounts = new ReferenceCounts({
        collection: this.referenceFields
      });
      this.renderChild('counts', referenceCounts);
      return this.$el.append(Templates.clear);
    };

    Preview.prototype.fetchData = function() {
      return this.service.fetchModel().then((function(_this) {
        return function(schema) {
          var gettingCounts, gettingDetails;
          _this.schema = schema;
          gettingDetails = _this.getAllDetails();
          gettingCounts = _this.getRelationCounts();
          return Promise.all(gettingDetails.concat(gettingCounts));
        };
      })(this));
    };

    Preview.prototype.getAllDetails = function() {
      var t, _i, _len, _ref, _results;
      _ref = this.model.get('types');
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        t = _ref[_i];
        _results.push(this.getDetails(t));
      }
      return _results;
    };

    Preview.prototype.getDetails = function(type) {
      var fields, id;
      id = this.model.get('id');
      fields = Options.get(['ItemDetails', 'Fields', this.schema.name, type]);
      return this.service.findById(type, id, fields).then(this.handleItem);
    };

    Preview.prototype.handleItem = function(item) {
      var clds, coll, field, t, testAttr, testRef, value;
      coll = this.fieldDetails;
      testAttr = acceptAttr(coll);
      testRef = acceptRef(coll);
      clds = (function() {
        var _i, _len, _ref, _results;
        _ref = this.model.get('types');
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          t = _ref[_i];
          _results.push(this.schema.classes[t]);
        }
        return _results;
      }).call(this);
      for (field in item) {
        value = item[field];
        if (testAttr(field, value)) {
          this.handleAttribute(item, clds, field, value);
        }
      }
      for (field in item) {
        value = item[field];
        if (testRef(field, value)) {
          this.handleSubObj(item, clds, field, value);
        }
      }
      return null;
    };

    Preview.prototype.getPathForField = function(clds, field) {
      var cld, path;
      cld = _.find(clds, function(c) {
        return c.fields[field] != null;
      });
      if (cld == null) {
        throw new Error(cantFindField(field, _.pick(clds, 'name')));
      }
      return path = this.schema.makePath("" + cld.name + "." + field);
    };

    Preview.prototype.handleSubObj = function(item, clds, field, value) {
      var details, path, values;
      path = this.getPathForField(clds, field);
      values = getLeaves(value, HIDDEN_FIELDS);
      details = {
        path: path,
        field: field,
        values: values
      };
      return this.fieldDetails.add(new RefDetailsModel(details));
    };

    Preview.prototype.handleAttribute = function(item, clds, field, rawValue) {
      var cuttoff, details, path, snipPoint, tooLong, valueString;
      path = this.getPathForField(clds, field);
      details = {
        path: path,
        field: field,
        value: rawValue
      };
      if ((rawValue != null) && (path.getType() === 'String') || (/Clob/.test(path.getType()))) {
        cuttoff = Options.get('CellCutoff');
        valueString = String(rawValue);
        tooLong = rawValue.length > cuttoff;
        if (tooLong) {
          snipPoint = valueString.indexOf(' ', cuttoff * 0.9);
          if (snipPoint === -1) {
            snipPoint = cuttoff;
          }
          details.tooLong = true;
          details.valueOverspill = valueString.substring(snipPoint);
          details.value = valueString.substring(0, snipPoint);
        }
      }
      return this.fieldDetails.add(new AttrDetailsModel(details));
    };

    Preview.prototype.getRelationCounts = function() {
      var c, cld, countSets, opts, root, settings, type, _ref;
      types = this.model.get('types');
      root = this.service.root;
      opts = (_ref = Options.get(['ItemDetails', 'Count', root])) != null ? _ref : {};
      countSets = (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = types.length; _i < _len; _i++) {
          type = types[_i];
          cld = this.schema.classes[type];
          _results.push((function() {
            var _j, _len1, _ref1, _ref2, _results1;
            _ref2 = (_ref1 = opts[type]) != null ? _ref1 : (function() {
              var _results2;
              _results2 = [];
              for (c in cld.collections) {
                _results2.push(c);
              }
              return _results2;
            })();
            _results1 = [];
            for (_j = 0, _len1 = _ref2.length; _j < _len1; _j++) {
              settings = _ref2[_j];
              _results1.push(this.getRelationCount(settings, type));
            }
            return _results1;
          }).call(this));
        }
        return _results;
      }).call(this);
      return countSets.reduce(concat, []);
    };

    Preview.prototype.getRelationCount = function(settings, type) {
      var counter, details, id, label, path, query, _ref;
      id = this.model.get('id');
      if (_.isObject(settings)) {
        query = settings.query, label = settings.label;
        counter = query(id);
        details = function(c) {
          return new CoreModel({
            parts: [label],
            id: label,
            displayName: label,
            count: c
          });
        };
      } else {
        path = this.schema.makePath("" + type + "." + settings);
        if (!((_ref = path.getType()) != null ? _ref.attributes.id : void 0)) {
          return Promise.resolve(true);
        }
        counter = {
          select: [settings + '.id'],
          from: type,
          where: {
            id: id
          }
        };
        details = function(c) {
          return new DetailsModel({
            path: path,
            count: c
          });
        };
      }
      return this.service.count(counter).then(details).then((function(_this) {
        return function(d) {
          if (d.get('count')) {
            return _this.referenceFields.add(d);
          }
        };
      })(this));
    };

    return Preview;

  })(CoreView);

}).call(this);
