(function() {
  var ATTR, CoreView, ITEMS, ItemDetails, REFERENCE, Templates, ignore, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  Templates = require('../../templates');

  CoreView = require('../../core-view');

  ignore = require('../../utils/events').ignore;

  ITEMS = Templates.template('cell-preview-items');

  REFERENCE = Templates.template('cell-preview-reference');

  ATTR = Templates.template('cell-preview-attribute');

  module.exports = ItemDetails = (function(_super) {
    __extends(ItemDetails, _super);

    function ItemDetails() {
      return ItemDetails.__super__.constructor.apply(this, arguments);
    }

    ItemDetails.prototype.tagName = 'table';

    ItemDetails.prototype.className = 'im-item-details table table-condensed table-bordered';

    ItemDetails.prototype.template = ITEMS;

    ItemDetails.prototype.collectionEvents = function() {
      return {
        sort: this.reRender,
        add: this.addDetail
      };
    };

    ItemDetails.prototype.events = function() {
      return {
        'click .im-too-long': this.revealLongField
      };
    };

    ItemDetails.prototype.postRender = function() {
      return this.collection.each((function(_this) {
        return function(details) {
          return _this.addDetail(details);
        };
      })(this));
    };

    ItemDetails.prototype.addDetail = function(details) {
      return this.$el.append(this['render' + details.get('fieldType')](details.toJSON()));
    };

    ItemDetails.prototype.renderATTR = function(data) {
      return ATTR(_.extend(this.getBaseData(), data));
    };

    ItemDetails.prototype.renderREF = REFERENCE;

    ItemDetails.prototype.revealLongField = function(e) {
      var $overSpill, $tooLong;
      ignore(e);
      $tooLong = this.$('.im-too-long');
      $overSpill = this.$('.im-overspill');
      $tooLong.remove();
      return $overSpill.slideDown(250);
    };

    return ItemDetails;

  })(CoreView);

}).call(this);
