(function() {
  var Body, CoreView, FilterDialogue, Joins, Messages, Modal, areEql, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../core-view');

  Messages = require('../messages');

  Modal = require('./modal');

  Body = require('./join-manager/body');

  Joins = require('../models/joins');

  require('../messages/joins');

  areEql = function(xs, ys) {
    return (xs.length === ys.length) && (_.all(xs, function(x, i) {
      return x === ys[i];
    }));
  };

  module.exports = FilterDialogue = (function(_super) {
    __extends(FilterDialogue, _super);

    function FilterDialogue() {
      return FilterDialogue.__super__.constructor.apply(this, arguments);
    }

    FilterDialogue.prototype.parameters = ['query'];

    FilterDialogue.prototype.className = function() {
      return FilterDialogue.__super__.className.apply(this, arguments) + ' im-join-manager';
    };

    FilterDialogue.prototype.title = function() {
      return Messages.getText('joins.Heading');
    };

    FilterDialogue.prototype.dismissAction = function() {
      return Messages.getText('Cancel');
    };

    FilterDialogue.prototype.primaryAction = function() {
      return Messages.getText('modal.ApplyChanges');
    };

    FilterDialogue.prototype.initialize = function() {
      FilterDialogue.__super__.initialize.apply(this, arguments);
      this.joins = Joins.fromQuery(this.query);
      return this.listenTo(this.joins, 'change:style', this.setDisabled);
    };

    FilterDialogue.prototype.initState = function() {
      return this.state.set({
        disabled: true
      });
    };

    FilterDialogue.prototype.act = function() {
      var newJoins;
      if (!this.state.get('disabled')) {
        newJoins = this.joins.getJoins();
        this.query.joins = newJoins;
        this.query.trigger('change:joins', newJoins);
        return this.resolve(newJoins);
      }
    };

    FilterDialogue.prototype.setDisabled = function() {
      var current, initial, p, s;
      current = _.keys(this.joins.getJoins());
      initial = (function() {
        var _ref, _results;
        _ref = this.query.joins;
        _results = [];
        for (p in _ref) {
          s = _ref[p];
          if (s === 'OUTER') {
            _results.push(p);
          }
        }
        return _results;
      }).call(this);
      current.sort();
      initial.sort();
      return this.state.set({
        disabled: areEql(current, initial)
      });
    };

    FilterDialogue.prototype.postRender = function() {
      var body;
      FilterDialogue.__super__.postRender.apply(this, arguments);
      body = this.$('.modal-body');
      return this.renderChild('cons', new Body({
        collection: this.joins
      }), body);
    };

    return FilterDialogue;

  })(Modal);

}).call(this);
