(function() {
  var BtnClasses, ClassSet, CoreView, Join, JoinManagerBody, LINE_PARTS, Templates, otherStyle, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  Templates = require('../../templates');

  ClassSet = require('../../utils/css-class-set');

  require('../../messages/joins');

  LINE_PARTS = ['join-style', 'column-manager-path-name', 'clear'];

  BtnClasses = (function(_super) {
    __extends(BtnClasses, _super);

    function BtnClasses(model, style) {
      BtnClasses.__super__.constructor.call(this, {
        'btn btn-default': true,
        active: function() {
          return style === model.get('style');
        }
      });
    }

    return BtnClasses;

  })(ClassSet);

  otherStyle = function(style) {
    switch (style) {
      case 'INNER':
        return 'OUTER';
      case 'OUTER':
        return 'INNER';
      default:
        return 'INNER';
    }
  };

  Join = (function(_super) {
    __extends(Join, _super);

    function Join() {
      return Join.__super__.constructor.apply(this, arguments);
    }

    Join.prototype.tagName = 'li';

    Join.prototype.className = 'list-group-item';

    Join.prototype.template = Templates.templateFromParts(LINE_PARTS);

    Join.prototype.modelEvents = function() {
      return {
        'change:style change:parts': this.reRender
      };
    };

    Join.prototype.initialize = function() {
      Join.__super__.initialize.apply(this, arguments);
      return this.classSets = {
        innerJoinBtn: new BtnClasses(this.model, 'INNER'),
        outerJoinBtn: new BtnClasses(this.model, 'OUTER')
      };
    };

    Join.prototype.getData = function() {
      return _.extend(Join.__super__.getData.apply(this, arguments), this.classSets);
    };

    Join.prototype.events = function() {
      return {
        'click button': this.onButtonClick
      };
    };

    Join.prototype.onButtonClick = function(e) {
      if (/active/.test(e.target.className)) {
        return;
      }
      return this.model.swap('style', otherStyle);
    };

    return Join;

  })(CoreView);

  module.exports = JoinManagerBody = (function(_super) {
    __extends(JoinManagerBody, _super);

    function JoinManagerBody() {
      return JoinManagerBody.__super__.constructor.apply(this, arguments);
    }

    JoinManagerBody.prototype.template = Templates.template('join-manager-body');

    JoinManagerBody.prototype.initState = function() {
      return this.state.set({
        explaining: false
      });
    };

    JoinManagerBody.prototype.postRender = function() {
      this.$group = this.$('.list-group');
      return this.collection.each((function(_this) {
        return function(m) {
          return _this.addJoin(m);
        };
      })(this));
    };

    JoinManagerBody.prototype.addJoin = function(model) {
      if (this.rendered) {
        return this.renderChild(model.id, new Join({
          model: model
        }), this.$group);
      }
    };

    JoinManagerBody.prototype.removeJoin = function(model) {
      return this.removeChild(model.id);
    };

    JoinManagerBody.prototype.events = function() {
      return {
        'click .alert-info strong': function() {
          return this.state.toggle('explaining');
        }
      };
    };

    JoinManagerBody.prototype.stateEvents = function() {
      return {
        'change:explaining': this.onChangeExplaining
      };
    };

    JoinManagerBody.prototype.collectionEvents = function() {
      return {
        add: this.addJoin,
        remove: this.removeJoin,
        sort: this.reRender
      };
    };

    JoinManagerBody.prototype.onChangeExplaining = function() {
      var meth, p;
      if (this.rendered) {
        p = this.$('.alert-info p');
        meth = this.state.get('explaining') ? 'slideDown' : 'slideUp';
        return p[meth]();
      }
    };

    return JoinManagerBody;

  })(CoreView);

}).call(this);
