(function() {
  var ABSTRACT, BaseCreateListDialogue, CreateListModel, ListDialogueBody, Messages, Modal, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  Modal = require('../modal');

  Messages = require('../../messages');

  CreateListModel = require('../../models/create-list');

  ListDialogueBody = require('./body');

  require('../../messages/lists');

  ABSTRACT = function() {
    throw new Error('not implemented');
  };

  module.exports = BaseCreateListDialogue = (function(_super) {
    __extends(BaseCreateListDialogue, _super);

    function BaseCreateListDialogue() {
      return BaseCreateListDialogue.__super__.constructor.apply(this, arguments);
    }

    BaseCreateListDialogue.prototype.getQuery = ABSTRACT;

    BaseCreateListDialogue.prototype.fetchCount = ABSTRACT;

    BaseCreateListDialogue.prototype.getType = ABSTRACT;

    BaseCreateListDialogue.prototype.getService = function() {
      return ABSTRACT;
    };

    BaseCreateListDialogue.prototype.Model = CreateListModel;

    BaseCreateListDialogue.prototype.Body = ListDialogueBody;

    BaseCreateListDialogue.prototype.className = function() {
      return BaseCreateListDialogue.__super__.className.apply(this, arguments) + ' im-list-dialogue im-create-list';
    };

    BaseCreateListDialogue.prototype.title = function() {
      return Messages.getText('lists.CreateListTitle', this.getData());
    };

    BaseCreateListDialogue.prototype.primaryAction = function() {
      return Messages.getText('lists.Create');
    };

    BaseCreateListDialogue.prototype.act = function() {
      return this.getQuery().then((function(_this) {
        return function(toRun) {
          return _this.processQuery(toRun);
        };
      })(this)).then(this.resolve, (function(_this) {
        return function(e) {
          return _this.state.set({
            error: e
          });
        };
      })(this));
    };

    BaseCreateListDialogue.prototype.verifyState = function() {
      return this.state.set({
        error: null
      });
    };

    BaseCreateListDialogue.prototype.processQuery = function(query) {
      return query.saveAsList(this.model.toJSON());
    };

    BaseCreateListDialogue.prototype.modelEvents = function() {
      return {
        'change:type': 'onChangeType'
      };
    };

    BaseCreateListDialogue.prototype.onChangeType = function() {
      return this.setTypeName();
    };

    BaseCreateListDialogue.prototype.stateEvents = function() {
      return {
        'change:typeName change:count': 'setTitle',
        'change:typeName': 'setListName',
        'change:error': function() {
          return console.log(this.state.get('error'));
        }
      };
    };

    BaseCreateListDialogue.prototype.setTitle = function() {
      return this.$('.modal-title').text(this.title());
    };

    BaseCreateListDialogue.prototype.setListName = function() {
      return this.model.set({
        name: Messages.getText('lists.DefaultName', this.state.toJSON())
      });
    };

    BaseCreateListDialogue.prototype.initState = function() {
      this.state.set({
        existingLists: {},
        minimised: _.result(this, 'initiallyMinimised')
      });
      this.setTypeName();
      this.setCount();
      this.checkAuth();
      return this.getService().fetchLists().then(function(ls) {
        return _.where(ls, {
          authorized: true
        });
      }).then(function(ls) {
        return _.groupBy(ls, 'name');
      }).then((function(_this) {
        return function(existingLists) {
          return _this.state.set({
            existingLists: existingLists
          });
        };
      })(this));
    };

    BaseCreateListDialogue.prototype.setCount = function() {
      return this.fetchCount().then((function(_this) {
        return function(count) {
          return _this.state.set({
            count: count
          });
        };
      })(this)).then(null, (function(_this) {
        return function(e) {
          return _this.state.set({
            error: e
          });
        };
      })(this));
    };

    BaseCreateListDialogue.prototype.setTypeName = function() {
      var _ref;
      return (_ref = this.getType()) != null ? _ref.getDisplayName().then((function(_this) {
        return function(typeName) {
          return _this.state.set({
            typeName: typeName
          });
        };
      })(this)).then(null, (function(_this) {
        return function(e) {
          return _this.state.set({
            error: e
          });
        };
      })(this)) : void 0;
    };

    BaseCreateListDialogue.prototype.checkAuth = function() {
      return this.getService().whoami().then(null, (function(_this) {
        return function() {
          return _this.state.set({
            error: {
              level: 'Error',
              key: 'lists.error.MustBeLoggedIn'
            }
          });
        };
      })(this));
    };

    BaseCreateListDialogue.prototype.getBodyOptions = function() {
      return {
        model: this.model,
        state: this.state
      };
    };

    BaseCreateListDialogue.prototype.postRender = function() {
      BaseCreateListDialogue.__super__.postRender.apply(this, arguments);
      return this.renderChild('body', new this.Body(this.getBodyOptions()), this.$('.modal-body'));
    };

    return BaseCreateListDialogue;

  })(Modal);

}).call(this);
