(function() {
  var CoreView, CreateListModel, InputWithButton, InputWithLabel, ListDialogueBody, ListTag, Messages, TagsApology, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  Templates = require('../../templates');

  Messages = require('../../messages');

  CreateListModel = require('../../models/create-list');

  InputWithLabel = require('../../core/input-with-label');

  InputWithButton = require('../../core/input-with-button');

  ListTag = require('./tag');

  TagsApology = require('./tags-apology');

  require('../../messages/lists');

  module.exports = ListDialogueBody = (function(_super) {
    __extends(ListDialogueBody, _super);

    function ListDialogueBody() {
      return ListDialogueBody.__super__.constructor.apply(this, arguments);
    }

    ListDialogueBody.prototype.Model = CreateListModel;

    ListDialogueBody.prototype.template = Templates.template('list-dialogue-body');

    ListDialogueBody.prototype.getData = function() {
      return _.extend(ListDialogueBody.__super__.getData.apply(this, arguments));
    };

    ListDialogueBody.prototype.modelEvents = function() {
      return {
        'add:tag': 'addTag'
      };
    };

    ListDialogueBody.prototype.stateEvents = function() {
      return {
        'change:minimised': 'toggleOptionalAttributes'
      };
    };

    ListDialogueBody.prototype.events = function() {
      return {
        'click .im-more-options': (function(_this) {
          return function() {
            return _this.state.toggle('minimised');
          };
        })(this)
      };
    };

    ListDialogueBody.prototype.$tags = null;

    ListDialogueBody.prototype.postRender = function() {
      this.renderListNameInput();
      this.renderListDescInput();
      return this.renderTags();
    };

    ListDialogueBody.prototype.renderTags = function() {
      this.$tags = this.$('.im-active-tags');
      this.addTags();
      this.renderApology();
      return this.renderTagAdder();
    };

    ListDialogueBody.prototype.renderTagAdder = function() {
      var nextTagView;
      nextTagView = new InputWithButton({
        model: this.model,
        placeholder: 'lists.AddTag',
        button: 'lists.AddTagBtn',
        sets: 'nextTag'
      });
      this.listenTo(nextTagView, 'act', this.addNextTag);
      return this.renderChildAt('.im-next-tag', nextTagView);
    };

    ListDialogueBody.prototype.addTags = function() {
      return this.model.tags.each((function(_this) {
        return function(t) {
          return _this.addTag(t);
        };
      })(this));
    };

    ListDialogueBody.prototype.addTag = function(t) {
      if (this.rendered) {
        return this.renderChild("tag-" + (t.get('id')), new ListTag({
          model: t
        }), this.$tags);
      }
    };

    ListDialogueBody.prototype.toggleOptionalAttributes = function() {
      var $attrs, msg, state;
      state = this.state.toJSON();
      $attrs = this.$('.im-optional-attributes');
      if (state.minimised) {
        $attrs.slideUp();
      } else {
        $attrs.slideDown();
      }
      msg = Messages.getText('lists.ShowExtraOptions', state);
      return this.$('.im-more-options .msg').text(msg);
    };

    ListDialogueBody.prototype.renderApology = function() {
      return this.renderChildAt('.im-apology', new TagsApology({
        collection: this.model.tags
      }));
    };

    ListDialogueBody.prototype.renderListNameInput = function() {
      var nameInput;
      nameInput = new InputWithLabel({
        model: this.model,
        attr: 'name',
        label: 'lists.params.Name',
        helpMessage: 'lists.params.help.Name',
        placeholder: 'lists.params.NamePlaceholder',
        getProblem: (function(_this) {
          return function(name) {
            return _this.validateName(name);
          };
        })(this)
      });
      this.listenTo(nameInput.state, 'change:problem', function() {
        var err;
        err = nameInput.state.get('problem');
        return this.state.set({
          disabled: !!err
        });
      });
      return this.renderChildAt('.im-list-name', nameInput);
    };

    ListDialogueBody.prototype.validateName = function(name) {
      var trimmed;
      trimmed = name != null ? name.replace(/(^\s+|\s+$)/g, '') : void 0;
      return (!trimmed) || (this.state.get('existingLists')[trimmed]);
    };

    ListDialogueBody.prototype.renderListDescInput = function() {
      return this.renderChildAt('.im-list-desc', new InputWithLabel({
        model: this.model,
        attr: 'description',
        label: 'lists.params.Desc',
        placeholder: 'lists.params.DescPlaceholder'
      }));
    };

    ListDialogueBody.prototype.addNextTag = function() {
      return this.model.addTag();
    };

    return ListDialogueBody;

  })(CoreView);

}).call(this);
