(function() {
  var AppendFromPath, AppendPicker, ClassSet, Collection, CoreModel, CoreView, Counter, CreateFromPath, CreatePicker, ListDialogueButton, PathModel, Paths, SelectableNode, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  CoreModel = require('../../core-model');

  Collection = require('../../core/collection');

  Templates = require('../../templates');

  ClassSet = require('../../utils/css-class-set');

  Counter = require('../../utils/count-executor');

  PathModel = require('../../models/path');

  AppendPicker = require('./append-from-selection');

  CreatePicker = require('./create-from-selection');

  AppendFromPath = require('./append-from-path');

  CreateFromPath = require('./create-from-path');

  require('../../messages/lists');

  Paths = (function(_super) {
    __extends(Paths, _super);

    function Paths() {
      return Paths.__super__.constructor.apply(this, arguments);
    }

    Paths.prototype.model = PathModel;

    return Paths;

  })(Collection);

  SelectableNode = (function(_super) {
    __extends(SelectableNode, _super);

    function SelectableNode() {
      return SelectableNode.__super__.constructor.apply(this, arguments);
    }

    SelectableNode.prototype.parameters = ['query', 'model', 'showDialogue', 'highLight'];

    SelectableNode.prototype.tagName = 'li';

    SelectableNode.prototype.modelEvents = function() {
      return {
        'change:displayName change:typeName': this.reRender
      };
    };

    SelectableNode.prototype.stateEvents = function() {
      return {
        'change:count': this.reRender
      };
    };

    SelectableNode.prototype.Model = PathModel;

    SelectableNode.prototype.template = Templates.template('list-dialogue-button-node');

    SelectableNode.prototype.events = function() {
      return {
        click: this.openDialogue,
        'mouseenter a': function() {
          return _.defer((function(_this) {
            return function() {
              return _this.highLight(_this.model.get('path'));
            };
          })(this));
        },
        'mouseout a': function() {
          return this.highLight(null);
        }
      };
    };

    SelectableNode.prototype.initialize = function() {
      SelectableNode.__super__.initialize.apply(this, arguments);
      return this.query.summarise(this.model.get('id')).then((function(_this) {
        return function(_arg) {
          var stats;
          stats = _arg.stats;
          return _this.state.set({
            count: stats.uniqueValues
          });
        };
      })(this));
    };

    SelectableNode.prototype.openDialogue = function() {
      var args;
      args = {
        query: this.query,
        path: this.model.get('id')
      };
      return this.showDialogue(args);
    };

    return SelectableNode;

  })(CoreView);

  module.exports = ListDialogueButton = (function(_super) {
    __extends(ListDialogueButton, _super);

    function ListDialogueButton() {
      return ListDialogueButton.__super__.constructor.apply(this, arguments);
    }

    ListDialogueButton.prototype.tagName = 'div';

    ListDialogueButton.prototype.className = 'btn-group list-dialogue-button';

    ListDialogueButton.prototype.template = Templates.template('list-dialogue-button');

    ListDialogueButton.prototype.parameters = ['query', 'selected'];

    ListDialogueButton.prototype.optionalParameters = ['tableState'];

    ListDialogueButton.prototype.tableState = new CoreModel;

    ListDialogueButton.prototype.initState = function() {
      return this.state.set({
        action: 'create',
        authenticated: false,
        disabled: false
      });
    };

    ListDialogueButton.prototype.stateEvents = function() {
      return {
        'change:action': this.setActionButtonState,
        'change:authenticated': this.setVisible,
        'change:disabled': this.onChangeDisabled
      };
    };

    ListDialogueButton.prototype.events = function() {
      return {
        'click .im-create-action': this.setActionIsCreate,
        'click .im-append-action': this.setActionIsAppend,
        'click .im-pick-items': this.startPicking
      };
    };

    ListDialogueButton.prototype.initialize = function() {
      ListDialogueButton.__super__.initialize.apply(this, arguments);
      this.initBtnClasses();
      this.paths = new Paths;
      this.query.getQueryNodes().reverse().forEach((function(_this) {
        return function(n) {
          return _this.paths.add(new PathModel(n));
        };
      })(this));
      this.query.service.whoami().then((function(_this) {
        return function(u) {
          return _this.state.set({
            authenticated: !!u
          });
        };
      })(this));
      return Counter.count(this.query).then((function(_this) {
        return function(count) {
          return _this.state.set({
            disabled: count === 0
          });
        };
      })(this)).then(null, (function(_this) {
        return function(err) {
          return _this.state.set({
            disabled: true,
            error: err
          });
        };
      })(this));
    };

    ListDialogueButton.prototype.getData = function() {
      return _.extend(ListDialogueButton.__super__.getData.apply(this, arguments), this.classSets, {
        paths: this.paths.toJSON()
      });
    };

    ListDialogueButton.prototype.postRender = function() {
      var highLight, menu, showDialogue;
      this.setVisible();
      this.onChangeDisabled();
      menu = this.$('.dropdown-menu');
      highLight = (function(_this) {
        return function(p) {
          return _this.tableState.set({
            highlitNode: p
          });
        };
      })(this);
      showDialogue = (function(_this) {
        return function(args) {
          return _this.showPathDialogue(args);
        };
      })(this);
      return this.paths.each((function(_this) {
        return function(model, i) {
          var node;
          node = new SelectableNode({
            query: _this.query,
            model: model,
            showDialogue: showDialogue,
            highLight: highLight
          });
          return _this.renderChild("path-" + i, node, menu, 'prepend');
        };
      })(this));
    };

    ListDialogueButton.prototype.onChangeDisabled = function() {
      return this.$('.btn').toggleClass('disabled', this.state.get('disabled'));
    };

    ListDialogueButton.prototype.setVisible = function() {
      return this.$el.toggleClass('im-hidden', !this.state.get('authenticated'));
    };

    ListDialogueButton.prototype.setActionIsCreate = function(e) {
      e.stopPropagation();
      e.preventDefault();
      return this.state.set({
        action: 'create'
      });
    };

    ListDialogueButton.prototype.setActionIsAppend = function(e) {
      e.stopPropagation();
      e.preventDefault();
      return this.state.set({
        action: 'append'
      });
    };

    ListDialogueButton.prototype.showDialogue = function(Dialogue, args) {
      var action, dialogue, handler;
      dialogue = new Dialogue(args);
      this.renderChild('dialogue', dialogue);
      action = this.state.get('action');
      handler = (function(_this) {
        return function(outcome) {
          return function(result) {
            _this.trigger("" + outcome + ":" + action, result);
            return _this.trigger(outcome, action, result);
          };
        };
      })(this);
      return dialogue.show().then(handler('success'), handler('failure'));
    };

    ListDialogueButton.prototype.showPathDialogue = function(args) {
      var Dialogue, action;
      action = this.state.get('action');
      Dialogue = (function() {
        switch (action) {
          case 'append':
            return AppendFromPath;
          case 'create':
            return CreateFromPath;
          default:
            throw new Error("Unknown action: " + action);
        }
      })();
      return this.showDialogue(Dialogue, args);
    };

    ListDialogueButton.prototype.startPicking = function() {
      var Dialogue, action, args, stopPicking;
      action = this.state.get('action');
      args = {
        collection: this.selected,
        service: this.query.service
      };
      Dialogue = (function() {
        switch (action) {
          case 'append':
            return AppendPicker;
          case 'create':
            return CreatePicker;
          default:
            throw new Error("Unknown action: " + action);
        }
      })();
      this.tableState.set({
        selecting: true
      });
      stopPicking = (function(_this) {
        return function() {
          _this.tableState.set({
            selecting: false
          });
          return _this.selected.reset();
        };
      })(this);
      return this.showDialogue(Dialogue, args).then(stopPicking, stopPicking);
    };

    ListDialogueButton.prototype.setActionButtonState = function() {
      var action;
      action = this.state.get('action');
      this.$('.im-create-action').toggleClass('active', action === 'create');
      return this.$('.im-append-action').toggleClass('active', action === 'append');
    };

    ListDialogueButton.prototype.initBtnClasses = function() {
      this.classSets = {};
      this.classSets.createBtnClasses = new ClassSet({
        'im-create-action': true,
        'btn btn-default': true,
        active: (function(_this) {
          return function() {
            return _this.state.get('action') === 'create';
          };
        })(this)
      });
      return this.classSets.appendBtnClasses = new ClassSet({
        'im-append-action': true,
        'btn btn-default': true,
        active: (function(_this) {
          return function() {
            return _this.state.get('action') === 'append';
          };
        })(this)
      });
    };

    return ListDialogueButton;

  })(CoreView);

}).call(this);
