(function() {
  var Promise;

  Promise = require('es6-promise').Promise;

  module.exports = function(Base) {
    return {
      parameters: ['query', 'path'],
      className: function() {
        return Base.prototype.className.call(this) + ' im-from-path';
      },
      getQuery: function() {
        return Promise.resolve(this.query.selectPreservingImpliedConstraints([this.path]));
      },
      fetchCount: function() {
        return this.query.summarise(this.path).then(function(_arg) {
          var uniqueValues;
          uniqueValues = _arg.stats.uniqueValues;
          return uniqueValues;
        });
      },
      getType: function() {
        return this.query.makePath(this.path).getParent().getType();
      },
      getService: function() {
        return this.query.service;
      }
    };
  };

}).call(this);
