(function() {
  var AttributeValueControls, LoopValueControls, Messages, Promise, SuggestionSource, fs, html, template, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  

  Promise = require('es6-promise').Promise;

  SuggestionSource = require('../utils/suggestion-source');

  Messages = require('../messages');

  AttributeValueControls = require('./attribute-value-controls');

  html = "<label class=\"im-value-options\">\n    <%- messages.getText('conbuilder.ExtraLabel') %>\n    <input type=\"text\" class=\"im-extra-value form-control\"\n            placeholder=\"<%- state.extraPlaceholder %>\"\n            value=\"<%- con.extraValue %>\">\n</label>\n\n";

  template = _.template(html);

  module.exports = LoopValueControls = (function(_super) {
    __extends(LoopValueControls, _super);

    function LoopValueControls() {
      return LoopValueControls.__super__.constructor.apply(this, arguments);
    }

    LoopValueControls.prototype.initialize = function() {
      LoopValueControls.__super__.initialize.apply(this, arguments);
      this.state.set({
        extraPlaceholder: Messages.get('conbuilder.ExtraPlaceholder')
      });
      this.listenTo(this.branding, 'change:defaults.extraValue.path', this.reRender);
      this.listenTo(this.branding, 'change:defaults.extraValue.value', function() {
        return this.state.set({
          extraPlaceholder: this.branding.get('defaults.extraValue.value')
        });
      });
      return this.listenTo(this.model, 'change', this.reRender);
    };

    LoopValueControls.prototype.stateEvents = function() {
      return _.extend(LoopValueControls.__super__.stateEvents.apply(this, arguments), {
        'change:extraPlaceholder': this.reRender
      });
    };

    LoopValueControls.prototype.template = function(data) {
      var base;
      base = LoopValueControls.__super__.template.apply(this, arguments);
      return base + template(data);
    };

    LoopValueControls.prototype.events = function() {
      return {
        'change .im-con-value-attr': 'setValue',
        'change .im-extra-value': 'setExtraValue'
      };
    };

    LoopValueControls.prototype.setExtraValue = function() {
      var input, value;
      input = this.$('input.im-extra-value.tt-input');
      if (!input.length) {
        input = this.$('input.im-extra-value');
      }
      value = input.val();
      if (value) {
        return this.model.set({
          extraValue: value
        });
      } else {
        return this.model.unset('extraValue');
      }
    };

    LoopValueControls.prototype.setBoth = function() {
      this.setValue();
      return this.setExtraValue();
    };

    LoopValueControls.prototype.suggestExtra = function() {
      var handler, path, suggesting, suggestingExtra, summPath, target;
      path = this.branding.get('defaults.extraValue.path');
      target = this.branding.get('defaults.extraValue.extraFor');
      return suggestingExtra = (path == null) || !this.model.get('path').isa(target) ? Promise.resolve(true) : (summPath = "" + (this.model.get('path')) + "." + path, suggesting = (this.__extra_suggestions != null ? this.__extra_suggestions : this.__extra_suggestions = this.query.summarise(summPath)), handler = this.handleSuggestionSet.bind(this, this.$('input.im-extra-value'), 'extraValue'), suggesting.then(function(_arg) {
        var results;
        results = _arg.results;
        return results;
      }).then(handler));
    };

    LoopValueControls.prototype.suggestValue = function() {
      var cls, gettingKeys, handler, path, s;
      path = this.model.get('path');
      s = this.query.service;
      cls = path.getEndClass().name;
      gettingKeys = s.fetchClassKeys().then(function(keys) {
        return keys[cls];
      });
      if (this.__value_suggestions == null) {
        this.__value_suggestions = gettingKeys.then((function(_this) {
          return function(keys) {
            var k, summaries;
            if (!(keys != null ? keys.length : void 0)) {
              return [];
            }
            summaries = (function() {
              var _i, _len, _results;
              _results = [];
              for (_i = 0, _len = keys.length; _i < _len; _i++) {
                k = keys[_i];
                _results.push(this.query.summarise(path + k.replace(/^[^\.]+/, '')));
              }
              return _results;
            }).call(_this);
            return Promise.all(summaries).then(function(resultSets) {
              return resultSets.reduce((function(acc, rs) {
                return acc.concat(rs.results);
              }), []);
            });
          };
        })(this));
      }
      handler = this.handleSuggestionSet.bind(this, this.$('input.im-con-value-attr'), 'value');
      return this.__value_suggestions.then(handler);
    };

    LoopValueControls.prototype.handleSuggestionSet = function(input, prop, results) {
      var dataset, handleSuggestion, mostCommon, opts, source, total;
      total = results.length;
      if (total === 0) {
        return;
      }
      source = new SuggestionSource(results, total);
      opts = {
        minLength: 0,
        highlight: true
      };
      dataset = {
        name: "" + prop + "_suggestions",
        source: source.suggest,
        displayKey: 'item',
        templates: {
          footer: source.tooMany
        }
      };
      handleSuggestion = (function(_this) {
        return function(control) {
          return function(e, suggestion) {
            return _this.model.set(prop, suggestion.item);
          };
        };
      })(this);
      mostCommon = results[0].item;
      return this.activateTypeahead(input, opts, dataset, mostCommon, handleSuggestion(input), (function(_this) {
        return function() {
          return _this.setBoth();
        };
      })(this));
    };

    LoopValueControls.prototype.provideSuggestions = function() {
      var suggestingExtra, suggestingValue;
      this.removeTypeAheads();
      suggestingValue = this.suggestValue();
      suggestingExtra = this.suggestExtra();
      return Promise.all([suggestingExtra, suggestingValue]);
    };

    LoopValueControls.prototype.remove = function() {
      LoopValueControls.__super__.remove.apply(this, arguments);
      return this.branding.destroy();
    };

    return LoopValueControls;

  })(AttributeValueControls);

}).call(this);
