(function() {
  var LoopValueControls, Messages, Promise, View, fs, helpers, html, mustacheSettings, template, toNamedPath, toOption, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  

  Promise = require('es6-promise').Promise;

  Messages = require('../messages');

  View = require('../core-view');

  helpers = require('../templates/helpers');

  mustacheSettings = require('../templates/mustache-settings');

  toNamedPath = require('../utils/to-named-path');

  html = "<% if (candidateLoops.length) { %>\n    <%= select(candidateLoops, isSelected, 'form-control im-value-options im-con-value') %>\n<% } else { %>\n    <%- messages.getText('conbuilder.NoSuitableLoops') %>\n<% } %>\n";

  template = _.template(html);

  toOption = function(_arg) {
    var name, path;
    path = _arg.path, name = _arg.name;
    return {
      value: path.toString(),
      text: name
    };
  };

  module.exports = LoopValueControls = (function(_super) {
    __extends(LoopValueControls, _super);

    function LoopValueControls() {
      return LoopValueControls.__super__.constructor.apply(this, arguments);
    }

    LoopValueControls.prototype.initialize = function(_arg) {
      this.query = _arg.query;
      LoopValueControls.__super__.initialize.apply(this, arguments);
      this.path = this.model.get('path');
      this.type = this.path.getType();
      this.setCandidateLoops();
      return this.listenTo(this.model, 'change', this.reRender);
    };

    LoopValueControls.prototype.events = function() {
      return {
        'change select': 'setLoop'
      };
    };

    LoopValueControls.prototype.setLoop = function() {
      return this.model.set({
        value: this.$('select').val()
      });
    };

    LoopValueControls.prototype.setCandidateLoops = function() {
      if (!this.model.has('candidateLoops')) {
        return this.getCandidateLoops().then((function(_this) {
          return function(candidateLoops) {
            return _this.model.set({
              candidateLoops: candidateLoops
            });
          };
        })(this));
      }
    };

    LoopValueControls.prototype.isSuitable = function(candidate) {
      return ((candidate.isa(this.type)) || (this.path.isa(candidate.getType()))) && (this.path.toString() !== candidate.toString());
    };

    LoopValueControls.prototype.getCandidateLoops = function() {
      return this.__candidate_loops != null ? this.__candidate_loops : this.__candidate_loops = (function(_this) {
        return function() {
          var loopCandidates, n;
          loopCandidates = (function() {
            var _i, _len, _ref, _results;
            _ref = this.query.getQueryNodes();
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              n = _ref[_i];
              if (this.isSuitable(n)) {
                _results.push(n);
              }
            }
            return _results;
          }).call(_this);
          return Promise.all(loopCandidates.map(toNamedPath));
        };
      })(this)();
    };

    LoopValueControls.prototype.template = function(data) {
      return template(_.extend({
        messages: Messages
      }, helpers, data));
    };

    LoopValueControls.prototype.getData = function() {
      var c, candidateLoops, currentValue, isSelected;
      currentValue = this.model.get('value');
      candidateLoops = (function() {
        var _i, _len, _ref, _results;
        _ref = this.model.get('candidateLoops') || [];
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          c = _ref[_i];
          _results.push(toOption(c));
        }
        return _results;
      }).call(this);
      isSelected = function(opt) {
        return opt.value === currentValue;
      };
      return {
        candidateLoops: candidateLoops,
        isSelected: isSelected
      };
    };

    return LoopValueControls;

  })(View);

}).call(this);
