(function() {
  var Messages, Modal, ModalFooter, Promise, Templates, View, modalTemplate, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Promise = require('es6-promise').Promise;

  _ = require('underscore');

  View = require('../core-view');

  Messages = require('../messages');

  Templates = require('../templates');

  modalTemplate = Templates.template('modal_base');

  ModalFooter = require('./modal-footer');

  module.exports = Modal = (function(_super) {
    __extends(Modal, _super);

    function Modal() {
      return Modal.__super__.constructor.apply(this, arguments);
    }

    Modal.prototype.className = function() {
      return 'modal fade';
    };

    Modal.prototype.initialize = function() {
      Modal.__super__.initialize.apply(this, arguments);
      this._promise = new Promise((function(_this) {
        return function(resolve, reject) {
          _this.resolve = resolve;
          _this.reject = reject;
        };
      })(this));
      return this.listenTo(this.state, 'change', this.renderFooter);
    };

    Modal.prototype.resolve = function() {
      throw new Error('resolved before initialisation');
    };

    Modal.prototype.reject = function() {
      throw new Error('rejected before initialisation');
    };

    Modal.prototype.dismissError = function() {
      return this.$('.modal-footer .alert').slideUp(250, (function(_this) {
        return function() {
          return _this.state.set({
            error: null
          });
        };
      })(this));
    };

    Modal.prototype.events = function() {
      return {
        'click .modal-footer .alert .dismiss': 'dismissError',
        'click .modal-footer .btn-cancel': 'hide',
        'click .modal-footer button.btn-primary': 'act',
        'hidden.bs.modal': 'onHidden',
        'click .close': 'hide'
      };
    };

    Modal.prototype.promise = function() {
      return this._promise;
    };

    Modal.prototype.hide = function() {
      return this.resolve('dismiss');
    };

    Modal.prototype.act = function() {
      throw new Error('Not implemented.');
    };

    Modal.prototype.primaryIcon = function() {
      return null;
    };

    Modal.prototype.Footer = ModalFooter;

    Modal.prototype.renderFooter = function() {
      var dismissAction, opts, primaryAction, primaryIcon;
      if (!this.rendered) {
        return;
      }
      dismissAction = _.result(this, 'dismissAction');
      primaryAction = _.result(this, 'primaryAction');
      primaryIcon = _.result(this, 'primaryIcon');
      opts = {
        template: this.footer,
        model: this.state,
        actionNames: {
          dismissAction: dismissAction,
          primaryAction: primaryAction
        },
        actionIcons: {
          primaryIcon: primaryIcon
        }
      };
      return this.renderChild('footer', new this.Footer(opts), this.$('.modal-content'));
    };

    Modal.prototype.postRender = function() {
      return this.renderFooter();
    };

    Modal.prototype.onHidden = function(e) {
      if ((e != null) && e.target !== this.el) {
        return false;
      }
      this.resolve('dismiss');
      this.shown = false;
      return this.remove();
    };

    Modal.prototype.remove = function() {
      this.reject(new Error('unresolved before removal'));
      if (this.shown) {
        return this._hideModal();
      }
      return Modal.__super__.remove.call(this);
    };

    Modal.prototype.title = function() {
      return Messages.getText('modal.DefaultTitle');
    };

    Modal.prototype.dismissAction = function() {
      return Messages.getText('modal.Dismiss');
    };

    Modal.prototype.primaryAction = function() {
      return Messages.getText('modal.OK');
    };

    Modal.prototype.modalSize = function() {};

    Modal.prototype.body = function() {};

    Modal.prototype.renderTitle = function() {
      if (this.rendered) {
        return this.$('.modal-title').text(_.result(this, 'title'));
      }
    };

    Modal.prototype.footer = Templates.templateFromParts(['modal_error', 'modal_footer']);

    Modal.prototype.template = function(data) {
      var body, modalSize, title;
      title = _.result(this, 'title');
      body = this.body(data);
      modalSize = "modal-" + (_.result(this, 'modalSize'));
      return modalTemplate({
        title: title,
        body: body,
        modalSize: modalSize
      });
    };

    Modal.prototype.shown = false;

    Modal.prototype.show = function() {
      var e, p;
      p = this.promise();
      p.then(((function(_this) {
        return function() {
          return _this.remove();
        };
      })(this)), ((function(_this) {
        return function() {
          return _this.remove();
        };
      })(this)));
      try {
        this._showModal();
        this.trigger('shown', this.shown = true);
      } catch (_error) {
        e = _error;
        this.reject(e);
      }
      return p;
    };

    Modal.prototype._showModal = function() {
      return this.$el.modal().modal('show');
    };

    Modal.prototype._hideModal = function() {
      return this.$el.modal('hide');
    };

    return Modal;

  })(View);

}).call(this);
