(function() {
  var ConstraintAdder, Messages, Modal, NewFilterDialogue, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  Modal = require('./modal');

  ConstraintAdder = require('./constraint-adder');

  Templates = require('../templates');

  Messages = require('../messages');

  module.exports = NewFilterDialogue = (function(_super) {
    __extends(NewFilterDialogue, _super);

    function NewFilterDialogue() {
      return NewFilterDialogue.__super__.constructor.apply(this, arguments);
    }

    NewFilterDialogue.prototype.className = function() {
      return 'im-constraint-dialogue ' + NewFilterDialogue.__super__.className.apply(this, arguments);
    };

    NewFilterDialogue.prototype.modalSize = 'lg';

    NewFilterDialogue.prototype.initialize = function(_arg) {
      this.query = _arg.query;
      NewFilterDialogue.__super__.initialize.apply(this, arguments);
      this.listenTo(this.query, 'change:constraints', this.resolve);
      return this.listenTo(this.query, 'editing-constraint', (function(_this) {
        return function() {
          return _this.$('.im-add-constraint').removeClass('disabled');
        };
      })(this));
    };

    NewFilterDialogue.prototype.events = function() {
      return _.extend(NewFilterDialogue.__super__.events.apply(this, arguments), {
        'click .im-add-constraint': 'addConstraint',
        'childremoved': (function(_this) {
          return function(e, child) {
            if (child instanceof ConstraintAdder) {
              return _this.hide();
            }
          };
        })(this)
      });
    };

    NewFilterDialogue.prototype.title = function() {
      return Messages.getText('constraints.AddNewFilter');
    };

    NewFilterDialogue.prototype.primaryAction = function() {
      return Messages.getText('constraints.AddFilter');
    };

    NewFilterDialogue.prototype.postRender = function() {
      var body, footer;
      footer = this.$('.modal-footer');
      body = this.$('.modal-body');
      this.renderChild('adder', new ConstraintAdder({
        buttonDelegate: footer,
        query: this.query
      }), body);
      return NewFilterDialogue.__super__.postRender.apply(this, arguments);
    };

    return NewFilterDialogue;

  })(Modal);

}).call(this);
