(function() {
  var Attribute, Icons, Reference, ignore,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Icons = require('../../icons');

  Attribute = require('./attribute');

  ignore = require('../../utils/events').ignore;

  module.exports = Reference = (function(_super) {
    __extends(Reference, _super);

    function Reference() {
      return Reference.__super__.constructor.apply(this, arguments);
    }

    Reference.prototype.initialize = function(_arg) {
      this.openNodes = _arg.openNodes, this.createSubFinder = _arg.createSubFinder;
      Reference.__super__.initialize.apply(this, arguments);
      this.state.set({
        collapsed: true
      });
      this.listenTo(this.openNodes, 'add remove', this.setCollapsed);
      this.listenTo(this.state, 'change:collapsed', this.onChangeCollapsed);
      return this.setCollapsed();
    };

    Reference.prototype.setCollapsed = function() {
      var _ref;
      return (_ref = this.state) != null ? _ref.set({
        collapsed: !this.openNodes.contains(this.path)
      }) : void 0;
    };

    Reference.prototype.handleClick = function(e) {
      ignore(e);
      if (this.$(e.target).is('i') || (!this.model.get('canSelectReferences'))) {
        return this.openNodes.togglePresence(this.path);
      } else {
        return Reference.__super__.handleClick.call(this, e);
      }
    };

    Reference.prototype.getData = function() {
      var d;
      d = Reference.__super__.getData.apply(this, arguments);
      d.icon = Icons.icon(this.state.get('collapsed') ? 'ClosedReference' : 'OpenReference');
      return d;
    };

    Reference.prototype.postRender = function() {
      return this.onChangeCollapsed();
    };

    Reference.prototype.onChangeCollapsed = function() {
      var subfinder, trail;
      if (this.state.get('collapsed')) {
        return this.removeChild('subfinder');
      } else {
        trail = this.trail.concat([this.path]);
        subfinder = this.createSubFinder({
          trail: trail
        });
        return this.renderChild('subfinder', subfinder);
      }
    };

    return Reference;

  })(Attribute);

}).call(this);
