(function() {
  var CoreView, QueryDialogueButton, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../core-view');

  Templates = require('../templates');

  module.exports = QueryDialogueButton = (function(_super) {
    __extends(QueryDialogueButton, _super);

    function QueryDialogueButton() {
      return QueryDialogueButton.__super__.constructor.apply(this, arguments);
    }

    QueryDialogueButton.prototype.Dialogue = function() {
      throw new Error('Not implemented');
    };

    QueryDialogueButton.prototype.longLabel = function() {
      throw new Error('Not implemented');
    };

    QueryDialogueButton.prototype.shortLabel = function() {
      throw new Error('Not implemented');
    };

    QueryDialogueButton.prototype.icon = function() {
      throw new Error('Not implemented');
    };

    QueryDialogueButton.prototype.template = Templates.template('modal-dialogue-opener');

    QueryDialogueButton.prototype.labels = function() {
      return {
        ICON: _.result(this, 'icon'),
        LONG: _.result(this, 'longLabel'),
        SHORT: _.result(this, 'shortLabel')
      };
    };

    QueryDialogueButton.prototype.parameters = ['query'];

    QueryDialogueButton.prototype.initState = function() {
      return this.state.set({
        disabled: false
      });
    };

    QueryDialogueButton.prototype.events = function() {
      return {
        click: this.onClick
      };
    };

    QueryDialogueButton.prototype.createDialogue = function() {
      return new this.Dialogue(this.dialogueOptions());
    };

    QueryDialogueButton.prototype.dialogueOptions = function() {
      return {
        query: this.query
      };
    };

    QueryDialogueButton.prototype.stateEvents = function() {
      return {
        'change:disabled': function() {
          return this.$('.btn.im-open-dialogue').toggleClass('disabled', this.state.get('disabled'));
        }
      };
    };

    QueryDialogueButton.prototype.onClick = function(e) {
      var dialogue, done;
      if (!(this.state.get('disabled'))) {
        dialogue = this.createDialogue();
        this.renderChild('dialogue', dialogue);
        this.state.set({
          disabled: true
        });
        done = (function(_this) {
          return function() {
            _this.removeChild('dialogue');
            document.body.classList.remove('modal-open');
            return _.defer(function() {
              return _this.state.set({
                disabled: false
              });
            });
          };
        })(this);
        return dialogue.show().then(done, done);
      }
    };

    return QueryDialogueButton;

  })(CoreView);

}).call(this);
