(function() {
  var ColumnMangerButton, CoreView, FilterDialogueButton, HistoryType, JoinManagerButton, Listenable, QueryManagement, Structure, Types, UnionOf, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  CoreView = require('../core-view');

  _ref = Types = require('../core/type-assertions'), UnionOf = _ref.UnionOf, Listenable = _ref.Listenable, Structure = _ref.Structure;

  ColumnMangerButton = require('./column-manager/button');

  FilterDialogueButton = require('./filter-dialogue/button');

  JoinManagerButton = require('./join-manager/button');

  HistoryType = UnionOf(Listenable, new Structure('History', {
    getCurrentQuery: Types.Function
  }));

  module.exports = QueryManagement = (function(_super) {
    __extends(QueryManagement, _super);

    function QueryManagement() {
      return QueryManagement.__super__.constructor.apply(this, arguments);
    }

    QueryManagement.prototype.className = 'im-query-management';

    QueryManagement.prototype.parameters = ['history'];

    QueryManagement.prototype.parameterTypes = {
      history: HistoryType
    };

    QueryManagement.prototype.initialize = function() {
      QueryManagement.__super__.initialize.apply(this, arguments);
      return this.listenTo(this.history, 'changed:current', this.reRender);
    };

    QueryManagement.prototype.renderChildren = function() {
      var query;
      query = this.history.getCurrentQuery();
      this.renderChild('cols', new ColumnMangerButton({
        query: query
      }));
      this.renderChild('cons', new FilterDialogueButton({
        query: query
      }));
      return this.renderChild('joins', new JoinManagerButton({
        query: query
      }));
    };

    return QueryManagement;

  })(CoreView);

}).call(this);
