(function() {
  var CoreView, EmptyApology, RowView, TableBody, Templates, buildSkipped, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  Templates = require('../../templates');

  buildSkipped = require('../../utils/build-skipset');

  require('../../messages/table');

  module.exports = TableBody = (function(_super) {
    __extends(TableBody, _super);

    function TableBody() {
      return TableBody.__super__.constructor.apply(this, arguments);
    }

    TableBody.prototype.tagName = 'tbody';

    TableBody.prototype.parameters = ['makeCell', 'collection', 'history'];

    TableBody.prototype.collectionEvents = function() {
      return {
        reset: this.reRender,
        add: this.onRowAdded,
        remove: this.onRowRemoved
      };
    };

    TableBody.prototype.template = function() {};

    TableBody.prototype.initialize = function() {
      TableBody.__super__.initialize.apply(this, arguments);
      return this._skipSets = {};
    };

    TableBody.prototype.renderChildren = function() {
      var frag;
      if (this.collection.isEmpty()) {
        return this.handleEmptyTable();
      } else {
        frag = document.createDocumentFragment('tbody');
        this.collection.forEach((function(_this) {
          return function(row) {
            return _this.addRow(row, frag);
          };
        })(this));
        return this.el.appendChild(frag);
      }
    };

    TableBody.prototype.onRowAdded = function(row) {
      this.removeChild('apology');
      return this.addRow(row);
    };

    TableBody.prototype.onRowRemoved = function(row) {
      this.removeChild(row.id);
      if (this.collection.isEmpty()) {
        return this.handleEmptyTable();
      }
    };

    TableBody.prototype.addRow = function(row, tbody) {
      var skipped, view;
      if (tbody == null) {
        tbody = this.el;
      }
      skipped = this.skipped(row);
      view = new RowView({
        model: row,
        makeCell: this.makeCell,
        skipped: skipped
      });
      return this.renderChild(row.id, view, tbody);
    };

    TableBody.prototype.handleEmptyTable = function() {
      return this.renderChild('apology', new EmptyApology({
        history: this.history
      }));
    };

    TableBody.prototype.skipped = function(row) {
      var _base, _name;
      return (_base = this._skipSets)[_name = row.get('query')] != null ? _base[_name] : _base[_name] = (function(_this) {
        return function() {
          var ret, temps;
          temps = row.get('cells').map(_this.makeCell);
          ret = buildSkipped(temps);
          temps.forEach(function(t) {
            return t.remove();
          });
          return ret;
        };
      })(this)();
    };

    return TableBody;

  })(CoreView);

  RowView = (function(_super) {
    __extends(RowView, _super);

    function RowView() {
      return RowView.__super__.constructor.apply(this, arguments);
    }

    RowView.prototype.tagName = 'tr';

    RowView.prototype.parameters = ['makeCell', 'skipped'];

    RowView.prototype.postRender = function() {
      var cell, cells, i, _i, _len, _results;
      cells = this.model.get('cells').map(this.makeCell);
      _results = [];
      for (i = _i = 0, _len = cells.length; _i < _len; i = ++_i) {
        cell = cells[i];
        if (!this.skipped[cell.model.get('column')]) {
          _results.push(this.renderChild(i, cell));
        }
      }
      return _results;
    };

    return RowView;

  })(CoreView);

  EmptyApology = (function(_super) {
    __extends(EmptyApology, _super);

    function EmptyApology() {
      return EmptyApology.__super__.constructor.apply(this, arguments);
    }

    EmptyApology.prototype.tagName = 'tr';

    EmptyApology.prototype.className = 'im-empty-apology';

    EmptyApology.prototype.template = Templates.template('no-results');

    EmptyApology.prototype.parameters = ['history'];

    EmptyApology.prototype.events = function() {
      return {
        'click .btn-undo': function() {
          return this.history.popState();
        }
      };
    };

    EmptyApology.prototype.getData = function() {
      return _.extend(EmptyApology.__super__.getData.apply(this, arguments), {
        selectList: this.history.getCurrentQuery().views,
        canUndo: this.history.length > 1
      });
    };

    return EmptyApology;

  })(CoreView);

}).call(this);
