(function() {
  var Cell, NestedTableModel, SubTable;

  NestedTableModel = require('../../models/nested-table');

  SubTable = require('./subtable');

  Cell = require('./cell');

  module.exports = function(service, opts) {
    var base, cellify, getFormatter;
    base = service.root.replace(/\/service\/?$/, "");
    getFormatter = function(cell) {
      var f;
      f = opts.getFormatter(cell.get('node'), cell.get('column'));
      if ((f != null) && opts.canUseFormatter(f)) {
        return f;
      } else {
        return null;
      }
    };
    return cellify = function(cell) {
      if (cell instanceof NestedTableModel) {
        return new SubTable({
          query: opts.query,
          model: cell,
          cellify: cellify,
          expandedSubtables: opts.expandedSubtables
        });
      } else {
        return new Cell({
          model: cell,
          service: service,
          popovers: opts.popoverFactory,
          selectedObjects: opts.selectedObjects,
          tableState: opts.tableState,
          formatter: getFormatter(cell)
        });
      }
    };
  };

}).call(this);
