(function() {
  var ColumnHeader, CoreView, TableHead, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  ColumnHeader = require('./header');

  module.exports = TableHead = (function(_super) {
    __extends(TableHead, _super);

    function TableHead() {
      return TableHead.__super__.constructor.apply(this, arguments);
    }

    TableHead.prototype.tagName = 'thead';

    TableHead.prototype.parameters = ['history', 'expandedSubtables', 'blacklistedFormatters', 'columnHeaders'];

    TableHead.prototype.template = function() {};

    TableHead.prototype.initialize = function() {
      TableHead.__super__.initialize.apply(this, arguments);
      this.listenTo(this.columnHeaders, 'add reset sort', this.reRender);
      this.listenTo(this.columnHeaders, 'remove', function(ch) {
        return this.removeChild(ch.id);
      });
      return this;
    };

    TableHead.prototype.renderChildren = function() {
      var docfrag, headerOpts, query, tr;
      docfrag = document.createDocumentFragment();
      tr = document.createElement('tr');
      docfrag.appendChild(tr);
      query = this.history.getCurrentQuery();
      headerOpts = {
        query: query,
        expandedSubtables: this.expandedSubtables,
        blacklistedFormatters: this.blacklistedFormatters
      };
      this.columnHeaders.each(this.renderHeader(tr, headerOpts));
      return this.$el.html(docfrag);
    };

    TableHead.prototype.renderHeader = function(tr, opts) {
      return (function(_this) {
        return function(model, i) {
          var header;
          header = new ColumnHeader(_.extend({
            model: model
          }, opts));
          return _this.renderChild(model.id, header, tr);
        };
      })(this);
    };

    return TableHead;

  })(CoreView);

}).call(this);
