(function() {
  var Collection, CoreView, DropDownColumnSummary, OuterJoinDropDown, PathModel, SubColumn, SubColumns, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  Templates = require('../../templates');

  Collection = require('../../core/collection');

  PathModel = require('../../models/path');

  DropDownColumnSummary = require('./column-summary');

  SubColumns = (function(_super) {
    __extends(SubColumns, _super);

    function SubColumns() {
      return SubColumns.__super__.constructor.apply(this, arguments);
    }

    SubColumns.prototype.model = PathModel;

    return SubColumns;

  })(Collection);

  SubColumn = (function(_super) {
    __extends(SubColumn, _super);

    function SubColumn() {
      return SubColumn.__super__.constructor.apply(this, arguments);
    }

    SubColumn.prototype.parameters = ['showPathSummary'];

    SubColumn.prototype.className = 'im-subpath im-outer-joined-path';

    SubColumn.prototype.tagName = 'li';

    SubColumn.prototype.template = _.template("<a href=\"#\">" + Templates.column_manager_path_name + "</a>");

    SubColumn.prototype.modelEvents = function() {
      return {
        change: this.reRender
      };
    };

    SubColumn.prototype.events = function() {
      return {
        click: this.onClick
      };
    };

    SubColumn.prototype.onClick = function(e) {
      e.stopPropagation();
      e.preventDefault();
      return this.showPathSummary(this.model);
    };

    return SubColumn;

  })(CoreView);

  module.exports = OuterJoinDropDown = (function(_super) {
    __extends(OuterJoinDropDown, _super);

    function OuterJoinDropDown() {
      return OuterJoinDropDown.__super__.constructor.apply(this, arguments);
    }

    OuterJoinDropDown.prototype.parameters = ['query'];

    OuterJoinDropDown.prototype.className = 'im-summary-selector';

    OuterJoinDropDown.prototype.tagName = 'ul';

    OuterJoinDropDown.prototype.initialize = function() {
      var c, _i, _len, _ref;
      OuterJoinDropDown.__super__.initialize.apply(this, arguments);
      this.subColumns = new SubColumns;
      _ref = this.model.get('replaces');
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        c = _ref[_i];
        this.subColumns.add(this.query.makePath(c));
      }
      return this.path = new PathModel(this.query.makePath(this.model.get('path')));
    };

    OuterJoinDropDown.prototype.getSubpaths = function() {
      return this.subColumns;
    };

    OuterJoinDropDown.prototype.postRender = function() {
      var paths, showPathSummary;
      paths = this.getSubpaths();
      if (paths.length === 1) {
        return this.showPathSummary(paths.first());
      }
      showPathSummary = (function(_this) {
        return function(m) {
          return _this.showPathSummary(m);
        };
      })(this);
      return this.getSubpaths().each((function(_this) {
        return function(model, i) {
          return _this.renderChild(i, new SubColumn({
            model: model,
            showPathSummary: showPathSummary
          }));
        };
      })(this));
    };

    OuterJoinDropDown.prototype.showPathSummary = function(model) {
      var summ;
      this.undelegateEvents();
      this.removeAllChildren();
      summ = new DropDownColumnSummary({
        query: this.query,
        model: model
      });
      this.children.summ = summ;
      summ.setElement(this.el);
      return summ.render();
    };

    return OuterJoinDropDown;

  })(CoreView);

}).call(this);
