(function() {
  exports.getCurrentPage = function() {
    var size, start, _ref;
    _ref = this.model.toJSON(), start = _ref.start, size = _ref.size;
    return Math.floor(start / size) + 1;
  };

  exports.getMaxPage = function() {
    var correction, count, size, _ref;
    _ref = this.model.toJSON(), count = _ref.count, size = _ref.size;
    correction = count % size === 0 ? 0 : 1;
    return Math.floor(count / size) + correction;
  };

  exports.goTo = function(start) {
    return this.model.set({
      start: start
    });
  };

  exports.goToPage = function(page) {
    return this.model.set({
      start: (page - 1) * this.model.get('size')
    });
  };

  exports.goBack = function(pages) {
    var size, start, _ref;
    _ref = this.model.toJSON(), start = _ref.start, size = _ref.size;
    return this.goTo(Math.max(0, start - (pages * size)));
  };

  exports.goForward = function(pages) {
    var size, start, _ref;
    _ref = this.model.toJSON(), start = _ref.start, size = _ref.size;
    return this.goTo(Math.min(this.getMaxPage() * size, start + (pages * size)));
  };

}).call(this);
