(function() {
  var CoreView, SubtableHeader, SubtableHeaders, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  Templates = require('../../templates');

  require('../../messages/subtables');

  SubtableHeader = (function(_super) {
    __extends(SubtableHeader, _super);

    function SubtableHeader() {
      return SubtableHeader.__super__.constructor.apply(this, arguments);
    }

    SubtableHeader.prototype.tagName = 'th';

    SubtableHeader.prototype.parameters = ['columnModel', 'model', 'query'];

    SubtableHeader.prototype.template = Templates.template('table-subtables-header');

    SubtableHeader.prototype.getData = function() {
      return _.extend(SubtableHeader.__super__.getData.apply(this, arguments), this.columnModel.pick('columnName'));
    };

    SubtableHeader.prototype.modelEvents = function() {
      return {
        'change:displayName': this.reRender
      };
    };

    SubtableHeader.prototype.events = function() {
      return {
        'click a': this.removeView
      };
    };

    SubtableHeader.prototype.removeView = function() {
      var _ref;
      return this.query.removeFromSelect((_ref = this.model.get('replaces')) != null ? _ref : this.model.get('path'));
    };

    SubtableHeader.prototype.postRender = function() {
      return this.$('[title]').tooltip();
    };

    SubtableHeader.prototype.initialize = function() {
      SubtableHeader.__super__.initialize.apply(this, arguments);
      return this.listenTo(this.columnModel, 'change:columnName', this.reRender);
    };

    SubtableHeader.prototype.remove = function() {
      delete this.columnModel;
      return SubtableHeader.__super__.remove.apply(this, arguments);
    };

    return SubtableHeader;

  })(CoreView);

  module.exports = SubtableHeaders = (function(_super) {
    __extends(SubtableHeaders, _super);

    function SubtableHeaders() {
      return SubtableHeaders.__super__.constructor.apply(this, arguments);
    }

    SubtableHeaders.prototype.tagName = 'thead';

    SubtableHeaders.prototype.template = function() {
      return '<tr></tr>';
    };

    SubtableHeaders.prototype.parameters = ['collection', 'columnModel', 'query'];

    SubtableHeaders.prototype.collectionEvents = function() {
      return {
        'add remove': this.reRender
      };
    };

    SubtableHeaders.prototype.renderChildren = function() {
      var tr;
      tr = this.el.querySelector('tr');
      return this.collection.forEach((function(_this) {
        return function(model, i) {
          return _this.renderChild(i, new SubtableHeader({
            model: model,
            query: _this.query,
            columnModel: _this.columnModel
          }), tr);
        };
      })(this));
    };

    SubtableHeaders.prototype.remove = function() {
      delete this.columnModel;
      return SubtableHeaders.__super__.remove.apply(this, arguments);
    };

    return SubtableHeaders;

  })(CoreView);

}).call(this);
