(function() {
  var CoreView, SubtableHeader, SubtableInner, buildSkipped,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  CoreView = require('../../core-view');

  SubtableHeader = require('./subtable-header');

  buildSkipped = require('../../utils/build-skipset');

  module.exports = SubtableInner = (function(_super) {
    __extends(SubtableInner, _super);

    function SubtableInner() {
      return SubtableInner.__super__.constructor.apply(this, arguments);
    }

    SubtableInner.prototype.tagName = 'table';

    SubtableInner.prototype.className = 'im-subtable table table-condensed table-striped';

    SubtableInner.prototype.parameters = ['query', 'headers', 'model', 'rows', 'cellify'];

    SubtableInner.prototype.render = function() {
      var i, row, tbody, _i, _len, _ref;
      this.removeAllChildren();
      if (this.rendered) {
        this.el.innerHTML = '';
      }
      if (this.headers.length > 1) {
        this.renderHead();
      }
      tbody = document.createElement('tbody');
      _ref = this.rows;
      for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
        row = _ref[i];
        this.appendRow(row, i, tbody);
      }
      this.el.appendChild(tbody);
      this.trigger('rendered', this.rendered = true);
      return this;
    };

    SubtableInner.prototype.renderHead = function(table) {
      var head;
      head = new SubtableHeader({
        query: this.query,
        collection: this.headers,
        columnModel: this.model
      });
      return this.renderChild('thead', head, table);
    };

    SubtableInner.prototype.buildSkipped = function(cells) {
      return this._skipped != null ? this._skipped : this._skipped = buildSkipped(cells, this.headers);
    };

    SubtableInner.prototype.appendRow = function(row, i, tbody) {
      var c, cell, cells, j, skipped, tr, _i, _len, _results;
      tr = document.createElement('tr');
      tbody.appendChild(tr);
      cells = (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = row.length; _i < _len; _i++) {
          c = row[_i];
          _results.push(this.cellify(c));
        }
        return _results;
      }).call(this);
      skipped = this.buildSkipped(cells);
      _results = [];
      for (j = _i = 0, _len = cells.length; _i < _len; j = ++_i) {
        cell = cells[j];
        if (!skipped[cell.model.get('column')]) {
          _results.push(this.renderChild("cell-" + i + "-" + j, cell, tr));
        }
      }
      return _results;
    };

    return SubtableInner;

  })(CoreView);

}).call(this);
