(function() {
  var CoreView, Messages, SubtableSummary, Templates,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  CoreView = require('../../core-view');

  Messages = require('../../messages');

  Templates = require('../../templates');

  require('../../messages/subtables');

  module.exports = SubtableSummary = (function(_super) {
    __extends(SubtableSummary, _super);

    function SubtableSummary() {
      return SubtableSummary.__super__.constructor.apply(this, arguments);
    }

    SubtableSummary.prototype.className = 'im-subtable-summary';

    SubtableSummary.prototype.tagName = 'span';

    SubtableSummary.prototype.template = Templates.template('table-subtable-summary');

    SubtableSummary.prototype.parameters = ['model', 'state'];

    SubtableSummary.prototype.modelEvents = function() {
      return {
        'change:contentName': this.reRender
      };
    };

    SubtableSummary.prototype.events = function() {
      return {
        click: this.onClick
      };
    };

    SubtableSummary.prototype.onClick = function(e) {
      if (e != null) {
        e.stopPropagation();
      }
      this.$el.tooltip('hide');
      return this.state.toggle('open');
    };

    SubtableSummary.prototype.postRender = function() {
      return this.$el.tooltip({
        title: (this.model.get('rows').length ? Messages.getText('subtables.OpenHint') : void 0),
        placement: 'auto right'
      });
    };

    return SubtableSummary;

  })(CoreView);

}).call(this);
