(function() {
  var Collection, CoreView, INITIAL_STATE, NestedTableModel, Options, PathCollection, PathModel, SubTable, SubtableInner, SubtableSummary, Templates, TypeAssertions, ignore, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  Options = require('../../options');

  Collection = require('../../core/collection');

  Templates = require('../../templates');

  TypeAssertions = require('../../core/type-assertions');

  NestedTableModel = require('../../models/nested-table');

  PathModel = require('../../models/path');

  SubtableSummary = require('./subtable-summary');

  SubtableInner = require('./subtable-inner');

  ignore = require('../../utils/events').ignore;

  PathCollection = (function(_super) {
    __extends(PathCollection, _super);

    function PathCollection() {
      return PathCollection.__super__.constructor.apply(this, arguments);
    }

    PathCollection.prototype.model = PathModel;

    return PathCollection;

  })(Collection);

  INITIAL_STATE = 'Subtables.Initially.expanded';

  module.exports = SubTable = (function(_super) {
    __extends(SubTable, _super);

    function SubTable() {
      return SubTable.__super__.constructor.apply(this, arguments);
    }

    SubTable.prototype.tagName = 'td';

    SubTable.prototype.className = 'im-result-subtable';

    SubTable.prototype.Model = NestedTableModel;

    SubTable.prototype.parameters = ['query', 'cellify', 'expandedSubtables'];

    SubTable.prototype.parameterTypes = {
      query: TypeAssertions.Query,
      cellify: TypeAssertions.Function,
      expandedSubtables: TypeAssertions.Collection
    };

    SubTable.prototype.initialize = function() {
      SubTable.__super__.initialize.apply(this, arguments);
      this.headers = new PathCollection;
      this.listenTo(this.expandedSubtables, 'add remove reset', this.onChangeExpandedSubtables);
      return this.buildHeaders();
    };

    SubTable.prototype.getPath = function() {
      return this.model.get('column');
    };

    SubTable.prototype.initState = function() {
      var open;
      open = (Options.get(INITIAL_STATE)) || (this.expandedSubtables.contains(this.getPath()));
      return this.state.set({
        open: open
      });
    };

    SubTable.prototype.stateEvents = function() {
      return {
        'change:open': this.onChangeOpen
      };
    };

    SubTable.prototype.onChangeOpen = function() {
      var wrapper;
      wrapper = this.el.querySelector('.im-table-wrapper');
      if (this.state.get('open')) {
        if (this.renderTable(wrapper)) {
          return this.$(wrapper).slideDown();
        }
      } else {
        return this.$(wrapper).slideUp();
      }
    };

    SubTable.prototype.onChangeExpandedSubtables = function() {
      return this.state.set({
        open: this.expandedSubtables.contains(this.getPath())
      });
    };

    SubTable.prototype.template = Templates.template('table-subtable');

    SubTable.prototype.renderChildren = function() {
      this.renderChildAt('.im-subtable-summary', new SubtableSummary({
        model: this.model,
        state: this.state
      }));
      return this.onChangeOpen();
    };

    SubTable.prototype.tableRendered = false;

    SubTable.prototype.renderTable = function(wrapper) {
      var inner, rows;
      rows = this.model.get('rows');
      if (this.tableRendered || (rows.length === 0)) {
        return this.tableRendered;
      }
      inner = new SubtableInner(_.extend({
        rows: rows
      }, _.pick(this, SubtableInner.prototype.parameters)));
      this.renderChild('inner', inner, wrapper);
      return this.tableRendered = true;
    };

    SubTable.prototype.buildHeaders = function() {
      var c, row;
      row = this.model.get('rows')[0];
      if (row == null) {
        return;
      }
      return this.headers.set((function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = row.length; _i < _len; _i++) {
          c = row[_i];
          _results.push(new PathModel(c.get('column')));
        }
        return _results;
      })());
    };

    return SubTable;

  })(CoreView);

}).call(this);
