(function() {
  var Messages, Promise, TypeValueControls, View, asOption, fs, helpers, html, toNamedPath, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  _ = require('underscore');

  

  Promise = require('es6-promise').Promise;

  Messages = require('../messages');

  View = require('../core-view');

  Messages.set({
    'typeconstraints.BadType': "<%- type %> is not a legal value for this constraint. Choose another from the list.",
    'typeconstraints.OneClass': "<%- name %> is the only legal value this constraint can have. You can always remove it though."
  });

  toNamedPath = require('../utils/to-named-path');

  helpers = require('../templates/helpers');

  html = "<label class=\"span4\">\n    <%- messages.getText('conbuilder.IsA') %>\n</label>\n<% if (subclasses.length == 1) { %>\n  <select disabled class=\"form-control\">\n      <option><%- subclasses[0].text %></option>\n  </select>\n<% } else { %>\n  <%= select(subclasses, isSelected, 'form-control im-value-type') %>\n<% } %>\n  \n";

  asOption = function(_arg) {
    var name, path;
    path = _arg.path, name = _arg.name;
    return {
      value: path,
      text: name
    };
  };

  module.exports = TypeValueControls = (function(_super) {
    __extends(TypeValueControls, _super);

    function TypeValueControls() {
      return TypeValueControls.__super__.constructor.apply(this, arguments);
    }

    TypeValueControls.prototype.parameters = ['query', 'model'];

    TypeValueControls.prototype.initialize = function() {
      TypeValueControls.__super__.initialize.apply(this, arguments);
      this.model.swap('type', (function(_this) {
        return function(t) {
          return t != null ? t : _this.model.get('path').getType().name;
        };
      })(this));
      this.listenTo(Messages, 'change', this.reRender);
      this.listenTo(this.state, 'change:subclasses', this.reRender);
      return this.setSubclasses();
    };

    TypeValueControls.prototype.getData = function() {
      var data, sc, type;
      type = this.model.get('type');
      return data = {
        select: helpers.select,
        messages: Messages,
        subclasses: (function() {
          var _i, _len, _ref, _ref1, _results;
          _ref1 = (_ref = this.state.get('subclasses')) != null ? _ref : [];
          _results = [];
          for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
            sc = _ref1[_i];
            _results.push(asOption(sc));
          }
          return _results;
        }).call(this),
        isSelected: function(opt) {
          return type === opt.value;
        }
      };
    };

    TypeValueControls.prototype.events = function() {
      return {
        'change .im-value-type': 'setType'
      };
    };

    TypeValueControls.prototype.setType = function() {
      return this.model.set({
        type: this.$('.im-value-type').val()
      });
    };

    TypeValueControls.prototype.template = _.template(html);

    TypeValueControls.prototype.setSubclasses = function() {
      if (!this.model.has('subclasses')) {
        return this.getPossibleTypes().then((function(_this) {
          return function(subclasses) {
            var msg;
            if (subclasses.length === 1) {
              msg = Messages.getText('typeconstraints.OneClass', subclasses[0]);
              _this.model.set({
                error: {
                  message: msg,
                  level: 'warning'
                }
              });
            }
            return _this.state.set({
              subclasses: subclasses
            });
          };
        })(this));
      }
    };

    TypeValueControls.prototype.getPossibleTypes = function() {
      var baseType, path, paths, promises, schema, subclasses, subtypes, t, type, _ref;
      _ref = this.model.toJSON(), path = _ref.path, type = _ref.type;
      subclasses = this.query.getSubclasses();
      schema = this.query.model;
      delete subclasses[path];
      baseType = schema.getPathInfo(path.toString(), subclasses).getType();
      subtypes = (function() {
        var _i, _len, _ref1, _results;
        _ref1 = schema.getSubclassesOf(baseType);
        _results = [];
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          t = _ref1[_i];
          if (t !== baseType.name) {
            _results.push(t);
          }
        }
        return _results;
      })();
      paths = (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = subtypes.length; _i < _len; _i++) {
          t = subtypes[_i];
          _results.push(schema.makePath(t));
        }
        return _results;
      })();
      promises = paths.map(toNamedPath);
      if (__indexOf.call(subtypes, type) < 0) {
        this.model.set({
          error: new Error(Messages.getText('typeconstraints.BadType', this.model.toJSON()))
        });
        promises.push(Promise.resolve({
          path: type,
          name: this.model.get('typeName')
        }));
      }
      return Promise.all(promises);
    };

    return TypeValueControls;

  })(View);

}).call(this);
