(function() {
  var ClassSet, CoreView, QueryProperty, Templates, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  CoreView = require('../../core-view');

  Templates = require('../../templates');

  ClassSet = require('../../utils/css-class-set');

  module.exports = QueryProperty = (function(_super) {
    __extends(QueryProperty, _super);

    function QueryProperty() {
      return QueryProperty.__super__.constructor.apply(this, arguments);
    }

    QueryProperty.prototype.template = Templates.template('undo-history-step-section');

    QueryProperty.prototype.labelContent = function() {
      throw new Error('NOT IMPLEMENTED');
    };

    QueryProperty.prototype.summaryLabel = function() {
      return thow(new Error('NOT IMPLEMENTED'));
    };

    QueryProperty.prototype.initState = function() {
      return this.state.set({
        open: false
      });
    };

    QueryProperty.prototype.initialize = function() {
      QueryProperty.__super__.initialize.apply(this, arguments);
      return this.collectionClasses = new ClassSet({
        'well well-sm': true,
        'im-hidden': (function(_this) {
          return function() {
            return !_this.state.get('open');
          };
        })(this)
      });
    };

    QueryProperty.prototype.getData = function() {
      var count, summaryLabel;
      summaryLabel = _.result(this, 'summaryLabel');
      count = this.collection.where({
        removed: false
      }).length;
      return _.extend(QueryProperty.__super__.getData.apply(this, arguments), {
        count: count,
        summaryLabel: summaryLabel,
        labelContent: this.labelContent,
        collectionClasses: this.collectionClasses
      });
    };

    QueryProperty.prototype.events = function() {
      return {
        'click .im-section-summary': 'toggleOpen'
      };
    };

    QueryProperty.prototype.stateEvents = function() {
      return {
        'change:open': this.reRender
      };
    };

    QueryProperty.prototype.collectionEvents = function() {
      return {
        'change': this.reRender
      };
    };

    QueryProperty.prototype.toggleOpen = function(e) {
      e.stopPropagation();
      e.preventDefault();
      return this.state.toggle('open');
    };

    return QueryProperty;

  })(CoreView);

}).call(this);
